

!      	Look for the mods 

! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix			
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	


!  ************************************************************************* 
!
!  POLAN.F90                        F90 version -- Created: 9/05/03                       
!  Author : JOHN TITHERIDGE         Copyright(c) University of Auckland 2000              
!  Last change: jet 30/07/03 14:17:15                                                     
!  ************************************************************************* 
             
      SUBROUTINE POLAN (Fin,Hin, Fout,Hout,Nout, Config, QP, Fx,Hx, Herr)
                            
      REAL, intent(in) :: Fin(*), Hin(*)                     !Input: Freq, Height arrays     
      REAL, intent(out):: Fout(*),Hout(*)                    !Output Freq, Height arrays     
      REAL, optional, intent(in) ::  Config(4)           !Constants (or set in PolSetup)     
      REAL, optional, intent(in) :: Fx(*), Hx(*)                  !(Optional x-ray data)     
      REAL, optional, intent(out):: QP(*),Herr(2,*)   !Array for polynomial coefficients     
!                                                                                         
!  Generalised POLynomial real-height ANalysis, for ionograms.    May 1986.               
!  >>>>>>> PARAMETERS ARE DESCRIBED IN THE TEXT FILE  POLAN.TXT.    <<<<<<<               
!         (Please list this file, and keep it by you for reference.)
                      
!  MUST PRECEDE 1ST CALL TO POLAN with:  CALL POLSITE (FB, DIP [,Site, Config])
           
!NEW 2003 (F90):-   OPTIONAL input arrays QP, Field, Config; AND new Fx,Hx.               
!   Separate data arrays:  Fv,Hv= Virtual(kv),  Fr,Hr= Real(kr), all in common /POL/.     
!   Field used is set in:  Field(2)= (/Fh, Dip/);  Fh(MHz) is at h=0; Dip in degrees.     
! Run Parameters set in: Config(4)= (/Start,Valley, aMode,aList/) {or set in PolSite)     
! CHANGE: FIXED START (prev 0<START<=45)  is now 10<= START <60 such that,                
!       for 0<=FS<5 MHz and HS= 90,100,110,..,180) km, use START = (HS - 70)/2 + FS.      
!   (START= 1, 2, 3, 4,..9  set different physical models for start, valley regions).     
!-CHANGES-----------------------------------------------------------------------          
! 12'95:  Data moved up 44 places (was 30) to ensure room for complex calcns.             
!      Mode 9 to NT= 6 (was 7).  Max NT= 14 (was 15, which sometimes distorted).          
!   POLSIN: Omit initial retarded points from ho calcn, for better O starts.              
!         Valley Width to SHA +7 = hm/4-13.   F1 use Width*2/3, Depth*0.5 (~0.07MHz).     
!  2'93  delete ndim;  1st call needs n = ndim.  (& ndim > #data+45; 12'95)               
!  3'88  MT +1 for physical equns, but slower increase with NX.                           
!  5'86  allow Dip= 0.         4'86 add NDIM and QQ,  add modes xyz (=F2/F1/E layer).     
!  PEAK revised aug,nov87,feb88;  2'93 merge chap/snglpoly, set curvature(fm)             
!-OUTPUTS-----------------------------------------------------------------------          
! Normal Outputs from Polan are commented !------->                                       
!        Trace & faults are **----->  ;   Fuller debug, at list > 0, are  ##----->        
!        Loops are delimited by  !.....                                                   
!-------------------------------------------------------------------------------          
      Include "polpars.pol"                 !Common /POL/= data arrays, params, counters     
      COMMON /site/FB,DIP, aLat,TLoc,aMon,aFlx, cstrt,cvaly,cmod,clst !Field; def params     
      INTEGER  IT(20),IV(20),IR(20),IH(20)                              !Mode parameters
     
      REAL  QQ(40), BS(99,17) ;  SAVE AMode, Start, Valley                  !BS to Solve     
!           |-------- first step --------|  |----- following steps ------|                
!At MODE =  1  2  3  4  5  6  7  8  9  10   1  2  3  4  5  6  7  8  9  10                 
      DATA IT /1, 2, 3, 4, 4, 5, 6, 6, 6, 73,  1, 2, 3, 4, 5, 6, 6, 6, 6, 73/ !polyterms     
      DATA IV /1, 2, 3, 4, 5, 7, 8,10,12, 90,  1, 1, 2, 3, 4, 5, 7, 8,13, 90/ !#virt hts     
      DATA IR /0, 0, 0, 1, 1, 2, 2, 3, 5,  2,  0,-1,-1, 1,-2,-3,-3,-4,-6, -3/ !#real hts     
      DATA IH /1, 1, 2, 3, 3, 4, 5, 6, 8, 28,  1, 1, 1, 1, 1, 1, 2, 2, 3, 28/ !#calcdhts     
      data JFin/0/, JCin/0/, JQin/0/ ;  Nout = 0                   !to flag usage errors 
        
        error_sqrt = "Error SQRT"		!! lfm_errors
        error_none = "Error None"		!! lfm_errors 

!c0 ---                       (0) SET-UP USING OPTIONAL CONFIG INPUTS                     
      if (FB==0.) then ; print*, '##Field  not set' ; RETURN ; endif   !CALL POLSITE 1ST     
      if (Present(Config)) then                                                              
            Start = Config(1)  ;  Valley= Config(2)                 !set given values     
            aMode = Config(3)  ;  aList = Config(4)  ;  endif                             
      if (cstrt/=0.) Start= cstrt ; if (cvaly/=0.) Valley= cvaly       !or use defaults,     
      if (cmod /=0.) aMode= cmod  ; if (cLst /=0.) aList = cLst        !given to POLSITE     
!                                                                                         
      if (Present(QP))  JQin = 1                           !flag to return poly coefs QP     
10    maxb= 98                     !=dimension of array B, -1.  Set IV(10)=IV(20)=maxb-8     
!                                                                                         
!c1 ---                       (1) INITIALISATION;  Data => internal Virt, Real arrays     
                 !                with Separate O data in Fin,Hin, & X data in Fx,Hx.     
      IF (Present(FX) .and.FX(1)>1.) THEN                  !Combine O, X data into Fv,Hv     
      GOTO 960                                               !==>> RETURNS TO 20 ==>>     
      ELSE                           !COPY GIVEN DATA from Fin,Hin to Fv,Hv, to analyse.     
      DO nv = 1, 396                                     !F,H to internal arrays [400]     
        Fv(4+nv) = Fin(nv) ;  Hv(4+nv) = Hin(nv)        !leaves space for 4 start pts 
      	

      	
      	
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix			
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	
      	
  
!LEO       if (Fin(nv)==0. .and. Hin(nv-1)==0.)  exit      !nv at 2nd zero = end of data 
      	
        if (Fin(1)==0. .and. Hin(1)==0.)  exit      ! Fix from JET 21 April 04
      	
! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	! mods by leo mcnamara, pending JET fix		
! mods by leo mcnamara, pending JET fix! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	
! mods by leo mcnamara, pending JET fix      ! mods by leo mcnamara, pending JET fix	! mods by leo mcnamara, pending JET fix		
      	

      	    
      END DO                                                                               
      END IF                                                                                 
20    List = int(aList) ;  TestL= aList - List               !TestL, TestM= decimal part     
      Mode = abs(AMode) ;  TestM= abs(AMode) - Mode          !(in 0.001-0.999) for tests     
!------                                                                                   
      Fv(1:4)= 0. ;  Hv(1:4)= 0.           ![O, X data processing, at end, returns here]     
      QQ( 1) = 1. ; QQ(2:40)= 0.           !Set number of poly coefficients, saved in QQ     
      Q(1:20)= 0.                                                                            
      JM = 0  ;   MT = 0  ;  ParHt= 0.                                    !for trace O/P     
      Fr(1:40)= 0. ;  Hr(1:40)= 0. ;  kr = 1                          !initialise output     
      kv = 5  ;   maxV = kv + nv -1                                !1st, last data index     
      NX = 0  ;   HVal= 0.                                           !start; novalley,..     
!!!   print *, nv,List ; stop                                                             
       if(List>1) write(2,28) nv,Fin(1),Hin(1), fb,dip,start, amode,valley,list           
              28  format ('#Args: N,f1,h1=',I4,F5.2,F6.1,'   fb,dip,start', &             
                         &  F6.2,2F6.1,'   mode,valy,list',F5.1,F6.2, I3 /)               
!         if(list>0) write(2,29) 'Input data', (Fv(i),Hv(i), i= 5,maxv)                   
              29  format (/, a,/ (f6.2,f6.1, 6(f8.2, f6.1)) )                             
!c1 ---                                                                                   
!c1.1                        Set trace, gyrofreq  and  mode  constants.                   
      aDiP= max( abs(Dip),.001)                                              !for dip= 0     
      Fh  = GIND(FB,-ADIP)                                                !set ground Fh     
      if (List >7)  List= -List                             !hold off tracing to peak     
      if (List >1)  call trace (0.)                   !to head trace output. ##----->     
      if (mode==0)  mode = 6 + int(adip/60.)*10       !mode 0 => def 6 (16 at dip>60)     
      Modb = 0                                                          !normal analysis     
      if (mode>29)  modb = mode/10                                 !single polynomial     
      moda = mode - modb*10                                              !first layer     
      Modc = 0                                                                               
      if (modb>29)  modc = modb/10                                         !top layer     
      modb = modb - modc*10                                                !mid layer     
      if (moda==0)  moda = modb                                                           
      if (modb==0)  modb = moda                                                           
      if (modc==0)  modc = modb                                                           
      Mod1 = moda - (moda/10)*10                                                             
      if (mode==10 .or. mode>29)  Mod1 = 10                           !single polynomial     
!-------------------------------------------------------------------------------          
!c1.2--  Real, Virtual height origins are at  kr = 1, kv = 5.                             
!     Returns with kv = 5-js, where js is the number of freqs added below fmin.           
! Set Fa,Ha = the origin (starting point) of the first real-height polynomial;            
! Set    Lk = 1 / 0 / -1   for   o-ray / polynomial / slab start.                         
!     Adds an interpolated point at Fv(kv-1),Hv(kv-1) to control o-ray starts.            
!                                Note kv > 5 if any retarded O points are deleted.        
      NV = IV(Mod1)                                          !virtuals used in 1st step     
      CALL  SETUP (START, NV, Fmin)                                                         
!                                                                                         
      DHS = MAX(HA-HS, 0.)                                                  !for !C3.3      
!===============================================================================          
!////////////   R E A L   H E I G H T   A N A L Y S I S   L O O P   \\\\\\\\\\\\          
!                                                                                         
! Calculate one polynomial, with NT terms, from the point fa=F(k), ha=H(k)                
!   to fit the next NV virtual and NR real hts.                                           
!                     (Include one real height below ha if NR is negative).               
!   Calculate a further NH real heights,  and set  k = k+NH.                              
!                                                                                         
!   If a critical frequency is found in k+1 to k+NV+1, calculate up to                    
!         the preceding freq, and determine a least-squares Chapman peak.                 
! With x-ray data (-ve freqs) at start or after critical, recalculate ha.                 
!                                                                                         
! Real height origin (fa,ha) is at k = kr, virtual at k = kv.  krm = top real.            
!-----------------------------------------------------------------------------            
!C2 ---                             (2) PREPARE  DATA                                     
!c2.1                               Start of analysis (or restart after a peak)           
200   Mod0 = Mod1                                                       !Mode = 1 to 10     
      krm = kr                                                       !top known real ht     
      NNR = 0                                                                               
      goto 230                                                                              
!c2.1a                              Later segments (using mod+10)                         
210   IF (Mod0<=10)  then                                       !Previous was 1st step;     
        kr = kr - IR(Mod0) *ScalDens                          !step back, by Prev NNR     
        kv = kv - IR(Mod0) *ScalDens                                                      
        Mod0 = Mod0 + 10                                      !Next steps use overlap     
      ENDIF                                                                               
      NNR = IR(Mod0)         !# real heights to fit (-ve if 1 is below FA; Mod>10 only)     
!c2.1b                              All segments - set # frequencies used                 
230     kp = kv                                                                           
        do while ( hv(kp+1) >50. )                                                        
           kp= kp + 1  ;  end do                            ! kp ==> last ht in layer     
      NV = IV(Mod0)                                           !# virtual heights to fit     
      km = min(kp,kv+nv) ; fT = fv(km)                            !top frequency in fit     
      ScalDens= 1.0                       !factor to increase #pts used in each section     
      IF (mod1<10 .and.fT>fmin) then                    !using overlaping polynomials:-     
        Fdens = NV / log10(fT/Fmin)                   !points per decade in this step     
        if (Fdens>18.) ScalDens= (Fdens/18.)**0.8     !increase points in polynomials     
      ENDIF                                                                               
             scaldens=1.0!!!!!!testing                                                    
      NT = nint(IT(Mod0) *ScalDens)                     !#  terms to use, in polynomial     
      NV = nint(IV(Mod0) *ScalDens)                     !# virtual heights to be fitted     
      NH = nint(IH(Mod0) *ScalDens)                     !# of new real hts to calculate     
      NR = nint(iabs(NNR)*ScalDens)                     !# known real hts, to be fitted     
      NL = 0 ; if(nnr<0) NL = nint(ScalDens)            !Fit 1 ht below FA,  if NNR -ve     
      MS = 0                                            !# of physical start eqns added     
       if (LK==1.and.kv==3 .and.aMode>=0.) MS = 1           !Add 1 gradient equation,     
       if (NV>1 .and.NV<8)  NV = NV - MS                    !at O start only (js = 2)     
         if (list==6)write(2,*)'POL2.1: mod,nr,nl,lk=', mod0,nr,nl,lk, &                  
                                  &  '  kr,kv,nh,nv,ms=', kr,kv,nh,nv,ms                  
          
!-------------------------------------------------------------------------------          
!c2.2                   Count initial x-rays. Check frequency sequencing.                 
!                       Check for cusp, peak, or end of data.                             
! Set NF= no of o-rays (=NV, if sufficient points exist before a peak/restart).           
!     NX= x-rays;   MV= NF+NX;   FM= Fv(mf) = top frequency in this step.                 
!     FCc = FC or 0.1 for a peak,  = -.1 for cusp at fm,  = 0. otherwise.                 
!                                                                                         
      CALL  SELDAT  (NV)                                                                    
                             tras= -2.2  ;  if (nv<0)  goto 730    !error exit--->>>>     
      FM = Fv(MF)                                                        !top frequency     
      MV = MF - kv                                                       !# frequencies     
      if (NF >NV)  NH = NH + (NF-NV)/2                                    !to calculate     
          if (fcc>0..and.List==-8) List = 8                                               
       if(List>2 .or.List==2.and.Mod0<11) call trace(2.2)   !trace headings  ##----->     
      IF (kr==1)  GOTO 300                                                       !start     
!-------------------------------------------------------------------------------          
!c2.3  Subtract the group retardation due to the last calculated real-height section.     
!  This modifies all h' at f > fa (where fa = Fr[kr] = Fv[kv]),  and increases            
!  the index LK (giving the height to which group retardation is removed) to kr.          
! 


!                                 Will set kv= kv+1, if an h' error is removed.

      error_text = error_none !! lfm_sqrt          
      CALL  REDUCE ()

        if(error_text.eq.error_sqrt) return !! lfm_sqrt
        
                                                                               
      MV = MF - kv                                            !in case kv was increased     
                             tras= -2.3 ; if (jm<=0) goto 740     !exit on error >>>>     
                             if (List >2) call trace (2.3)                  !##----->     
!===============================================================================          
!C3 ---                     (3) Set Up Equations for next profile step                    
!                                                                                         
!c3.1                                  Set number of terms (MT) and origin.               
300   MT = NT

      error_text = error_none !! lfm_sqrt                                                                        
      if (NT>20)  MT = nint(2.*sqrt_lfm(real(NF)))                      !#terms for mode 10
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
              
      if (LK<0 .or. HVal/=0.) MT = MT + 1                           !add physical equn.     
      if (NX>0)   MT = MT + NX/3                                              !+ X-rays     
      if (NF>NV)  MT = MT + (NF-NV)/3                !using extra freqs; fit more terms     
      IF (Mode>29)  then                                                                    
        MT = Moda                                                        != 1st layer     
        if (kr>1)  MT = Modb                                             != 2nd layer     
        if (Fv(MF+2)==0. .or. NF>=NV)  MT = Modc                         ! last layer     
      ENDIF                                                                               
      MT = min(14, MT, MV +NR +MS)                !max # fitted terms (MS= # phys eqns)     
      JM = MT                                                                               
      FA = Fr(kr)  ;   HA = Hr(kr)                                           !new start     
      NC = 0                                                              !# iterations     
!                                 CHECK for VALLEY, set valley flag HVal                  
!                                 Initialise valley width & depth.                        
!                                 Increase MT by 0-2, for physical equns (C3.3)           
      LOOP = 0                                                                              
      CALL STAVAL (STart, Valley, Loop)                                                     
      if (HVal/=0..and.aMode>=0.)  MT = MT + max( (9-MT)/3, 0 )                             
      IF (LK<=0 .or. HVAL/=0.)  JM = MT + 1           !Start or valley, q(mt+1)= offset     
                               if (List>3) Call Trace (3.1)                 !##----->     
!-------------------------------------------------------------------------------          
!c3.2                      Set Up MV Virt-Ht equations in B (Start,Valy iterate here)     
!c3.2                           (followed by NR Real-Ht equations, if not Start/Valy)     
330   CALL COEFIC (MV)                                                !set coefficients     
                 tras = -3.2  ;   if (jm<=0)  goto 740              !exit on error>>>     
      IF (AMode<0. .or. MV+4>MAXB)  goto 380                     !no physical equations     
      IF (MS==1) then                             !==== O Start, from kv= 3 (with Lk=1)     
       G = 1.0 + 1.8/FV(4)                           !Add gradient equation, at kv= 4     
       B(MV+1, 1)  = .5                              !follows MV virtual ht equations     
       B(MV+1,JM+1)= .5*G*(Hv(4)-HA)                 !JM = # unknowns; JM+1 is r.h.s.     
       B(MV+1,19)  = 1.                                                       !weight     
      ENDIF                                                                                
!c3.3                                    ADD PHYSICAL RELATIONS                           
      IF (LK<0)  then                         !Add MS physical start relations;  X only     
          WS = 0.1  ;  if (Start>44.) WS = 0.3                            !set weight     
          B(MV+1:MV+3, 19) = WS                                                           
       B(MV+1,JM)   = -1.                                                     !-q(jm)     
       B(MV+1,MT)   = .25                                                   !+q(mt)/4     
       B(MV+1,JM+1) = DHS *.25/FA**2                                          !=ha-hs     
       B(MV+2,MT)   = 0.3                                                      !q(mt)     
       B(MV+2,JM+1) =(HS/2.-40.) /FA**2 *0.3                                   !=slab     
       B(MV+3,MT-1) = 0.15                               !low order (last term=small)     
       MS = 3                                                                             
      ELSE IF (HVal/=0.) then                !Add MS physical valley relations; X or O     
          WV = 1.0                                                 !weight for O eqns     
          if (HVal<-2.)  WV = 10.                        !large weight =>fixed valley     
          if (NX>0)  WV = 0.2                            !use less weight with X data     
          B(MV+1, 19) = WV                                                                
          B(MV+2:MV+4,19) = 1.0                                                           
       B(MV+1,JM)   = 1.                                    !JM is total valley width     
       B(MV+1,JM+1) = VWidth - ParHt                        !R.H.S. = standard valley     
       B(MV+2,MT) = 0.5                                  !low order (last term=small)     
       B(MV+3,1)  = 0.4                                                  !gradient is     
       B(MV+3,JM) = -.1/VDepth                                           !-continuous     
       B(MV+4,MT-1) = 0.15                               !low order(2nd-last term=>0)     
       MS = min(4, MT)                                                                    
      ENDIF                                                                                
!                                                                                         
380   NC = NC+1                                       !iterations; count total # cycles     
        if(List>2 .or. (ms>0.and.List/=0)) Call Trace(3.3)                  !##----->     
!===============================================================================          
!C4 ---                            (4) REAL-HEIGHT SOLUTION      MS=# added phys eqns     
!c4.1                                  SOLVE equations in B.     JM = # unknown pars,     
      NS = min(MV+NR+MS, Maxb)                                    !NS = # eqns to solve     
          
      CALL  SOLVE (NS, JM,  B, Q, Devn, List)             !Solve NS eqns in JM unknowns     
                        tras = 4.1 ;  if (ns<jm) RETURN           !exit on error-->>>     
!                                                                                         
!c4.2                                  CHECK & adjust physical constraints                
!                                                       (incl peak curve 2'93)            
                    if (ms== 1) List= List+200                            !leave q(1)     
                    if (dip<0.) List= List+400                             !no adjust     
      CALL ADJUST (HA,FA, FM,FCC, LK,JM,MT, Q, List)                                        
!                                                                                         
!c4.3                                  ITERATE a valley or X-start calcn.                 
      LOOP = 2                                                                              
      IF (JM >MT .and.NX<=0)  then                                                          
       VWidth = Q(JM) + ParHt                !O-ray Valley; loop once to adjust depth     
       if (NC==1.and.HVAL/=0.)  LOOP = 1                               !adjust vdepth     
      ENDIF                                                                                
       if(List>1.and.hval/=0..or.List>2) Call Trace(4.3)                    !##----->     
!                                                                                         
      if (FB <0.)  Loop = -abs(Loop)                     !uses fixed Fh, don't iterate      
      if (JM >MT)  CALL STAVAL (STart,Valley, Loop)            !start/valley; adjust HA     
      if (LOOP==4)  goto 330                                               !valley loop     
      if (LOOP==3.and.FB>0.)  goto 330                                     !x-ray  loop     
!===============================================================================          
!C5 ---                             (5) Store Real Heights.  kv,kr point at FA,HA         
!c5.1                                        (NR= # real hts fitted, NL= # below FA.)     
      krm = kr +NR -NL                                          !last known real height     
      kvM = kv +NR -NL                                          !=>freq at last real ht     
      FL = Fv(kvM)                                              !  ,  for total content     
      NH = min(NH,NF-Mod1/10*2)                                 !# new hts to calculate     
      MQ = MT + min(Lk,0)                                           !# polynomial terms     
      DO K = Kvm + 1, MF                                      !set all unknown real hts     
       FRr = Fv(K)  ;  Deltf = FRr-FA                                                     
       krm = krm+1  ;  Fr(krm) = FRr                    !calculate all real heights..     
       Hr(krm) = HA + SUMVAL(MQ,Q,Deltf,1)              !from polynomial coefficients     
      END DO    ;    Hr(krm+1) = 0.                                    !(for security)     
!                                                                                         
!c5.2                                   SAVE Virtual Height ERRORS                        
      IF (Present(Herr)) THEN                   !calculate from 1st MV eqns in B, 18/7/03     
      DO j = 1, NH                            !store h' errors, at final calcd real hts     
       kvj = kvm -4 + j   ;  if(kvj<1) cycle                                              
       He = Dot_Product(B(j,1:mq),Q(1:mq))           !h' calcd from equation (l.h.s.)     
       Herr(1,kvj) = (He - B(j,jm+1))                           !h' error, unweighted     
       Herr(2,kvj) = B(j,18)                                    !frequency of jth eqn     
      END DO                                                                               
      ENDIF                                                                                   
!c5.3                                    Check Peak;  Store Total Content                 
      FN = Fv(kvm+NH)                                                                        
      IF (FCC/=0.)  THEN                                                                     
       NH = krm-kr ;  FN = FM ;  ENDIF                            !# heights to peak.     
!                                                                                         
      DO J = 1, MQ                               !Total Content for polynomial section     
       tcn = ( fa*(fa/j + 2.*(fn-fa)/(j+1)) + (fn-fa)**2/(j+2) ) *(fn-fa)**j!polycont     
       tcl = ( fa*(fa/j + 2.*(fl-fa)/(j+1)) + (fl-fa)**2/(j+2) ) *(fl-fa)**j              
       tcont = tcont + j*q(j)*(tcn -tcl)                     !add TCont from fl to fN     
      END DO                                                                               
      kr = kr + nh  ;  kv = kv + nh                                      !step on origin     
      if (FCC== 0.)  goto 210                                            !do next layer,     
      if (FCC==-.1)  goto 200                                           !or cusp restart     
!///////////////////////////////////// End  of  Normal  Steps ///////////////////////     
!C6 ---                            (6) CALCULATE and LIST PEAK DATA                       
!c6.1                               Store Coefficients of last polynomial in qq           
      FC = FCC                                                              !Layer Ends     
      numq = qq(1) + 4                                                                    
      DO j = numq-3, numq+mq                                                              
         if (qq(j)==-1.)  goto 620                                          !no store     
         if (j>=numq) qq(j)= q(j-numq+1)                   !store poly coefs q, in qq     
       END DO                                                                             
      qq(numq-3) = fa  ;  qq(numq-2) = ha                                                 
      qq(numq-1) = mq  ;  numq = numq + mq                                                
      qq(numq)= devn                                                                      
      if (fcc<0.)  numq = numq + 1                                                        
      if (fcc<0..and.qq(numq)/=-1.)  qq(numq)= fm                                         
      qq(1) = numq                                                                        
620   CONTINUE                                                                              
!c6.2                               Least-Squares Fitting of Chapman-layer Peak.          
            tras= 6.2 ; if (fcc<0.) goto 760                      !End on error--->>>     
                   if (Hr(krm)<70.) goto 740                      !Abort calcn --->>>     
      CALL  PEAKFIT (QQ)                                                                    
!-------------------------------------------------------------------------------          
!C7 ---                            (7)  RESTART for a New Layer,  or end.                 
!c7.1                                                                                     
           if (List/=-10) List= iabs(List) ; if (List==8) List= -8     !turn trace on     
      HS = (HMax + Hr(krm))/2.                                           !height for Fh     
      if (Hv(kv+1)>0.)  goto 200                                         !for new layer     
!                                                                                         
!c7.2                All finished.  Add points at z= 0.35, 0.85, 1.5  above peak,         
!                                        using a scale height gradient of 0.1.            
      N = kr + 3                                                !end of topside profile     
      Fr(N-2) = FC *.98642                        ![0.3=.98984, 0.4=.98257, 0.5=.97372]     
      Fr(N-1) = FC *.93300                        ![0.8=.93957, 0.9=.92622, 1.0=.91213]     
      Fr(N  ) = FC *.83462                                     !z = 1.5 is at FC*.83462     
      Hr(N-2) = HMax + SH *0.3565                 !z=.3+0044, .35+0065, .4+0081,.5+0128     
      Hr(N-1) = HMax + SH *0.8878                 !z=.8+0332, .85+0378, .9+0424, 1+0526     
      Hr(N  ) = HMax + SH *1.6216                 !last added point, at z= 1.5 (+.1216)     
                                                !(Fr,Hr(n+1)= devf,devh from PEAKFIT)     
      Fr(N+2) = TCont*.124                                                    !  T.E.C.     
      Hr(N+2) = SH                                                            !scale ht     
      Fr(N+3) = 0.  ;  Hr(N+3) = 0.                                                         
      numq = QQ(1) + 1.                                                                     
      if (numq>1)  QQ(numq) = -99.                !end of calcd polynomial coefficients     
      goto 800                                    ! RETURN >>>>  >>>> END OF POLAN <<<<     
!====================================================================================     
!c7.3                                   E x i t   o n   E r r o r                         
720         if (FC ==-1.)  goto 760                                                       
730         if (nv<0)  kv = -nv -1                                        !for seldat     
740         if (List==-10) goto 760                                         !no lists     
                   write(2,750) (Fv(i),Hv(i), i= kv-1,kv+4), tras, kv       !**----->     
750        format('>>>>>error at f,h =',12f7.2,' section',f4.1,i5,'  >>>> end',/)            
                           Call Trace (tras)               !'tras'= section# **----->     
760         n = kr + 1                                                                    
            Fr(n) = Fv(kv+1)                                !add end points, and exit     
            Hr(n) = Hv(kv+1)                                                              
            Fr(n+1) = 0.  ;   Hr(n+1) = 0.                                                
            Fr(n+2) = 0.  ;   Hr(n+2) = 0.                   !2 zeros ==> end of data     
            numq = qq(1)+1                                     !-99. ==> end of coefs     
            if (numq>1 .and.qq(numq).ne.-99.) qq(numq)= -98.     !-98. ==> error flag     
!====================================================================================     
!C8 ---    EXIT and ENTRY.     ALL EXIT HERE,  and  SET DATA in output arrays             
800     Fout(1:N+2) = Fr(1:N+2)                                                           
        Hout(1:N+2) = Hr(1:N+2)                       !copy results to output arrays,     
        Nout = N                                          !index of top profile point
        if (JQin>0) QP(1:numq) = QQ(1:numq)           !return polynomial coefficients     
      RETURN                                                                              
!====================================================================================     
!C9 ---    GIVEN: SEPARATE X data in Fx,Hx;  O data in Fin,Hin;   COMBINE into Fv,Hv.     
960   nv = 5 ;  no = 1  ; nx = 1                       !Store data to start at Fv,Hv(5)     
      jco= 1 ;  fm = 0.                 !====(1) FIND Top Freq fm, in Next Layer.======     
      hFh = 0.47*abs(Fh)                                        !Fh/2, scaled to 120 km     
970   DO while (hv(jco)>0.)                                                                 
        jco = jco+1 ; END DO                            !jco = index of first zero ht     
      fm = fv(jco-1)  ; jco= jco + 1                      !top freq in layer; skip zero 
        
        error_text = error_none !! lfm_sqrt    
      fxm = hFh + sqrt_lfm(fm**2 + hFh**2) - 0.1              !fx for plasma freq just < fm
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
 
              
          if(Fh<0.) write (2,*) "start: jco, fm,fxm=", jco-1, fm,fxm         !!--->>>     
      DO i = nx, 199                                                                        
       fxi = fx(i)                    !====(2) COPY all X-Ray Data, at fx < fxm.=====     
         if (fxi>fxm) exit            !This X point is for the next layer. Not stored     
         if (fxi==0.) exit            !End of all X data (recheck =>zero). Not stored     
       fv(nv)=-fxi ;  hv(nv)= hx(i)                                                       
       nv = nv + 1                              !X point is stored; check next frequ.     
      END DO                                                                                
            if(Fh<0.) write (2,*) "end x: nv,nx,i,fxi=", nv, nx,i, fxi       !!--->>>     
      nx = i                                      !rechecks last X data, for next layer     
      DO i = no, 300                                                                        
       fvi = fin(i)                   !====(3) COPY all O-Ray Data, to Next Peak.====     
       fv(nv)= fvi ;  hv(nv)= hin(i)                                                      
       nv = nv + 1                                                                        
         if (fvi ==-1.)  goto 980                           !All Data ends  (no peak)     
         if (hin(i)==0.) exit                               !At peak, has been stored     
      END DO                                                                                
            if(Fh<0.) write (2,*) "end o: nv,no,i,fvi=", nv, no,i, fvi       !!--->>>     
      no = i + 1                                                !Next O Point, to check     
      if (hin(no)/=0.)  goto 970                                      !Check next layer     
      IF (fxi>fxm) then                                 !O data ends; store final fcx     
         fv(nv)= -fxi ;  hv(nv)= 0.                     !Remaining X point = last fcx     
         nv= nv + 1   ;  ENDIF                                                            
 980  fv(nv)= 0.  ;  hv(nv)= 0.                                            !terminate     
!   =========== END OF O, X DATA MINGLING (FHin + FHx ==> combined arrays FHv) ------     
!      write(2,9)'Reconstituted',(Fv(i),Hv(i),i=5,nv)      !list combined output data     
      GOTO 20                                                                                
      END     ! >>>>>>>>>>>>>>>>>>>>> E N D  O F  P O L A N <<<<<<<<<<<<<<<<<<<<<<<<<<<<     
!####################################################################################     
!POLSITE;-              CALL to SET FIELD,  and optional set of analysis constants        
!  Optional site constants are used to define the E-layer/Valley start model.             
!  Optional cFig defines default values of Mode, Start, Valley, List, for all calcns.     
      SUBROUTINE  POLSITE (aFB, aDIP, Site, cFig)                                            
      REAL, intent(in) :: aFB, aDIP                                   !MUST SET: FB, DIP     
      REAL, optional, intent(in) ::  Site(4), cFig(4)                                        
      COMMON /site/FB,DIP, aLat,TLoc,aMon,aFlx, cstrt,cvaly,cmod,clst !Field; def params     
      FB = aFB  ;  DIP = aDIP                                                                
      aLat = 0. ;  TLoc = 0. ;  aMon = 0. ;  aFlx= 0.                                        
      cmod = 0. ;  cstrt= 0. ;  cvaly= 0. ;  clst= 0.                                        
      if(Present(Site)) then                                                                 
      aLat = Site(1) ;  TLoc = Site(2)                                                    
      aMon = Site(3) ;  aFlx = Site(4) ;  endif                                           
      if(Present(cFig)) then                                 !non-zero values => default     
      cstrt= cFig(1)  ;  cvaly= cFig(2)                                                    
      cmod = cFig(3)  ;  cLst = cFig(4) ;  endif                                           
      RETURN ;  END !====================END OF POLSITE ================================     

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!  POLCOF.F90                     F90 version -- Created: 9/05/03                         
!  Author : JOHN TITHERIDGE       Copyright(c) University of Auckland 2000                
!  Last change: jet 30/07/03 16:59:16                                                     
!  ***********************************************************************                
!  POLCALC.F90  =  COEFIC,  REDUCE,  GIND, TRACE,  SQ.          jan77/may86/Jun2003       
!                  To calculate virtual heights, simultaneous equations,...               
      SUBROUTINE   COEFIC  (MV)                                                           
!   Calculate coefficients  B(i,j),  for the real-height polynomial                       
!            h-ha = q(j)*(f-fa)**j;     MT terms,  fa=Fv(k),  ha=Hv(k).                   
!   The first MV rows of B give virtual height coefs at freqs k+1 to k+mv;                
!                               (these are savd to calc fit errors).                      
!       following NR rows give real height coefs at freqs k+1 to k+nr.                    
!   Adds terms for a linear section at X ray start or above peak.                         
!   Subtracts a parabolic segment (with s.h.=1.40*sh) above peak.                         
!                                                                                         
!   Called with MV -ve (from "reduce", in section 2.3) to reduce the next                 
!   |MV| virtual heights by the delay in the previous section fa to Fv(k).                
! 7'03: Equations to B() without weighting.  Weights in B(,19), Freqs B(,18), and         
!        then Errors =>B(,20).    Copy B() to BS(,1:17) to solve, adjust, etc.            
!------------------------------------------------------------------------------------     
      Include "polpars.pol"                                !Common arrays /POL/, etc.
       
      DIMENSION TR(17),W(17), GAUSS(17),FNR(17)                                           
      DATA TR  /  .046910077,.23076534, .50     ,.76923466,.95308992,  &  !5-pt Gauss     
     & .009219683,.047941372,.11504866,.20634102,.31608425,.43738330,  &  !12pt Gauss     
     &  .56261670,.68391575,.79365898, .88495134,.95205863,.99078032 /                    
      DATA  W  /  .11846344,.23931434, .28444444,.23931434,.11846344,  &                  
     &  .02358767,.05346966,.08003917, .10158371,.11674627,.12457352,  &                  
     &  .12457352,.11674627,.10158371, .08003917,.05346966,.02358767 /                    
      DATA  VB, FTC, GTC  /  0.6,  0., 180. /                                             
 1         format (a,15f8.2)                                                                   
!------------------------------------------------------------------------------------     
!cc1 ---                                                                                  
!cc1 ---                          (1).  Initialise                                        
      F1 = Fv(kv+1)                                                                       
      NFF = abs(MV)                                                         ! # freqs     
      km = kv + NFF  ;  FW = Fv(km+1)        !top virt; end point for tapered weights     
        IF (FW<1.)  FW = Fv(km)*2. - Fv(km-1)                               ! at fw=0     
      I = kv + min(NFF, max(Mod0-15,2)+NR)                                                
      DW = FW - Fv(I)                                                       !for wv=1     
      DA = Fv(kv+NR-NL) - FA                                                !for wv=1     
!                                      Gyrofrequency height                               
      Hrr= HA + 10.*min(1,kr-1)                                             !at start     
        IF (krm >kr)  Hrr= Hr(kr+1)                                     !for 1st freq     
        IF (krm==kr)  FTc = FA*1.2                                                        
        IF (HVal/=0.)  HS = HMax + VWidth/3.                                              
          IF (MV <0)  goto 10                                        !reduction cycle     
        IF (LK>=0 .or. krm==kr)  goto 6                                                   
!                                      Fh level, for slab start                           
      Deltf = 0.                                                                          
      grad2 = Q(1) - Gtc                                                                  
      IF (grad2>=0.)  THEN                                                  !abnormal     
2         grad1 = grad2                                                                   
          deltf = deltf + .1*fa                                                           
          grad2 = Sumval(mt-1,q,deltf,2) -gtc                                             
            if (grad2>0..and.deltf<fa*.45)  goto 2                    !increase deltf     
          deltf = deltf + .1*fa* amin1(grad2,0.) /(grad1-grad2)                           
        ENDIF                                                                             
      FTC = (FTC + FA + DELTF)*.5                                           ! average     
          
6     B(1:Maxb,:) = 0.                                                !Clear matrix B     
10    CONTINUE                                                                            
!====================================================================================     
!>>>>>>>>>>>>>>>>>>>>>>>>>>>  LOOP FREQUENCIES: i= 1 to nff normally,                     
!                                                = 0 to nff to fit 1 back height          
      I = 1 - NL                                                                          
        if (I==0.and.Mod0/=12)  I = -1                                      ! prev ht     
        if (MV<0)  I = 1                                                    !reducing     
!==============================================  LOOP FREQUENCIES:                        
20    IReal = NFF + NL + max(I,0)                                                         
      kvI = kv + I   ;   krI = kr + I                                                     
!cc2 ---                                                                                  
!cc2 ---                          (2).  Frequency and weight                              
      F  = Fv(kvI) ;  HVt = Hv(kvI)                                                       
        IF (krI<=krm) Hrr= Hr(krI)*.8 + Hr(kr+1)*.2                    !reflection ht     
        HFh = Hrr  ;  if (F1<0.)  HFh = HS                                                
      Fh = GIND(0.,HFh)                                              !set gyrofreq Fh     
      FR2 = F*F   ;   if (F<0.)  FR2 = F*(F+Fh)                              !(X ray)
        
        error_text = error_none !! lfm_sqrt      
      FRr= sqrt_lfm(FR2)                                       !plasma freq at reflection 
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
            
!                                      WEIGHTing for least squares analysis 
             
      WReal = 10.                                                                         
      if (kvI<kv)  WReal = 3.                                               !back ht.     
         IF (I<=0)   goto 60                                                !realonly     
                if (frr<=Fr(kr) .or. frr <=fc)    jm = -jm                                
                if (ParHt>2.*SH .or. nff+nr>Maxb) jm = -jm                  !fatal>>>     
                if(jm<=0) write(2,'(a8,6i3,9f7.2)')'coef2:',  &             !     >>>     
             &  i,kri,kvi,nr,mf,mv,hvt,f,frr,FC,fw,Fr(kr),Fv(km),ParHt      !     >>>     
                                   if (jm<=0)  return                       !  end>>>     
      WVirt = 1.                                                                          
        IF (MV<0)  goto 30                                            !reduction only     
      IF (F<0. .or. FW<=FRr) THEN                                                         
          WVirt = XWat                                                                    
        ELSE IF (NR>NL.and.FCC==0.) then
      	
      	  error_text = error_none !! lfm_sqrt                                                 
          WVirt = sqrt_lfm( min((FRr-FA)/DA, (FW-FRr)/DW) )               !taper weight
      	  if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	         
        END IF                                                                            
!                                      VARY WEIGHT with freq interval (O ray)   

!        print*," VARY WEIGHT with freq interval (O ray) "

          
      FVL = Fv(kvI-1)                                                                     
      IF (nx>0 .or. F<0. .or. FVL<0.)  goto 30                                            
          Deltf = (Fv(kvI+1) - FVL) /2.                                                   
            if (Deltf<0.)  Deltf = F - FVL 
      		
      	  error_text = error_none !! lfm_sqrt	                                               
          WVirt = WVirt *sqrt_lfm( 8.*abs(Deltf)/sqrt_lfm(F) ) 
      	  if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	                                     
!------------------------------------------------------------------------------------     
!                      Integrate from TB (at f=fa) to TA (=0 at reflection)               
!          17-point integrals are 5-pt to mid point TC, plus 12-pt from TC to TA          
!cc3 ---                                                                                  
!cc3 ---                          (3).  Set integration range
                             
30    error_text = "error_none" !! lfm_sqrt
        TB = SQ(FA/FRr)                                                    !lower limit
        if(error_text.eq.error_sqrt) RETURN
             
      TA = 0.                                                             !reflection     
      IF (MV >0) THEN                                                                     
         FTC = min(FTC, FA*.2 + FRr*.8)                                    !for X ray     
         TC = 0.39 -0.05/cos(.016*aDip)                                    !for 17 pt     
!                                       Set integration order inum                        
         inum = 5                                                     !default 5point     
         if (adip>=60.  .or. mode>=8)   inum = 12                     !12-point Gauss     
         if (adip>=80. .and.tb>1.2*TC)  inum = 17                     !use 5pt + 12pt     
         if (f1<0.) then                                              !x calculation,     
            inum = 17  
      		
      		error_text = "error_none"
      		TC = SQ(FTC/FRr) 
      		if(error_text.eq.error_sqrt) RETURN 

      		endif                                         
       ELSE                            !REDUCTION STEP, set upper limit FP                
         FP = Fr(kr)                            !2'93 added point below peak, so that     
           if (FP==FC) FP = Fr(kr-2)            !(kr-1 =>-2 with added ht)   end poly     
           if(fp>=FRr) write(2,1)'coef3',FC,fp,FRr                          !!##--->>
      	   
      	 error_text = "error_none"       
         TA = SQ(FP/FRr)
      	 if(error_text.eq.error_sqrt) RETURN 
      	                                                  !upper limit     
         inum= 5  ;  if (adip>73.and.ta<.3) inum= 12  !HiLat needs increased accuracy     
       ENDIF                                                                              
!                                                                                         
      ira = 1  ;  if (inum==12) ira = 6                        !1st Gauss coefficient     
      irb = ira + inum-1                                            !last coefficient     
        if (inum==17)  TA  = TC                                   !17-pt integral (a)     
      TD = TB - TA                                              !range of integration     
         !!      if(List==5)write(2,*)'FH,FA,FRr,FTC,TB=',FH,FA,FRr,FTC,TB                
!cc4 ---                                                                                  
!cc4 ---                          (4).  Retardation in start/peak section                 
      DePaR = 0.                                                            !peak sum     
      DeLiN = 0.                                                            !slab sum     
      IF (LK>=0 .and.ParHt==0.)  goto 48                                   !not valley    
         IF (SH/=0.)  DZ = .5*ParHt/SH                                      ! z at fm     
       DO ir = 6, 17                                                                      
          IF (lk >=0)  then                                              !linear only

      	     error_text = "error_none"    
             TP = SQ(FC/FRr*SQ(TR(ir)*DZ))
      		 if(error_text.eq.error_sqrt) RETURN
      		                                                 
             DePar= DePar + Gind(F,TP) *W(ir)             !delay in parabolic section     
             ENDIF
      		 
      	  error_text = "error_none"	                                                                         
          GindV = Gind(F, SQ((FA-TR(ir)*VDepth)/frR))
      	  if(error_text.eq.error_sqrt) RETURN
      	                                       
          DeLiN = DeLin + GindV*W(ir)                                   !linear delay     
       END DO                                                                             
               if(List==7)write(2,1)'coef4', fc,f, depar,delin,gindv        !##===>>>     
               if(List==9)write(2,1)'Fh,FRr,ftc,hFh,Hrr=',Fh,FRr,ftc,hFh,Hrr              
            if (ParHt>0.)  Fh = Gind (0., (HMax+VWidth)*.8 + Hrr*.2)                      
48        continue                                                                            
!cc5 ---                                                                                  
!cc5 ---                         (5).  Group index for polynomial terms                   
      DO 58 ir = ira, irb                                                                 
       IF (inum/=17 .or. IR/=6)  goto 55                                                  
          TD = TA                                                 !17-pt integral (b)     
          TA = 0.
      	  
      	  error_text = "error_none" !! lfm_sqrt                                                                         
          Fh = Gind(0.,Hrr)                                            !reflection Fh
      	  if(error_text.eq.error_sqrt) RETURN
      	       
          IF (F>0.)  goto 55                                               !not X ray     
             FR2 = F*(F+Fh) 
      		 
      		 error_text = "error_none" !! lfm_sqrt 
      		 FRr= sqrt_lfm(FR2)  !!!SET AT 77 ?????  !X-ray: refln FRr
      		 if(error_text.eq.error_sqrt) RETURN

      		 error_text = "error_none"     
             TD  = SQ(FTC/FRr)                                       !corresponding TC
      		 if(error_text.eq.error_sqrt) RETURN
      		     
   55  T  = TR(ir)*TD + TA                                                                
       FN = SQ(T)*FRr
         
         error_text = "error_none" !! lfm_sqrt                                                                     
       Gauss(ir) = Gind(F,T)*T*W(ir)/FN *TD*FR2
         if(error_text.eq.error_sqrt) RETURN
                                                    
       FNR(ir) = FN - FA                                                                  
  58  CONTINUE   
  
                                                                          
!------------------------------------------------------------------------------------     
!cc6 ---                          (6).  STORE Coefficients in array B                     
!                                                                                         
60        DO 90 J = 1, JM                                                                     
       RH = (FRr - FA)**J                                                !real ht sum     
          IF (kvI==kv .and. J==1)  RH = 1.                                !for mode 2     
       DPeak= 0.                                                                          
       Sumh = 0.                                                                          
          IF (I <=0)  goto 85                                              !real only     
          IF (J==JM)  DPeak = DePar*ParHt                             !parabolic peak     
       IF (J>=MT .and.(J/=MT .or. LK<0)) THEN                                             
                                               ! Start or Valley terms              .     
             RH = J - MT                                                                  
             if (J==MT)  Sumh = DeLin                                    !linear slab     
             if (LK >0)  Sumh = Gindv*VB+DeLin*(1.-VB)                   !linear valy     
       ELSE                                                                               
          DO IR = IRA, IRB                      ! Polynomial terms                   .    
             A = Gauss(IR) ;  Gauss(IR) = A*FNR(IR)                                       
             Sumh = Sumh + A                                                              
            END DO                                                                        
          Sumh = J*Sumh                                                        !delay     
       ENDIF                                                                              
             !!   if(List==5)write(2,*)'FH,FRr,TD,RH,sumh=',FH,FRr,TD,RH,sumh             
!                                       Coefficients B(i,j).                              
       B(I,J) = Sumh + RH                                                    !Virtual     
       if (MV <0) Hv(kvI) = Hv(kvI) - Q(J)*sign(SumH,HVt)-sign(DPeak,HVt)    ! reduce     
  85   if (IReal<=NFF+NR)  B(IReal,J) = RH                                   !   Real     
90        CONTINUE                                                                            
!                                                                                         
!d      if(List==5)write(2,*)'coef6', nff,i,ireal, f,frr,hvt,dpeak,wvirt ##-->>>          
      IF (MV<0)  goto 100                                                                 
!-----------------------------                                                            
!cc7 ---                          (7a)  STORE Virtual Height as r.h.s.                    
      IF (I >0) then                                                                      
        B(I,JM+1) = HVt -HA -DPeak                                    !Virtual r.h.s.     
           B(I,18) = F ;  B(I,19) = WVirt                       !save freq and weight     
           endif                                                                          
!cc7 ---                          (7b)  STORE  Real Height  as r.h.s.                     
      IF (IReal >NFF+NR)  goto 100                                                        
         dReal = Hr(kri) - HA                                                             
            if(Mod0==12) dReal = Q(1) + 2.*Q(2)*(FA-Fr(kr-1))           !fit gradient     
         B(iReal,JM+1) = dReal                                          !Real  r.h.s.     
         B(iReal,18) = Fr(kri) ;  B(iReal,19) = WReal           !save freq and weight     
100   I = max(I,0) + 1                                                                    
      IF (I<=NFF)  GOTO 20                                              !LOOP FREQUENCY   
!============================= End of frequency cycle ===============================     
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of COEFIC <<<<<<<<<<<<<<<<<<<   
!####################################################################################     
          
      SUBROUTINE   REDUCE  ()                                                   !Feb84.   
!   To reduce the remaining virtual heights by the group retardation in                   
!       the last calculated real-height section  (from  Fa  to  Fr(kr)).                  
!                                                                                         
!   Modifies all h' at  F > Fr(kr),  by subtracting the group retardation.                
!   Increases lk (the height to which group retardation is removed) to kr.                
!       Use  LIST = 7  to show details of the reduction steps.                            
!-------------------------------------------------------------------------------          
      Include "polpars.pol"                                !Common arrays /POL/, etc.     
   7  format (' reduce:',15f8.3)                                                          
!-------------------------------------------------------------------------------          
!c2.a--       Reduction using full polynomial expression (at f<fm+mode/25).               
      Fred = Fv(MF) + .04*real(MODE)                                                      
      K = MF                                     !mf = top freq in step (virtual, kv)     
20      K = K+1                                                             !nextvirt     
        if (abs(Hv(K))>40. .and.Fv(K)<=Fred)  goto 20                       !reduce k     
!---                                                                                      
      kv1 = kv+1                                                            !minreduc     
      kvM = min(K -1, kv+Maxb-NR)                                          !maxreduc      
                if(List==7)write(2,7) Fv(kv1:kvm)                           !##----->     
                if(List==7)write(2,7) Hv(kv1:kvm)                           !##----->     
      CALL COEFIC (kv-kvM)                                                  !prevpoly     
                if(List==7)write(2,7) Hv(kv1:kvm)                           !##----->     
                if (jm<=0)  return                                   !Error, exit>>>>     
!----------                            Error check on reduced virt hts.                   
      DO  k = kv1, kvm                                                                    
         if (abs(Hv(k))<ha)  goto 50                                        ! low ht.     
         END DO                                                                           
      goto 60                                                                             
!                                    list bad point (h'<ha) and delete it                 
   50         if(List>=-9) write(2,52) ha, (Fv(j),Hv(j), j=k-1,k+1)         !**----->     
   52      format ('*****Reduce: Error at ha=',f6.1,'; f,h=',6f8.3, i5,' end >>>>')       
   55    Fv(k)= Fv(k-1)                                                ! move up     
              Hv(k)= Hv(k-1)                                                              
              k= k-1                                                                      
              if (k>kv-4)  goto 55                                                        
              kv = kv1                                                                    
!-------------------------------------------------------------------------------          
!c2.b--       Approx reduction at f>fred for delay in Fr(Lk) (=fa) to Fr(kr)              
60    MQ = MT + min(LK,0)                                                  !polterms      
      LK = max(LK,1)+1                                                                    
      FAr = Fr(kr)                                                          !top freq     
      G2 = Q(1)                                                                           
!.....                            For section  Fr(L-1) to Fr(L)                           
      DO 100 L = LK,kr                                      !loop section (L=real index)  
!                                 :-  Get mean density, thickness                         
      FL = Fr(L-1)  ;  FN = Fr(L)                                                         
      AVN = (FL**2 + FN*(FL+FN)) /3.                                        !mean f*f     
      HA = Hr(L)    ;  DH = HA - Hr(L-1)                                                  
!                                 :-  Correct for curvature                               
      Deltf = FN - FA                                                                     
      G1 = G2                                                                             
      if (FN/=FC .and.FN>FA)  G2 = SUMVAL(MQ,Q,DELTF,2)                      != dh/df     
      if (FN==FC .or. FN<FA)  AVN = AVN+FN*(FN-FL)/3.                        !   peak     
      DH = DH + (G2-G1)*(FL+FN)*(FN-FL)**2/(12.*AVN)                      !correction     
      Fh = Gind(0., HA)                                                     !scale Fh     
!                                 :-  Loop frequency to end                               
      K = kvM                                                                             
!---                                                                                      
80    K = K+1                                                              !loop freq     
        F = Fv(K)                                                                         
        if (F==-1.)  Cycle                                                  !end freq     
        FRr = F                                                                           
        HVt = Hv(K)                                                    !(-ve at cusp)     
      IF (HVt==0. .and.Hv(K+1)==0.)  Cycle                                  !end freq     
            if (abs(hvt) <=40.)  goto 80                                   !skip peak     
            if (f<0. .and.f>-Fh)   goto 90                                !freq error 
      		
      		error_text = error_none !! lfm_sqrt    
            if (f<0.)  FRr= sqrt_lfm((f+Fh)*f)
      		if(error_text.eq.error_sqrt) RETURN
      		
      					                                !f at refln     
                   if (frr <Far)   goto 90                                !freq error
      			   
        error_text = error_none !! lfm_sqrt			        
      TAV = sqrt_lfm(1.-AVN/FRr**2)
        if(error_text.eq.error_sqrt) RETURN
        	                                                             
      Hv(K) = HVt - Gind(F,TAV)*DH *sign(1.,HVt)                           !reduce h'     
              if(List==7) write(2,7) fl,fn,tav,dh, f,hvt,Hv(k)              !##----->     
      goto 80                                                         !loop frequency     
!---                        END FREQUENCY LOOP.   Delete bad data and end                 
90            if(List>=-9)write(2,52) ha, (Fv(j),Hv(j), j=k-1,k+1),k        !*******>     
              Fv(k) = -1.                                                   !end data     
!---                                                                                      
100        CONTINUE                                                                            
!.....         End loop section                                                           
      LK = kr                                                                             
      RETURN ;  END              !>>>>>>>>>>>>>>>> END of REDUCE <<<<<<<<<<<<<<<<<<<<<    
!####################################################################################     
          
      FUNCTION  GIND (F, T)                                                               
!*****************************************************************jan77.                  
!  Group index subroutine, for o or x rays.      (f negative for x ray).                  
!  Gives (group index -1) to full machine accuracy,  for any value of t.                  
! Initialise by  call gind(GH,-dip) to set gyrofreq (MHz) and dip (deg).                  
! GH is ground value;  scaled to height h by  Fh = gind(0.,h), with h>2.                  
!       An initial negative value of GH suppresses the scaling.                           
!----------------------------------------------------------------------- 


      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT

                 
      SAVE  GH,GHSN,GCSCT, Fh,FhSN,FCSCT,HFh, C,CC2                                       
      data ibug / 0 / 
        
        error_text="          "   
        
!                                                                                         
         IF (F==0.)  goto 2                          !scale Fh constants to height= T     
         IF (T <0.)  goto 1                             !set Fh, Dip values at ground     
         T2 = MAX(T, .1E-9)**2                                   !to cope with tiny T     
         goto 5                                                                           
!                              STORE ground constants                                     
1     Gh = F    ;  Fh = abs(Gh)                                                           
      Dip = max(-.01745329*T, .001)                          !so can use dip (=t) = 0     
      Ghsn = Gh*sin(Dip)  ;   Gcsct= (Gh*cos(Dip))**2*.5/Ghsn                             
      goto 3                                                                              
!                              SCALE constants to height  h  =  T.                        
2     if (gh<0. .or. T<2.) goto 4                                     !don't alter Fh     
               if(ibug==1) write (2,*) 'Gind Fh to ht=',T                                 
      Fh = Gh/(1. + T/6371.2)**3                                   !Fh to height T km     
3     Fhsn = Ghsn*Fh/Gh   ;   Fcsct= Gcsct*Fh/Gh                                          
      hFh = .5*Fhsn       ;   c = Fcsct + Fhsn    ;   cc2= c*c                            
4     GIND = Fh                                                                           
      RETURN                                                                              
!                              CALCULATE group index  gind  =  mu' - 1.                   
!                              f < 0. sections increase accuracy for x ray.               
5     IF (F <0.) then                                                                     
          x  = (f + Fh)*T2                                                 !for X ray     
          g1 = x - Fh                                                                     
        ELSE                                                                              
          g1 = F*T2                                                            !O ray     
        ENDIF                                                                             
      g2 = Fcsct/g1      
        
        error_text = "error_none" !! lfm_sqrt
        g3 = sqrt_lfm(g2*g2 + 1.)
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
                                               
      IF (F <0.) then                                                                     
          g4 = Fhsn*(g3 - g2)                                                             
          x  = x*(g1 - fh)                                                 !for X ray 
      	  
      	  error_text = "error_none" !! lfm_sqrt    
          g5 = -g4*x /(Fhsn*( sqrt_lfm(x + cc2) + c ))
      	  if(error_text.eq.error_sqrt) return !! lfm_sqrt
                                         
        ELSE                                                                              
          g4 = Fhsn/(g2 + g3)                                                  !O ray     
          g5 = g1 + g4                                                                    
        ENDIF                                                                             
9     g6 = F + g4                                                                         
      g7 = (F*g2*g4/g1 - hFh) *(F - g1)/(g3*g6)
        
        error_text = "error_none" !! lfm_sqrt                                           
      GIND = abs(g7 + g6)/sqrt_lfm(g5*g6) - 1.
        if(error_text.eq.error_sqrt) return !! lfm_sqrt

                                                
      RETURN  ;  END            !>>>>>>>>>>>>>>>>>>> END of GIND <<<<<<<<<<<<<<<<<<<<     
!####################################################################################     
          
      SUBROUTINE  TRACE ( TRAS )                                                          
!************************************************************************jan'79.          
!          Debug listing,  produced when  0 < List < 10.                                  
!  (List = 1 gives a single trace line for each real-height step, in ADJUST.)             
!  List > 3 adds intermediate listings of freq,height  (& Q,devn, in ADJUST).             
!                                                                                         
      Include "polpars.pol"                                  !Common arrays /POL/, etc.   
!-----------------------------------------------------------------------                  
      IF (iabs(List)>9)  RETURN                                            !no listings   
      IF (tras==0.)  THEN                                                                 
        write(2,9) 'FRQ', Fv(kv: min(kv+14,maxv))        !first call, show input data     
        write(2,9) 'HTS', Hv(kv: min(kv+14,maxv))                                         
      9 format (' #',a3, 16f8.2/ (5x,16f8.2))                                             
        RETURN  ;  ENDIF                                                                  
!-----------------------------------------------------------------------                  
      IF (TRAS==2.2) write(2,15)                                 !head trace parameters   
   15  format('---------------------------------------------------------' &               
             &  /'#TRACE:  kr  lk jm mt    ha     fa   frm    fm',  &                     
             &   '   kv  nf  nr nl nx ms mode mod   hs' ,        &                        
             &   '    fc   fcc    sh  ParHt  hval vwide vdeep' )                          
      FRM = Fr(krm) ;  FM = Fv(MF)                                                        
       write(2,25) Tras, kr,lk, jm,mt, Ha,Fa,Frm,Fm, kv,nf,nr, nl,nx,ms, &                
                   &  Mode,Mod0, Hs, Fc,Fcc,Sh, ParHt,HVal,VWidth,VDepth                  
   25  format('#=',f4.1,':',2i4, 2i3, f8.2,3f6.2, 3i4,  3i3, 2i4, 1x,8f6.2)               
       km = kv +NF +NX                                                                    
      IF (List>3 .and. abs(tras-3.3)==1.)  THEN            !at List>3 & tras=2.3 OR 4.3   
       write(2,9) 'FRQ', Fv(kv:km)                                 !show current data     
       write(2,9) 'VHT', Hv(kv: min(km+3,maxv))                                           
       write(2,9) 'RHT', Hr(kr:krm)                                                       
      ENDIF                                                                               
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of TRACE <<<<<<<<<<<<<<<<<<<<   
!####################################################################################     
          
      FUNCTION  SQ(x)  ![more accurate than sqrt(1. - X*X), for X near 1]

      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT


           error_text = "error_none" !! lfm_sqrt                
         SQ =  sqrt_lfm((1.-x)*(1.+x))
      	 if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	                                                         
      RETURN ;  END                                                                       

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!  POLSIN.F90                       F90 version -- Created: 9/05/03                       
!  Author : JOHn TITHERIDGE         Copyright(c) University of Auckland 2000              
!  Last change: jet 30/07/03 14:37:44                                                     
!  ***********************************************************************                
!  POLSET.FOR  =  SETUP,  SELDAT,  STAVAL.  -  Setup & Start routines for Polan.          
!                                                                                         
      SUBROUTINE   SETUP  (START, NV, Fmin)                                               
!-----------------------  (Called once only, from section C1.2 of polan, with kv = 5)     
! 1. Set  fmin =  the lowest plasma frequency in the data.                                
!         hmin =  the lowest virtual height in the data.                                  
!         (these are used for start extrapolation in the absence of x-ray data).          
! 2. Identify the start method, and set the following parameters:                         
!      js = the number of points added below fmin, =2/1/0 for Oray/Xray/direct start.     
!      fa, ha  define the starting point for the first polynomial.                        
!      hs =  the height to evaluate the gyrofrequency for an x-ray start.                 
!      lk = 1 / 0 / -1   for   o-ray / x-ray poly / x-ray slab   starts.                  
! 3. Real, Virtual height origins at  kr = 1, kv = 5-js [kv is incrd if data deleted]     
!      where js is the number of freqs added below fmin.                                  
!                [NV = number of virtual hts to fit; used to check for valid X data.]     
!------------------------------------------------------------------------------------     
!Constants which SETUP sets in /pol/ are:-  lk,kv, fa,ha, hs,vdepth,vwidth.               
      Include "polpars.pol"                                  !Common arrays /POL/, etc.     
 9    Format (a,2i3,a,7f7.2)                                                                
      SH = 0.     ;  Fc = 0.                                                                
      TCONT = 0.  ;  VDepth= 0.  ;  VWidth= 0.                                              
!c1.a --                    Virtual Data  starts at  Fv(kv), Hv(kv)  [kv = 5]             
!c1.a --                    Find index jov of the 1st o ray; fmin= lowest Fn              
      do jov = kv, 99                                     !virt ht data starts at kv= 5     
       if (Fv(jov)>0.)  goto 12                               !first O data frequency     
      end do
        no_O_data = 1	!! leo mcnamara insert                                                                              
      print *, 'No O Data ???' ;  Fmin= 0. ;  return          !Return on ERROR ##===>     
12    Fmin = Fv(jov)                                            !jov => first Oray used     
      IF (jov>kv)  THEN                 !==== X rays scaled; check in useful range ====     
       FT  = max(Fv(kv+NV+NV/2), Fmin+0.5)           !Maximum fN for useful X data---
         
         error_text = "error_none" !! lfm_sqrt      
       fxN = sqrt_lfm(Fv(kv)*(Fv(kv)+.9*Fh))             !Fn at first X point [Fv is -ve]
         if(error_text.eq.error_sqrt) return !! lfm_sqrt
              
       if (fxN > FT) then                            !X freq too high, >> top O point     
          kv = jov  ;   end if                       !incr kv, to omit initial X data     
       Fmin = amin1(Fmin,FxN)                        !lowest plasma freq for 1st step     
      END IF                                                                                
!c1.b --                    Calculate INITIAL FA, HA (Direct start from fmin)             
      Hmin = Hv(jov) ;  Hav = Hmin                               !Fmin, Hmin= 1st O ray     
      DO i = jov+1, jov+5                                        !get least of 1st 6 Hv     
       if (Hv(i)<45.) goto 20                                        !this layer ends     
       Hav =  Hav + Hv(i)                                   !=> average of initial hv     
       Hmin = amin1(Hmin, Hv(i))                            !h'min= least of 1st 6 hv     
      END DO                                                                              
20    HA = Hmin ;  FA = Fmin ;  HS = HA                             !set origin (FA,HA)     
      JS = 0    ;  LK = 1    ;  Hav = Hav / (i - jov)                                       
           if(list==6)write(2,9)'SetUp kv,jov',kv,jov,' FA,HA,Hav=',FA,HA,Hav  !--->>     
      IF (STart<0. .and.STart>=-1. .and.jov==kv) GOTO 40     !direct start, O data only     
!                                                                                         
                                         !(Check for initial retarded O points 12'95)     
        if (Hv(jov+1)==0.) goto 30                                  !only one point!!
      	
      	error_text = "error_none" !! lfm_sqrt      
        hminav = sqrt_lfm(Hmin*Hav)                          ![better for digital data ?]
      	if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	     
        h1max= min(Hminav+40., Hv(jov+1)+200*(Fv(jov+1)-Fmin) )                           
        IF (jov==kv .and.Hv(kv)>h1max .and.i>4) then     !O ray only; 1st pt retarded     
           kv = kv+1 ; jov = kv                          !increase kv, to omit 1st pt     
           goto 12                                                                        
         ENDIF                                                                            
!c1.c --                    Set STARTING CONDITIONS  (direct, extrapolated or model).     
                                                ! - start extrapn: -----------------!     
 30   JS = 2  ;  F3 = Fv(jov+2) ;  H3 = Hv(jov+2)                         !add 2 points     
      IF (F3>0. .and.H3>0.)  then                               !3 O-rays exist, so....     
        DH = abs(H3-Hv(jov)) *Fmin /(F3-Fmin)                 !extrapolate h' to f= 0     
      ELSE ;  DH = Hv(jov)/6.  ;  endif                                                   
      HS = amin1(Hmin-DH, Hmin/2.+50.)                                        !start Fh     
      HS = amax1(HS, Hmin/4.+55.)                                          !lower limit     
      FA = amin1(.5, .6*Fmin)                                                               
                                                ! - model  height: -----------------!     
      IF (abs(Start)>=60.) HS = amin1( abs(Start), HS*.4+Hmin*.6 )  !model start height     
      IF (jov==kv)  THEN                                     !this will be O start only     
       HA = HS                                                       !starting height     
       if (Mode ==10 .or. Mode>=20)  FA = Fmin*.6                  !single polynomial     
       if (Start>=60. .or.STart==0.) goto 40                          !normal O start     
                                                ! - model density: -----------------!     
          h = int(Start*.1)*10                                                            
          HA = 90. +2.*h  ;  FA = STart - h                           !model=> FA, HA     
      ELSE                                        ! - X-ray calculation: -------------!     
       Lk = 0   ;   js = 1                                               !add 1 point     
       HA = HS*.4 + Hmin*.6                                              !X-ray start     
          if (Start >-3.)  FA = -STart - 1.                 !polynomial start, set FA     
          if (Start <-1.)  goto 40                          !X ray,  polynomial start     
       Lk =-1  ;  FA = Fmin*.6  ;  VDepth = FA*.5           !parametrs for X ray slab     
      ENDIF                                                                                 
!c1.d               Store initial points.  Virtual Height data starts at index kv.        
!c1.d --                                   [or kv increased by # of deleted O data]       
40    ko = kv-1   ;   kv = kv - js                   !kv = 3-5 (larger if data omitted)     
      Fv(ko)= (FA + Fmin)/2.0                        !added h', to stabilise an O start     
      Hv(ko)= HS + (Hmin-HS)*FV(ko)/Fmin             !interpolatd (overwritten at js=1)     
      Fv(kv)= FA  ;   Hv(kv)= HA                     !Analysis starts at F,H(kv)= FA,HA     
      Fr(1) = FA  ;   Hr(1) = HA                     !Calculated profile starts at kr=1     
            if (jov==ko+1)  hs= Hv(ko)                        !(to show added height) 
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of SETUP <<<<<<<<<<<<<<<<<<<<     
!####################################################################################     
          
      SUBROUTINE  SELDAT  (NV)                      !Called from section c2.2 of POLAN.     
!     Select the NV virtual-height data to be used in the next step of POLAN.             
!     Define the following parameters:-                                                   
!  NF = number of O-ray data points to be used                                            
!       (equal to NV, if sufficient good points exist before a peak/restart);             
!  NX = number of X-rays points;   [kv is increased if initial X data are deleted.]       
!  fm = Fv(mf) = highest frequency included in this step;                                 
!  fcc is set equal to zero for a normal (non-peak) step;  -.1 for  a cusp at fm;         
!             equal to a scaled critical frequency  (fc),  or to 0.1, for a peak.         
!-------------------------------------------------------------------------------          
      Include "polpars.pol"                                  !Common arrays /POL/, etc.     
!                                                                                         
!   ffit = minimum desirable frequency range, for fitting x-ray data.                     
!   gfit = maximum slope  dh'/df  which should be used in an x-start.                     
      data   ffit,  gfit    /  0.411, 40.1 /                                              
!-------------------------------------------------------------------------------          
!c2.a                   Count initial x rays. Check frequency sequencing.                 
!c2.a                   Check for cusp, peak, or end of data.   kv => Fa,Ha               
5     FCc= 0.  ;  Fh = GIND(0., Hr(kr))                          !no peak; set gyrofreq     
      FS = Fv(kv)                                            !start freqncy (FA, O ray)     
      FSx= 0.  ;  FTx= 0.                                    !first, last X frequencies     
      F1 = 0.  ;  Mf = kv                                    !first, last O frequencies     
      Nf = 0   ;  idx= 0                             !count O frequencies; X data shift     
  9   format('Seldat',5i3,4f7.2)                                                            
      if(List==6.and.kr==1)write(2,*)'      nv kv nf mf nx    f1     fs     fm'  !##-->     
!.....                              Frequency loop  (nf = 1 to nv):                       
10    Nf = Nf+1                                                                             
15     Mf = Mf+1                                         !Next freq, =>top point used     
       Fm = Fv(Mf)  ; HVt= Hv(Mf)                        !top frequency, height at Mf     
       Fn = Fv(Mf+1)                                            !next frequency; Mf+1     
       IF (Fm<FS) THEN                                   !====X-ray point (or error):
         
            error_text = "error_none" !! lfm_sqrt  
          FTx = sqrt_lfm(Fm*(Fm+Fh))                                 != Fn for Top X ray.
      	  if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	       
            if (Mf==kv+1) FSx =FTx                               !Fn for Start X ray.     
          IF (Fm<0. .and.FTx >=FsX .and.Nf==1)  goto 15      !valid X ray; check next     
                 goto 120                                        !Return on Error-->>     
       END IF                                                                             
         if (F1==0.)  F1 = Fm                                 !first fitted frequency     
         IF (HVt<0. .or. Fn<0.)   goto 40                                  !cusp, end     
         IF (abs(Hv(Mf+1))<=50.)  goto 50                                  !peak, end     
       Fs = Fm                                                                            
                 if (Fn<=Fm)  goto 120                          !Return on Error-->>      
      IF (Nf+1<Nv.and.Mf-kv<maxb-8)  goto 10                            !add next point     
       Grad = (Hv(Mf+1)-HVt) / (Fn-Fm)                              !check last point     
      IF (Nf+1==Nv .and.(Nf<=2 .or. kr>1 .or. Grad<100.)) goto 10       !add last point     
!.....                        Leave loop, with nf = no of O rays (<= total number nv)     
!                                                                                         
                 if(List==6.and.kr==1)write(2,9)nv,kv,nf,mf,nx, f1,fs,fm    !##----->     
!c2.b                                                                                     
!c2.b                       CHECK need for additional points.                             
      IF (Mod0>10 .or. Mod0<4)   goto 70                                 !end frequency     
       IF (Hv(Mf+1)-HVt>(Fn-Fm)*Gfit) goto 70                         !retarded point     
       IF (FTx>FSx  .and. Fm>FTx)     goto 70                      !all x data are in     
       IF (Fm-F1+.04*(nf-nv)<Ffit  .or. Fm<FSx)  goto 10          !increase fit range     
      goto 70                                                                              
!                                 CUSP  (fcc =-0.1) or end data                           
40     FCc = min(Fn, -.1)                                              !discontinuous     
       Hv(Mf)= abs(HVt)                                               !(-HVt at cusp)     
      goto 70                                                                              
!                                 PEAK  (fcc = 0.1  or scaled fc)                         
50     FCc = max(Fn,0.1)                                      !critical freq (or 0.1)     
70    if (List==6 .and.kr==1) write(2,9) nv,kv,nf,mf,nx, f1,fs,fm             !##----->     
       if (nf<1) goto 120                                       !Return on Error--->>     
!c2.c                                                                                     
!c2.c                       CHECK X DATA;   Delete any with Fnr > fm + 0.1.               
      Mx = Mf - Nf                          ! Top X-ray.  Mf= Total Freqs;  Nf= # Orays     
      kv1= kv                                                            !initial start     
80    Nx = Mx - kv                                               !Number of X rays used     
      IF (Nx==0)  goto 100                                                                  
      F = Fv(Mx) 
        
        error_text = "error_none" !! lfm_sqrt                                                                         
      if (sqrt_lfm((F+Fh)*F) >Fm+0.1) goto 90               !Delete X point, out of range
        if(error_text.eq.error_sqrt) return !! lfm_sqrt 
        
            
      if (Nx==1)  goto 100                                           !keep last X ray     
      if (Hv(Mx)-Hv(Mx-1) <Gfit*(Fv(Mx-1)-F)) goto 100        !Accept, Gradient is OK 
            
   90 if(error_text.eq.error_sqrt) return !! lfm_sqrt

      		DO jv= Mx,kv+1,-1                              !==== Rewrite this Range, to:     
            Fv(jv)= Fv(jv-1) ; Hv(jv)= Hv(jv-1)         !Move up (delete top X point)     
            END DO                                      !Move all data, so kv => kv+1     
         kv = kv + 1  ;  idx = idx + 1                            !count x data shift     
         if(kv>kv1+Nv) goto 5                                     !redo all selection     
         goto 80                                                  !check next x point
      	      
100        if(error_text.eq.error_sqrt) return !! lfm_sqrt   


        if (Nx==0 .and.kr==1)  Lk = 1                                         !no x start     
                if(List==6.and.kr==1) write(2,9)nv,kv,nf,mf,nx, f1,fs,fm    !##----->     
                if(List >1)write(2,"(('SelDat', f6.2,f6.1, 6(f7.2,f6.1)))") &             
                                     & (fv(i),hv(i),i=kv,mf)                !##----->     
      RETURN                                                                                
120      nv = -mf                                             !flag Error & Exit--->>     
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of SELDAT <<<<<<<<<<<<<<<<<<<     
!####################################################################################     
          
      SUBROUTINE  STAVAL  (START, VALLEY, LOOP)                                             
! For all Start, Valley calculations; where the real-height polynomial has a constant     
!   term [q(jm), at jm=mt+1] so that the height at the origin [fa,ha] is recalculated     
!-------------------------------------------------------------------------------          
!--> THE INITIALISING CALL enters and exits with  loop = 0.                               
!    If this is not a valley calculation (i.e. hval = 0.)  then STAVAL just               
!       sets the initial weight  xwat  for any x-ray data, and returns.                   
!    For a valley calculation (shown by hval /=0.) the iteration-flags devl, devll        
!       are initialised,  and the standard values for valley depth and width              
!       are calculated  (based on the 'standard scale height'  sha).                      
!--> A call with  loop = 1  is to adjust the valley depth for a single                    
!       O-ray iteration.  This exits with  loop = 4.                                      
!-------------------------------------------------------------------------------          
!--> THE MAIN CALL enters with  loop = 2.    ( -2 if fb is negative. )                    
!    Exit with  loop = 2  shows that the start/valley calculation is completed            
!       and the required real heights have been added to Ht().                            
!    If loop > 2  on exit,  POLAN recycles the valley calculation:-                       
!       loop = 3  requests a new calculation with a changed gyrofrequency.                
!       loop = 4  is to recalculate with a new value of valley depth  Vdepth.             
!-------------------------------------------------------------------------------          
      Include "polpars.pol"                                !Common arrays /POL/, etc.     
!constants:   base,    depthfac,   depthconst              for default valley             
      DATA    VBase,    VDeep,       VConst    / 0.6, .008, 20. /                         
!constants: 1st depth,  scale,  peak-top increase          for valley iteration           
      DATA    Val1,     DVal1,       VPeak     / .1001, 6., 1.4 /                         
!constants:  xweight,    Fhht itern limit                                                 
      DATA     Wvx,          HXerr             / 1.0,  2.0 /                              
      SAVE  Vald, DVaL, Devl, DevlL, HDec, Fhht                                           
!-------------------------------------------------------------------------------          
      nfb = loop   ;  loop = iabs(loop)                                  !-ve to fix fb     
      IF (loop==1) then                                      !O ray,  valley adjustment     
       loop = 4  ;  goto 40                                                               
      ELSE IF (loop>1) then  ; goto 200                    !start or valley iteration      
      ENDIF                                                                                
!************************************************************************************     
!cx1---                         FIRST CALL (with loop = 0) from polan section !C3.        
        tras = -3.1                                                                       
      xwat = wvx   ;  ParHt= 0.                                                             
!cx1.a                              CHECK for valley, set flag hval (def= 1)              
      hval = hv(kv)                                    !valley parameter given in data?     
        if (hval== 0.) hval = valley                         !No; Valley set in call?     
        if (hval== 0.) hval = 1.                             !NO.  Use default valley
        if (hval>=10.) hval = 0.  ;  if (hval==0.) return                  !no valley     
!------------------------------------------------------------------------------------     
!                               INITIALISE VALLEY Width and Depth (from hval)             
      hdec = (int(hval) - hval) *2.                   !decimal part => valley depth(/2)     
      devl = 1.e6    ;    devll= 1.e7                 !last deviations large => iterate     
      dval = dval1                                       !scale factor to iterate depth     
      hmax = hr(kr)                                              !height of Elayer peak     
      sh  = sh *vpeak                                            !scale ht above E peak     
20    sha = hmax*.25 - 20.                                       !standard scale height     
      hs  = hmax + sha                                           !height for valley fh.     
      vwidth = (sha + 7) * abs(hval)                             !standard valley width
        if (hval<-2.)  vwidth = int(-hval) *2.                   !use specified width 
!------------------------------------------------------------------------------------     
!                    SET INITIAL DEPTH Vald, or depth adjustment for valley iteration     
!cx1.c                          STANDARD DEPTH (Width calculations iterate here).         
40    vald = vwidth**2 *vdeep/(vconst+vwidth)                  !=standard valley depth     
         if (hmax>140.)  vald = 0.5*vald                      !decrease for F1 valley     
      if (hdec>0.)  vald = hdec                                !use a specified depth     
          if (hval==-1. .and.nx>0)  vald = val1                   !X ray, first depth     
          if (int(hval)==-1.)  hval = -1.                       !iterate valley depth     
!cx1.d                          PEAK  SECTION  (Depth calculations iterate here).         
60    vdepth = vald                                               !default valley depth     
      if(hdec<=0. .or. vald>.8*fa) vdepth = vald*fa/(vald+fa)         !keep vdepth < fa
        
        error_text = "error_none" !! lfm_sqrt     
      ParHt = 2.0*sh* sqrt_lfm((2.-vdepth/fa)*vdepth/fa)        !ht of parablc valy sectn
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
             
      ha = hmax + ParHt                                       !start of valley bottom     
      if (nc==0)  fhht = ha + 20.                             !1st guess for field ht     
      RETURN                                                                                
!************************************************************************************     
!                           MAIN CALL  with  loop = 2,3,4,   from polan section C4.3.     
!                               START / VALLEY  entry,  after  "solve".                   
200   tras = -4.3  ;   devn = q(20)                                                         
      Fnl = 0.     ;   dhl = q(jm)                                                          
!cx2--                              CALCULATE and CHECK real heights                      
220   if (nx<=0. .or. (devn==0..and.hval==-1.)) dval = -1.                    !list,end     
      Qm = Q(jm)                                            !offset term (dh at origin)     
      Hrr= HA + Qm                                            !height of shifted origin     
      Hn = Hrr   ;   Fn = FA                              !origin of real-ht polynomial     
      mc = nc    ;   mv = nf + nx                         !# iterations; # freqs fitted     
      mq = mt + min(lk,0)                                                                   
!.....                                      (Store Real Heights for Coefic recycle)       
      DO 300  I = 1, MV                                                                     
       HL = Hn  ;  FL = Fn
         
         error_text = "error_none" !! lfm_sqrt                                                                
       Fn = Fv(kv+I)  ;   IF (Fn<0.) Fn = sqrt_lfm((Fn+Fh)*Fn)
         if(error_text.eq.error_sqrt) return !! lfm_sqrt

                                         
       deltf = Fn - FA                                                                    
       Hn = Hrr + SUMVAL(Mq,Q,deltf,1)                                                    
          if (nc+mc>=25 .or.adip<0.)  goto 290           !too many iterns; omit tests     
          if ((Hn-hl)/(Fn-fl) > 2.0)  goto 290                      !gradient is O.K.     
             mc = mc + 3                                 !CHECKS at  dh / dFn  <  2.0     
                if (nx>0 .and.xwat==wvx .and.nc>1) goto 380         !bad, recalculate     
             Qmm = Qm - max(5., abs(Qm)/4.) *max(1,3-kr)            !next Qm, set 350     
             if (Fn/=Fnl .or. Hn-hl>dhl) goto 350                   !lower Qm, to Qmm     
                if (List>=-9) write(2,250) Fv(kv+i)                 !bad data**----->     
             250 format('Data/Gyrofrequency incompatible at f =',f6.2)                    
                mc = 30                                          !no more adjustments     
290    Hr(kr+I)= Hn  ;  Fr(kr+I)= Fn                              !store real heights     
300   CONTINUE                                                                              
!.....                                                                                    
      krm = kr + MV                           !top calcd real ht (for coefic recycle)       
!cx3---                             Set field ht  (and recycle fb).                       
      if (nc <3)  xwat = wvx                                                                
      krX = min(kr + 1 + NX/3, kr + MV)                !real ht Fhht, for Fh in X calcn     
      dhx = Hr(krx) - Fhht                                          !save shift in Fhht     
      Fhht = Hr(krx)                                             !real ht 1/3 up X data     
       if (nc==1 .or. abs(dhx)>hxerr)  loop = 3                             !reset fb     
       if (nx<=0 .or. nfb<0 .or.nc>19) loop = 2                             !no reset     
      if (kr>1)  goto 500                                                      ! valley     
      goto 400                                                                 !X start     
!------------------------------------------------------------------------------------     
!                           (jump here to get new solution with reduced start offset)     
350        Call ReSolve (-9., jm, q, Qmm, 0., devn,List)         !decrease Qm(=q(jm))     
           if(List>0) write(2,360) nc,Qm,q(jm), Fn,Hn,q(19),devn            !**----->     
360    format(i3,' STAVAL: Qm reduced from',f6.1,' to',f6.1,', to avoid', &               
     &     ' -ve slope at f,h =',2f7.2,'   devn increases',f6.2,' to',f6.2)               
           Fnl = Fn   ;   dhl = Hn - hl                                                   
           goto 220                                                                       
!------------------------------------------------------------------------------------     
!                                   Re-calculate a bad result                             
380           xwat = wvx/2.                                   !bad data, halve weight     
              if(List>=-9)write(2,*)'X ray Weights Reduced to 1/4.'  !note it, **--->     
              loop = 4 ; return                                      !and recalculate     
!------------------------------------------------------------------------------------     
!cx4---*******************************  X RAY START: slab (.3-.6f1) + poly **********     
!cx4---                                                                                   
400   SLab = Q(mt) ;  if (lk==0) SLab = 0.                        !0.=>polynomial start     
        if(List>=-9)write(2,420) nc,Qm, slab,devn, jm,nf,nx,ms,Fhht         !------->     
420     format (i2,' Start Ofset',f6.1,' km,  Slab',f6.1,' km.  devn', &                  
      & f5.2,' km.',i3,' terms fit',i3,' O +',i2,' X +',i2,'.  hx=',f6.1)                 
      if (loop==3)  return                                                    !reset fb     
      kd = 1-lk  ;  goto 700                                              !added points     
!------------------------------------------------------------------------------------     
!cx5---*******************************  Valley:  Iterate and print   ****************     
!cx5---                                                                                   
500   VWidth = Qm + ParHt                                         !overall valley width     
          if (hdec>0.)  dval= -hdec                                     !no iteration     
          if ((List>0 .or. dval<0. .or. nc>=20).and.List>=-9)  &                          
       &     write(2,520) nc, vwidth,vdepth, devn,jm,nf,nx,ms, Fhht         !------->     
520       format ( i2,' Valley',f6.1,' km wide,',f6.2,' MHz deep.',  &                    
                 &    '  devn',f5.2,' km.', i3,' terms fit',         &                    
                 &    i3,' O +',i2,' X +',i2,'.  hx=',f6.1)                               
      if (loop==3) return                                                     !reset FB     
!                                                                                         
      kd = 4   ;   loop = 4                                                                 
      VBot = Qm*VBase  ;  SLab = Qm - VBot             !constant density, + linear slab     
       if (dval<0. .or. nc>25)  goto 700                      !end valley calculation     
       if (hval==-1.)  goto 600                                  !iterate calculation     
!                                                                                         
! - - - - - - - - - - - - Normal cycle: Scale Depth as (Width)**2  - - - - - - - - -      
      if (devn>devl/.9.and.nc<4)  goto 20                     !revert to prev solution     
      if (devl <1.e6)  goto 560                                           !END  valley     
      devl = devn  ;   goto 40                                            !loop valley     
560   dval = -1.                                                                           
        if (List==0)  goto 500                                           !list valley     
      goto 700                                                            !END  valley     
!cx6--- - - - - - - - - - Vdepth Iteration: Choose Depth val1 or val1*dval1. - - - -      
!cx6---                                                                                   
600   if (dval/=dval1) goto 620                                             ! iterate     
      if (vald==val1)  goto 675                                            !1st round     
      dval = 1.+.5*cos(.015*adip)                                            !2nd round     
      if (devn <devl)  goto 675                                             !continue     
      vald = val1  ;   goto 680                             !revert to previous depth     
!                                   Iterate from chosen DEPTH                             
620   if (devn>(devl*.97)-.003.and.devlL<1.E6)  goto 660                         !END     
      if (devn <devl)  goto 670                       !deviation decreasing; continue     
       Dval = 1./Dval                                 !devn increased; reverse change     
       Vald = Vald*Dval                                            !use previous Vald     
       devll = devn ;  goto 680                                    !..and recalculate     
! - - - - - - - - - - - -           Interpolate to minimum deviation                      
660   dmin = (devll-devn)/abs(devll+devn-2*devl)*.5  - 1.    !min is in devll to devn     
      dval = -dval**amin1(dmin, .5)                      !value of Dval near minimum,     
      goto 680                                           !do a last Width calculation     
!                                   Recalculate Valley Width                              
670   devll= devl                                                  !save last 2 devns     
675   devl = devn                                                  !save last devns..     
680   vald = vald*abs(dval) ; goto 60                              !..and recalculate     
          
!------------------------------------------------------------------------------------     
!cx7--- ============================   Tidy up.    Delete x rays.  ==================     
!cx7---                         ADD initial points;  kd = 1,2,4  for poly, slab, valy     
700   loop = 2                                                                !all done     
                     if (List==6) call trace (tras)                         !##----->     
      kr = kr + kd                                                   !step real heights     
      kv = kv + abs(nx)                                                 !delete x data      
      if (kd==0)  return                                                      !all done     
      if (kd==1)  goto 750                                                 !poly start      
!                                   STORE  Valley,Start slab at kd = 4,2                  
      FBot = FA - VDepth                                                                  
      Fr(kr-2) = FBOT     ;  Hr(kr-2) = HA                     !bottom of valley base     
      Fr(kr-1) = Fr(kr-2) ;  Hr(kr-1) = HA+Qm*VBase            !& top of base section     
      if (kd<4)  goto 750
        
            error_text = "error_none" !! lfm_sqrt                                                             
          Fr(kr-3) = 0.5*sqrt_lfm(3.*FA**2 + FBot**2)              !add point above peak,
      	  if(error_text.eq.error_sqrt) return !! lfm_sqrt

      	       
          Hr(kr-3) = HA - 0.5*Parht                            !half-way peak to base     
          Fv(kv) = FA                                                                     
!                                                                                         
750   HA = HA + Qm                                                                          
      if (kd<=2)  kr = kd                                                                   
      Fr(kr) = FA  ;   Hr(kr) = HA                         !start of Real-ht polynomial     
      if (kr >3)  goto 800                                     !not a start calculation     
!                                   Add Points on start polynomial                        
       Hr(1) = HA - SLab                                       !Base of start section     
       Fv(kv-1) = FA                                          !calculated (offset) ht     
       F1 = Fv(kv+1)                                                 !first frequency     
         if (lk==0) Fv(kv-1)= (FA + F1)*.5                          !(for polynomial)     
       Fv(kv) = (Fv(kv-1) + F1)*.5                                 !calculated height     
       kv = kv -2 -lk                                                                     
       VBot = 0.                                                                          
800   if(kr>1) TCont= TCont +Fr(kr-1)**2*(VBot+.5*SLab) +FA**2*.5*SLab & !linear valley     
             &     + Parht*(FA*FA - VDepth*(FA+Fr(kr-1))/3.)           !parabolc valy     
              if (List==6) call trace (tras)                                !##----->     
              if (List==6) List = 0                                       !end  start     
              if (List==9) List = -9                                      !end valley     
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of STAVAL <<<<<<<<<<<<<<<<<<<     
!####################################################################################     


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!  POLSOLV.F90                     F90 version -- Created: 9/05/03                        
!  Author : JOHN TITHERIDGE       Copyright(c) University of Auckland 2000                
!  Last change: jet 1/08/03 12:38:13                                                      
!  ***********************************************************************                
! POLSOLV.FOR  =  SOLVE/ReSolve,   ADJUST,   PEAKFIT,   SUMVAL,   SUMPROD.                
!   To SOLVE simultaneous equations,  and ADJUST the solution as required.                
!=========================================================================                
!                                                                                         
            SUBROUTINE  SOLVE (M, N, B, Q, Devn, List)                                    
!                                                                                         
! Solve m simultaneous equns in n unknowns, given in the array  B(m,n+1).                 
! The result is returned in  Q(1)  to  Q(n).  Max values: M = 99, N = 16.                 
! The rms fit error is returned in q(20), and the previous error in q(19)                 
!====================================================================================     
!              ADJUSTMENTS TO A PREVIOUSLY OBTAINED SOLUTION    are made by:-             
!>>>>>>>>   CALL  ReSOLVE (Wn, N,  Q, Qset, delf, devn, List)   <<<<<<<<<<<<<<<<<<<<<     
!                                                                                         
!  This modifies the least-squares solution by removing any previous constraint on        
!      Q(N),  and adding the constraint:    Q(N) = Qset,  with a weight  Wn.              
!  Any number of the coefficients Q can be modified in this way.  If Wn is negative,      
!      any constraints previously applied at larger values of N are also removed.         
!      (Use Wn = 0. to just remove a constraint on q(N).)   Addition of constraints       
!      is numerically stable.  Removal of constraints is less accurate but still O.K.     
!  To add a Profile Constraint on  Height/Gradient/Curvature, set  N = 100/200/300,       
!      with  Delf = freq-FA,   Value = Qset,  and Weight = Wn  as before.                 
!-----------------------------------------------------------------------                  
      REAL  B(99,20), Q(20), WSetq(17), VSetq(17), Bs(99,17)           !use Bs to solve     
      SAVE  NQ, NP, WSetq, VSetq, BS 
                                                           
      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT
           
      DATA  WSetq, VSetq  / 34*0. /                                                         
   19 Format (a,i5,9f8.3)                                                                
      NQ = N   ;   NP = N+1                                                                 
      DO I = 1, M                             !M equations, in N unknowns; NP is r.h.s.     
        Bs(I,1:np) = B(I,1:np) *B(I,19)     !COPY EQUATIONS, with weighting, to solve     
        END DO                                                                            
          
        20 IF (List==5.or.m<n) THEN         !LIST MATRIX B (List=5 or Error in Solve)     
                  write(2,22) (j, j= 1, NP), 18, 19                                       
               22 format ('>Solve: J=', i3,12i9/ 4x,13i9)                                 
                  do i= 1, M                                                              
                     write(2,24) i, b(i,1:NP), b(i,18:19) ; end do                        
               24 format ('>B(',i2,',j=',f8.4,12f9.4/ 8x,13f9.4)                          
            ENDIF   ;   if (m<n) RETURN                           !exit on error-->>>     
!------------------------------------------------------------------------------------     
!                                 Householder transformations                             
      K = 0                                                                                 
1     K = K+1                                                                               
       WSetq(K) = 0.                                        !zero constraints on q(n)     
       S = 0.                                                                             
       MK = M-K+1   ;   if (MK<=0)  goto 7                          !form Q() and END     
       S = SumPrOD (MK, Bs(K,K),Bs(K,K), 4)                        !sums Bs(k:m, k)^2     
                        if (K==NP)  goto 7                          !form Q() and END     
       A = Bs(K,K)
         
         error_text = "error_none" !! lfm_sqrt                                                                        
       D = sign(sqrt_lfm(S), A)
         if(error_text.eq.error_sqrt) return !! lfm_sqrt
         
                                                                        
       Bs(K,K) = A + D                                                                    
       C = A*D + S                                                                        
               if(C==0.) then ; m = -m ; goto 20  ; endif         !list, end on error     
        DO J = K+1, NP                                                                    
           S = SumPrOD (MK, Bs(K,K),Bs(K,J), 4) /C                                        
           DO I = K, M ;  Bs(I,J) = Bs(I,J) - Bs(I,K)*S;  ENDDO                           
        END DO                                                                            
      Bs(K,K) = -D   ;  goto 1                                                              
!====================================================================================     
      ENTRY  ReSOLVE (Wn, N, Q,  Qset, delf, devn, List)                                    
!----------       Adjust Previous Solution.  All entries here, exit at bottom [8].        
                if (List>=4 .or. (N >nq .and.N<100))  &                                   
             &  write(2,19) '>>>reSolve with n,qset,w=',N,Qset,Wn                         
       Ww = abs(Wn)                                              !Weight for equation     
       nad = N/100                                        !1-3 adds ht,grad,curv equn     
       IF (nad >0) THEN           ! ADD NEW EQUATION ================================     
          fj = 1.  ;   if (nad>1) fj = 1./delf       !delf= freq-FA, for profile equn     
          nn = max(1, nad-1)                               !ht,grad,curv at nn= 1,1,2     
          DO j = nn, nq                                        !store equation in Q()     
             fj = fj * delf                                    !height = f, f^2,  ...     
             qj = fj                                           !grad,curv = 1,f,f^2,.     
             if (nad>1) qj = qj * j                            !gradient is sum(j*Qj)     
             if (nad>2) qj = qj * (j - 1)                      !curv= sum(j*(j-1)*Qj)     
             q(j) =  qj * Ww                                                              
          END DO                                                                          
             q(np)= Qset * Ww                                                 !r.h.s.     
          remov = 1.  ;  goto 6                                  !add in new equation     
       ENDIF                                                                              
!                           Wn -ve;  Remove any previous constraints on q(n) to q(nq)     
      if (Wn >0.) goto 51    !!!!!!! ALL PREV VERSIONS DID NOT CHECKED W < 0. !!!!!!!!!     
      Remov = -1.  ;  nn = N -1                                                             
3     nn = nn + 1                                                                           
       if (WSetq(nn) /= 0.)  goto 5                   !REMOVE Constraint, return to 4     
4      if (nn<nq .and.Wn<0.) goto 3                        !FIND any more Constraints     
!----------                 ADD CONSTRAINT   Wn*Q(n) = Wn*Qset                            
51    Remov = 1.   ;  nn = N                                     !To ADD EQUATION -----     
      WSetq(nn) = Ww                                             !record weight & value     
       if (Ww==0.)  goto 8                                            !nothing to add     
      VSetq(nn) = Qset                                                  !save set value     
5     Q(nn)= WSetq(nn)  ;  Q(np)= WSetq(nn)*VSetq(nn)                       !set r.h.s.     
      if (Remov <0.)  WSetq(nn) = 0.                             !record it's cancelled     
!                                                                                         
6     DO i = nn, np                          !Given's Transform, to ADD in NEW EQUATION     
       bii = Bs(i,i)
         
         error_text = "error_none" !! lfm_sqrt                                                                      
       R = sqrt_lfm( max(bii**2 + q(i)**2*Remov, .1e-9) )       !(correct negative value)
         if(error_text.eq.error_sqrt) return !! lfm_sqrt

              
       C = bii/R   ;   S = q(i)/R                                                         
       DO j = i, np                                                                       
          Qj = Q(j)                                                                       
          if (i==nn .and.j>i .and.j<np .and.nad==0)  Qj = 0.                              
          Q(J) = C*Qj - S*Bs(I,J)                                                         
          Bs(I,J)= C*Bs(I,J) + S*Qj*Remov                                                 
       END DO                                                                             
      END DO                                                                                
!                                                                                         
      if (Remov <0.)  goto 4                 !Constraint is removed; CHECK for any more     
      goto 8                                                                                
!------------------------------------------------------------------------------------     
!                               BACK SUBSTITUTION                                         
7     Bs(NP,1) = m

        error_text = "error_none" !! lfm_sqrt                                                                          
      Bs(NP,NP)= sqrt_lfm(s) 
        if(error_text.eq.error_sqrt) return !! lfm_sqrt

                                                                           
8     error_text = "error_none" !! lfm_sqrt
        devn = abs(Bs(np,np)) /sqrt_lfm(Bs(np,1)) 
        if(error_text.eq.error_sqrt) return !! lfm_sqrt

                                                
      DO ii = 2, np                                                                         
       i = np-ii+1  ;   s = Bs(i,np)                                                      
          DO j = i+1, nq ;  if (ii>2) s = s - Q(J)*Bs(i,j) ;  ENDDO                       
       Q(I) = S/Bs(i,i)                                                                   
      END DO                                                                               
              if (List>=4) write(2,'(a,13f9.3)') 'Q,Devn=', q(1:np-1), devn               
      Q(19) = Q(20)  ;  Q(20) = devn                                                        
      RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of SOLVE <<<<<<<<<<<<<<<<<<<<      
!####################################################################################     
          
      SUBROUTINE  ADJUST (HA,FA, FM,FC, LK,JM,MT, Q, List)                                 
!                                                                 jan82/jun83.            
! Called from section !C4.2 of Polan, after the initial call to SOLVE,                    
! Adjust is used to condition the real-height polynomial  (in  df = f-fa)                 
!        h = ha + df*q(1) + df**2 *q(2) + ... + df**mq *q(mq)                             
!     by ensuring that                                                                    
! 1-  The gradient  dh/df  is positive at  f = fa.                                        
!     For an O-ray start calculation, an initial gradient  Q1  of                         
!                        greater than 80 km/MHz is reduced to  160.Q1/(80+Q1).            
!     For an X-ray slab start (lk =-1) the gradient is limited above 160 km.              
! 2-  The solution is well-defined:                                                       
!               -  the last 3 coefficients do not alternate in sign, and                  
!               -  these coefficients have absolute values less than 999.                 
!     These conditions are omitted for the peak and x-ray start, when a large             
!                          gradient may be required at one end of the fit range.          
! 3-  For x start calculations:  the underlying slab is positive,                         
!                                the initial height offset is negative,                   
!                                the initial height (+offset) is > 60 km.                 
! 4-  For a valley calculation:  the initial gradient  dh/df > sha,                       
!                                the initial curvature  q(2) < -1.5,                      
!                                the initial height offset is positive.                   
! 5-  For the last polynomial in a layer (with a peak to be fitted):                      
!                       the curvature d2h/df2 is large at the top frequency fm.           
!                                                                                         
! Adjustments alter the least-squares coefficients  q(1)  to  q(jm),                      
!     and the rms deviation of the fit (devn, stored in q(20)).                           
!-----------------------------------------------------------------------                  
!     When  jm = mt,  the polynomial ends at  mq = mt.                                    
!-----                                                                                    
!     jm = mt+1  and  lk<=0  indicates an x start calculation.                            
!        The poly then ends at  mq = mt-1,  and                                           
!        q(mt) = underlying slab thickness,  preferably positive;                         
!        q(jm) = starting height offset,  which must be negative.                         
!-----                                                                                    
!     jm = mt+1  and  lk >0  indicates a valley calculation.                              
!        The poly then ends at  mq = mt,                                                  
!        and  q(jm) = the valley width,   which must be positive.                         
!-----------------------------------------------------------------------                  
!  Adjustments are made by CALL ReSOLVE (W, n, q, qset, devn,List).                       
!  This modifies the least-squares solution by adding the constraint                      
!  q(n) = qset,  with a weight  Wn.   Any constraints previously                          
!  applied at this or larger values of n are first removed by  SOLVE.                     
!-----------------------------------------------------------------------                  
      REAL  Q(20)
        

      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT

            lflag= (List+50)/100                          !2=leave q1; 4=don't adjust     
            List = List- lflag*100                                                        
            ladj = 0                                                                      
!                             Set mq = no of poly terms,  and head                        
      Devn = Q(20)                                                                        
      MQ = MT                                                                             
      if (LK<0)  MQ = MT-1                                                                
         if (List>2 .or. (List>0.and.lk<2)) write(2,7)(m,m=2,mt)            !------->     
         if(List>0)write(2,9)'--- ',lk,jm,mt,ha,fa,fm,q(1:jm),devn          !------->     
    7  format('*adjust----  lk jm mt    ha     fa    fm',6x,'q1',9i8/40x,10i8)          
    9  format ('*adjust', a5,3i3, f8.2,2f6.2, 10f8.1 /41x,10f8.1)                       
         if (lflag>3 .or. jm<4) return                                     !no adjust     
!-----------------------------------------------------------------------                  
!(a)                          Initial gradient;  must exceed 1.5                          
      Qmin = 2.  ;  delf= 0.                                                              
      if (lflag>1) goto 100                              !initial O start; leave q(1)     
      IF (lk<=1)  THEN                    !====  O,X Start: limit gradient to 160,320.     
        Qmax = 80.                                                                        
          if (LK==-1)  Qmax = 160.                                                        
          if (Q(1)>Qmax)  Qmin = 2.*Qmax*q(1) / (Qmax+q(1))                               
      ELSE                               !====  Valley:  Gradient > sha             .     
        if (JM>MT)  Qmin = HA/4. - 20.                                                    
      ENDIF                                                                               
!                                                                                         
      IF (Q(1)<Qmin .or. Qmin>=85.)  THEN                                                  
        Call ReSOLVE (-9., 1, Q, QMin, delf, Devn,List)                  !q(1) adjust     
        ladj= ladj + 1                                                                    
               if(List>0)write(2,9)'q(1)',lk,jm,mt,ha,fa,fm,q(1:jm),devn    !------->     
      ENDIF                                                                               
                                         !====  Valley:  Initial curvature < -1.5   .     
      IF (JM>MT .and.LK>0 .and.Q(2)>=-1.5) THEN                                            
        Call ReSOLVE (-9., 2, Q, -1.5, delf, Devn,List)                  !q(2) adjust     
        ladj= ladj + 2                                                                    
               if(List>0)write(2,9)'q(2)',lk,jm,mt,ha,fa,fm,q(1:jm),devn    !------->     
      ENDIF                                                                               
!-----------------------------------------------------------------------                  
!(b)                    CHECK FOR UNNECESSARY HIGH-ORDER COEFFICIENTS.                    
!Reduce order if last 3 signs alternate, & sizes increasing, or any size exceeds 999.     
100   QL = Q(MQ)                                                                          
      IF (MQ<5 .or. abs(QL)<150. .or. FC>0. .or. LK<=0) goto 200              !  O.K.     
          IF (QL/Q(MQ-2)>2. .and. QL/Q(MQ-1) <-1.)  goto 150                  !fix it     
          IF (abs(QL)<999. .and.abs(Q(MQ-1))<999.)  goto 200                  !  O.K.     
!                       ADD CONSTRAINT  q(mq) = 0.,  and reduce mq.                       
150           Call ReSOLVE (9., MQ, Q, 0., delf, Devn,List)                               
      if(List>0)write(2,9)'mq ',lk,jm,mt,ha,fa,fm,q(1:jm),devn              !------->     
              MQ = MQ-1                                                                   
              goto 100                                                                    
200   CONTINUE                                                                             
!-----------------------------------------------------------------------                  
!(c)              S T A R T  and  V A L L E Y:   check sign, and limit offset term        
!                                                                                         
      IF (JM==MT)  goto 500                                            !no offset term     
      IF (LK >0 )  goto 400                                                  !  valley     
!--------               START:-  Slab                                                     
      qm = Q(MT)                                                                           
      QMT= 0.1                                                                             
      IF (QM<0.)  then                                                                     
         Call ReSOLVE (-9., MT, Q, QMT, delf, Devn,List)                    !slab= .1     
            if(List>0)write(2,9)'Slab',lk,jm,mt,ha,fa,fm,q(1:jm),devn       !------->     
         if(Devn>Q(19)*1.25) Call ReSOLVE(0.,MT,Q, QMT,delf,Devn,List)      !  cancel     
       ENDIF                                                                              
!                       START:-  Offset                                                   
        OFset = -0.1                                                                      
        if (Q(JM) >0.)  goto 450                                                          
        if (LK>=0 .or. HA+Q(JM)>60.)  goto 500                                            
           OFset = 60. - HA   ;   goto 450                                                
!--------               VALLEY                                                            
400   if (Q(JM)>=0.)  goto 500                                                             
        OFset = 0.1              ! Correct initial real-height offset               .     
450     Call  ReSOLVE (-9., JM, Q, OFset, delf, Devn,List)                                
        if(List>0) write(2,9) 'Ofset',lk,jm,mt,ha,fa,fm,q(1:jm),devn        !------->     
!-----------------------------------------------------------------------                  
!(d)       P O L Y N O M I A L   to   P E A K:   check curvature at fm.   (2'93)          
!                                                                                         
500   if (fc<=0. .or. mq<4) goto 600                           !no peak, or cubic only     
      hfm = ha + sumval (mq, q, fm-fa, 1)                                                  
      shm = max(.27*hfm - 21., 5.)                                     !model sh at fm     
      d = FC - fm 
        
        error_text = "error_none" !! lfm_sqrt                                                                         
      if (d<.03) d = (0.1*sqrt_lfm(fm) +.03*fm)             !fm=3,7,11,16->.26,.47,.66,.88
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
        
        error_text = "error_none" !! lfm_sqrt      
      Curve = 0.28*shm /(d*sqrt_lfm(fm*d))                  !parab=0.35*..,  80% ->0.28*
        if(error_text.eq.error_sqrt) return !! lfm_sqrt

      if (sumval(mq,q,fm-fa,3) >Curve) goto 600                                  !O.K.     
        delf = fm - fa 

      	error_text = "error_none" !! lfm_sqrt                                                                    
        Call ReSOLVE (1.,300, Q, Curve, delf,Devn, List)         !set curv(fm), W=1
      	if(error_text.eq.error_sqrt) return !! lfm_sqrt
      	       
             if(List>0)write(2,9)'Curvm',lk,jm,mt,ha,fa,fm,q(1:jm),devn       !----->     
        if (q(1)>qmin  .or. mod(ladj,2)==1) goto 600 
      	
      	      error_text = "error_none" !! lfm_sqrt                               
              Call ReSOLVE (-9., 1, Q, Qmin, delf,Devn,List)             !adjust q(1) 
      		  if(error_text.eq.error_sqrt) return !! lfm_sqrt
      		      
             if(List>0)write(2,9) 'q(1)',lk,jm,mt,ha,fa,fm,q(1:jm),devn       !----->     
!                                                                                         
600   RETURN  ;  END              !>>>>>>>>>>>>>>>>>> END of ADJUST <<<<<<<<<<<<<<<<<<<     
!####################################################################################     
          
      SUBROUTINE  PEAKFIT  (QQ)                                                           
!*************************************************************jan78/de!!C84/nov87.        
!  Get FC, SH  by least-squares fitting of a Chapman-layer expression                     
!     to the profile gradients at the last NK calculated points.                          
!  Include any scaled  FC, FCX,   and iterate from a model scale height.                  
!  Called with kr, kv pointing at the last calculated real height before peak.            
!  Exit with kr, kv at peak.      LIST = 8 adds detailed trace outputs.                   
!-------------------------------------------------------------------------------          
      DIMENSION   QQ(*), PQ(20)                                                             
      Include "polpars.pol"                               !Common arrays, etc. in /POL/     
      PQ(20) = 0.                                                                           
  9   format (a, 10f10.3/(15x,10f10.3))                                                     
!-------------------------------------------------------------------------------          
!                                    Set frequencies                                      
      kr = kr + 1    ;    kv = kv + 1                                         ! to peak     
      FM = Fr(krm)   ;    HN = Hr(krm)                        !top frequency and height     
      nk = min(nf*9/(nf+9), kr/3) + 2                       !# frequencies for peak fit     
       if (Fv(kv-nk) < fm*.7)         nk = nk-1                !drop lowest frequency     
       if (Fv(kv-nk)<fm*.85.and.nk>5) nk = nk-1                         !drop another     
       if (mode==10 .or. mode>=30)    nk = nk-1           !& -1 for single polynomial     
      KA = kv - NK -1                                              !origin, below start     
      KB = krm - NK                                                                         
      SH = MAX(.27*HN - 21., 5.)                                              !model SH     
      HMax = HN + .3*SH                                              !estimated, for Fh     
      Fh = GIND(0., HMax)                                                                   
      MK = NK                                                            !points to fit     
      if (FCC>.1)  MK = MK + 1                                              !incl. FC     
      Fcx = abs(Fv(kv+1)) ;  Hcx = Hv(kv+1)                                               
      IF (abs(Hcx)<=30..and.Fcx>=Fm+.5*Fh)  then                             !x data:     
         Fv(kv+1)=Fv(kv) ;  Hv(kv+1)= Hv(kv)                                 !swap Fc     
         Fv(kv) = Fcx    ;  Hv(kv) = Hcx                                     !and fcx     
         MK = MK + 1     ;  kv = kv + 1                                  !include fcx     
        ENDIF                                                                             
      Fr(kr) = fcc         ;  Hr(kr) = Hv(kv)                                               
      fnext= Fv(kv+1)      ;  if (fnext==-1.) fnext = 0.                                    
      if (fnext<0.)  then
        
         error_text = "error_none" !! lfm_sqrt                                                                  
       fnext = sqrt_lfm(fnext*(fnext+.99*Fh))                            !fN at 1st x-ray
         if(error_text.eq.error_sqrt) return !! lfm_sqrt
              
       DO i = 2, 60                                                                       
          if (Fv(kv+i)>=0.)  exit                                          !1st o-ray     
         END do                                                                           
       fnext = min(fnext, Fv(kv+i))                                                       
      endif                                                                                 
!-------------------------------------------------------------------------------          
!   Solves Mk1 equations:   B(i,1)*ln(FC) + B(i,2)*(SH/SHA)^2 = B(i,3)*ln(Fi).            
!.....                              (A) SET UP AND SOLVE PEAK EQUATIONS                   
      DO 400 LOOP = 1, 3                                                       !iterate     
      pgrad = 1.0                                                                         
!.....                                                                                    
      DO 300 I = 1, MK                                 !Eqns to fit grad at each freq
        
      	     
         F = Fv(KA+I)
      	 
      	    error_text = "error_none" !! lfm_sqrt                                                                  
            if (F==Fcx)  F = sqrt_lfm(FCX*(FCX - Fh))                        !critical Fx 
      		if(error_text.eq.error_sqrt) return !! lfm_sqrt
      		    
         W = 2.**(14.*(F-FM)/F)  / .7                                         !weight     
         GRAD = 0.                                                          !for peak     
         IF (F<=FM)  then                                          !below critical Fo     
            W  = W  * .7                                           ! (W => 1.0 at FM)     
            MQ = MT + min(lk, 0)                                   !#polynomial terms     
            Grad = 4./F/ max( SUMVAL(MQ,Q,F-FA,2), 3.)             !  = 2.*dN/dh /N ,     
            if (i==nk) grad= grad - grad*.2*(1.-float(mt)/nf)**3   !at top calcd freq     
          ENDIF                                                                           
         T = SH*Grad                                                                      
         pgrad = pgrad * 20.* max(Grad,.002)            !for weight on final SH = SHA     
         B(I,5) = Grad                                                    !save 5, 6,     
         B(I,6) = (log(1.+T) - T)*.25                                     !for errors     
         B(I,1) = 1.                                                     ! * ln( FC )     
         B(I,2) = B(I,6)                                               ! * (SH/SHA)^2     
         B(I,3) = log(F)                                               !r.h.s.=ln(fc)     
         B(I,18) = F ;  B(I,19) = W                                    !freq & weight     
300   CONTINUE                                                                            
!                                 Add condition  (SH/SHA)^2 = 1.0   [B(i,2) = B(i,3)]     
      mk1= mk+1  ;     b(mk1,1) = 0.                                                      
      b(mk1,2) = 1. ;  b(mk1,3) = 1.                                    !set equation
        
        error_text = "error_none" !! lfm_sqrt     
      w = 0.1*sqrt_lfm(pgrad) + .02                                         !, and weight
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
             
      b(mk1,18)= SH ;  b(mk1,19)= w                                     !(show SH, W)     
!                                                                              !List,     
             if(List==8) write(2,320) nk,mk,sh,w                               !trace     
             if(List==8 .and.loop==1)   &                                                 
          &  write (2,322) (Fr(kb+k),Hr(kb+k),b(k,5),b(k,19), k=1,mk)        !#----->     
   320      format (' peak: nk,mk,sh,w=', 2i3, f6.1, f7.3 )                              
   322      format (7x,'F, H, G, W=', 16f7.2 / (18x,16f7.2))                             
!                                                                                         
      Call SOLVE (mk1, 2, B, PQ,  devn,List)                                              
!                                   Set  sh = avge (sh,sha)  if ill-defined               
      Gmax = B(nk, 5)                                                                     
        erfac= 400./(mk1-nk)/(nk-.8) *devn                                                
        qfac = .1/gmax - .1/b((nk+1)/2,5)                                                 
        IF (qfac<erfac)  then                                                             
            avsh = max(PQ(2), 0.) *.5 + .5                                  !use mean     
            if (PQ(2)>1.)  avsh = PQ(2)/avsh                                !avg 1/SH     
            Call  ReSOLVE (0.1, 2, PQ, avsh, 0., devn,List)                 !set avsh     
          ENDIF                                                                           
!                                   If no scaled FC, limit calcd FC to 1.5fm 
!LEO      print*," POLAN EXP 1",pq(1)             
      FC = exp(PQ(1))                                                                     
      if (mk==nk.and.FC>1.5*fm) Call ReSOLVE(4., 1, PQ, log(1.5*fm), 0.,devn,List) 
        
        error_text = "error_none" !! lfm_sqrt        
      SH = SH*sqrt_lfm( abs(PQ(2)) )
        if(error_text.eq.error_sqrt) return !! lfm_sqrt
                                                                  
      ParHt= SH*min( log(1.+SH*Gmax), 1.8)                                                
      HMax = HN + ParHt                                                                   
        Fh = Gind(0., HMax)                                                               
             if(List==8) write(2,9) 'qfac,erfac,parht', qfac,erfac,ParHt                  
          if (ParHt>sh/loop)  goto 500                                      !no itern     
          if (qfac <erfac*2.*loop**2) goto 500                              !no itern     
400   CONTINUE                                                                              
!.....                                                                                    
!---------------------          (B) FIT PEAK TO LAST NK REAL HEIGHTS.                     
500   continue
!LEO      print*," POLAN EXP 2",pq(1)
        FC = exp(pq(1))                                                                       
      fcn = 0.   ;  hmx = 0.                                                                
      fadj= 0.   ;  hadj= 0.                                                                
      fcm = fnext*.8 + fm*.2 -.015                                 !upper limit (nov87)     
      if (FC>fcm.and.fcm>fm)  fcn = fcm                                                   
      if (fc<fm*1.002)  fcn = fm*1.002                   !lowerlim(8'87; ->.002 2'88)     
      if (fcn/=0.)  Call ReSOLVE (3.,1, PQ, log(fcn), 0.,devn,List)
!LEO        print*," POLAN EXP 3",pq(1)                       
      FC = exp(PQ(1))                                                                       
      SHr= PQ(2)                                                                            
          
      Sumw = 0. ; Sumhw= 0.                        !'85 fit hn,hl; '88-91 fit G's only.     
      fw = Fr(max(kb,1))               !get hmax as weighted mean of fits to each point     
      DO 520 I = 1, NK                 !2'93: use mostly zf(fits f/fc), & zg(fits grad)     
       W = (Fr(kb+i)-fw)**2                                                               
       r = 4.*log(Fr(kb+i)/fc)                 !at f,=1+z-e^z for Chap, -z^2/2 parab
         
         error_text = "error_none" !! lfm_sqrt      
       zf = sqrt_lfm(-2.*r)                                     !1st (parab) approx to zf
         if(error_text.eq.error_sqrt) return !! lfm_sqrt
              
       do  ii = 1, 3                                                !iterate to Chap: 
!LEO         print*," POLAN EXP 4",zf    
          rf = 1. + zf - exp(zf)                                        !(z +ve down)     
          gf = rf - zf                                              !Chap dr/dz at zf     
          zf = zf + (r-rf)/gf                                            !next approx     
       end do                                                                             
       zg = log(1. + sh*b(i,5))                            !Chap z to match poly grad     
       Zm = zf                 !!!*.8 + zg*.2          !fit grad is no help; fit mean     
       hlx = hmx                                                                          
       Hmx = Hr(KB+I) + SH*Zm                                     !peak ht for this z     
          if (List==8) write(2,9) ' f,h, hm,w, zf,g=',   &                                
      &                     Fr(kb+i),Hr(kb+i), hmx,w, zf,zg                    !!#----->     
                !c       if(List==8)write(2,9)' r,z1;r2,g2;zf,zg', r,z1, r2,g2, zf,zg     
       Sumhw= Sumhw + Hmx*w                                                               
       Sumw = Sumw  + W                                                                   
520   CONTINUE                                                                              
      HMax = Sumhw/Sumw                                            !final mean estimate     
!                           Adjust last point towards chap layer (ht [& grad])            
      IF (nf>=3) THEN                                                                       
        Hadj = HMax - Hmx                                        ! (adds to hmax err)     
        Hr(krm) = HN + Hadj*.80                           !2'93: move 80% to fit hmax     
        Hr(krm-1)= Hr(krm-1) + (Hmax-hlx)*.40             !2'93: move 40% to fit hmax
!LEO      	print*," POLAN EXP 5", 0.25*(zm - sh*Gmax)      
          fchap= fc*exp( .25*(zm - sh*Gmax) )                     !freq to match grad     
          fadj = fchap - fm                                       !(added to FC devn)     
!cc2'93 ??best no shift?  Fr(krm) = fm + fadj *0.1    ! ??move sl toward same grad        
            if(List==8) write(2,9)' FC,fad,hmax,had=',FC,fadj,hmax,hadj     !!#----->     
      ENDIF                                                                               
      ParHt = Hmax - Hr(krm)           !parabolic sectn for 'reduce' (top freq to peak)     
       Hr(kr)= Hmax - 0.5*Parht                           !add point half-way to peak     
       z = 0.5*Parht/sh
!LEO         print*," POLAN EXP 6",Hmax,krm,Hr(krm),Parht,sh,z                                                                   
       Fr(kr)= Fc*exp(0.25*(1. + z - exp(z)))                      !on Chapman layer.     
       kr = kr + 1                                      !(use fp at (kr-2) in coefic)     
      Fr(kr)= Fc   ;   Hr(kr)= HMax                                                         
      Devn = Devn*2/(1+mk-nk)                                                               
      if (Fnext==0.)  goto 700                                                              
!-------------------------------------------------------------------------------          
! Check overlap - this section can be omitted with manual scalings (F monotonic)          
      Fc = min(Fc, fnext-.03)                                                               
      dfc= Fr(kr) - FC   ;   fm = fm - dfc                                   !REDUCE fm     
      Devn= min( Devn, .5*(fnext-fm)/Fc)                                                    
      if (dfc<=0.01)  goto 700                                                              
!                                         Layer Overlap;  reduce frequencies              
          if(List>=-9)write(2,640) Fr(kr), FC, fnext                        !**----->     
        640  format (' * FC  reduced from',f7.3,'   to',F7.3,  &                          
             &      '   since next layer starts at',f7.3,' MHz.' /)                       
      df = dfc/fR(kr)**3                                                                  
      DO k = 1, kr                                                                        
         Fr(k)= Fr(k) - df*fr(k)**3  ;  END DO                                            
      fa = fa - df*fa**3                                                                  
!-------------------------------------------------------------------------------          
!                                         List peak parameters                            
700   Devf = Fc*Devn + abs(fadj)                                              !freq err     
      Bavge= -b(2,6) - b(nk,6)                                                              
      dEvs = SH/SHr*Devn/Bavge                                                 !sh err.     
      Devh = Devn *ParHt/Bavge + Devs*SH*Gmax + abs(Hadj)                     !hmax err     
      TCont= TCont + Parht*(Fc**2+.5*Fm**2) /1.5                              !parabola     
      Ssh = SH                                                                              
      IF (Loop==1)  Ssh = -SH                                                   !-model     
        if(List>=-9)write(2,750) FC,devf,hmax,devh,Ssh,devs,tcont/fc**2     !**----->     
  750 format('PEAK',F7.3,' (~',F5.3,') MHz,  Height',F6.1,' (~',F4.1,  &                
        &    ') km.    ScaleHt',f5.1,' (~',F4.1,') km  SlabT',F6.1,' km')                 
      Fr(kr+4)= Devf  ;  Hr(kr+4)= Devh                !rms devn of fitted freq, height     
      Fv(kv) = FC                                                                           
!                                 TO SAVE PARAMETERS IN ARRAY  QQ                         
      numq = int(QQ(1))                                                 !# poly coefs     
      DO 770 j = numq+1, numq+4                                                           
         if (qq(j)==-1.)  goto 800                                  !don't add params     
770      continue                                                                         
      wf = 0.1 + 0.9/nf                            !nf=1,2,3,5,9..->1,.55,.4,.28,.2,.     
      fp = Fr(krm)*wf + Fr(krm-1)*(1.-wf)                  !2'93 best poly/chap match     
      fp = min(fp, 0.98*fc)                                                               
      QQ(numq+1) = max(fp, 0.90*fm)                         !but keep in 0.9fm-0.97fc     
      QQ(numq+2) = FC    ;  QQ(numq+3) = HMax                                             
      QQ(numq+4) = SSH   ;  QQ(1) = numq + 4                              != new numq     
800   RETURN  ;  END              !>>>>>>>>>>>>>>>>> END of PEAKFIT <<<<<<<<<<<<<<<<<<<     
!####################################################################################     
      FUNCTION  SUMVAL (N, A, C, L)                                                         
! RETURNS THE SUM,  for j = 1 to N,  of:-     POLYNOMIAL:    A(j)*C**J      at L = 1;     
! GRADIENT: j*A(j)*C**(j-1)  at L = 2;    CURVATURE: (j-1)*j*A(j)*C**(j-2)  at L = 3.     
!------------------------------------------------------------------------------------     
      DIMENSION  A(*)  ;  double precision S                                                
      S = 0.                                                                                
      n1 = n  ;  if (L==3) n1 = n - 1                                                       
      DO J = n1, 1, -1                                                                      
      IF  (L==1) then                      !L= 1 ==> evaluate Polynomial,   A(j)*C**j     
         S = (S + A(j)) * C                                                               
       ELSE if (L==2) then                 !L= 2 => get Gradient, Sum A(j)*j*C**(j-1)     
         S = S*C + A(J)*J                                                                 
       ELSE if (L==3) then                 !L= 3 Curvature, Sum A(j)*j*(j-1)*C**(j-2)     
         S = S*C + A(J+1)*(J+1)*J                          !  [this starts at j= n-1]     
       ENDIF                                                                              
      END DO                                                                                
!.....................                                                                    
10    SUMVAL = S                                                                            
      RETURN  ;  END              !>>>>>>>>>>>>>>>>> END of SUMVAL <<<<<<<<<<<<<<<<<<<<     
!====================================================================================     
      FUNCTION  SUMPROD (N, A, B, L)                                                        
      DIMENSION A(*), B(*)  ;  double precision S                                           
      jd = 1                                              !Sum of  A(j)*B(j),  at L = 4     
      if (L>4) jd = L                                     !Sum A(j)*B(1-L+j*L) at L > 4     
      jb = (n-1)*jd + 1                                   ! with JD = L = 1st dim of B.     
      S  = 0.                                                                               
      DO j = n, 1, -1                                                                       
        S = S + A(j)*b(jb)                                                                
        jb= jb - jd                                                                       
      END DO                                                                                
      SUMPROD = S                                                                           
      RETURN  ;  END              !>>>>>>>>>>>>>>>>> END of SUMPROD <<<<<<<<<<<<<<<<<<<     
!####################################################################################     



      function sqrt_lfm (x)
      
!      SQRT accompanied by error check

!      leo mcnamara 12-dec-2003


      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT


!        If IprotectSQRT = 0, POLAN is allowed to crash


        if(x.lt.0.and.IprotectSQRT.eq.0) sqrt_lfm = sqrt(x)	!! CRASH CRASH


      if(x.lt.0.and.IprotectSQRT.eq.1) THEN
      error_text = error_sqrt
      sqrt_lfm = -999.
      return
      ENDIF
      
      if(x.ge.0) THEN
      error_text = error_none
      sqrt_lfm = sqrt(x)
      return
      ENDIF
      
      end