c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c+++++ qualscan V2009.10  -- October 2009 Leo F McNamara

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


c+++++ Updates since April 2008 release of qualscan V2008.4
c
c----- Modifed 05-October-2009
c      Changes to dealing wiht monotonic POLAN profiles.
c      Desired to output an EDP file even without a profile
c
c----- Modified 30-july-2009
c      Eliminate the linear interpolation in the valley region in polan profile
c
c----- Modified 03-june-2009
c      A poor F1 fit had been salvaged by setting ipoorfitF1 = 5 to ipoorfitF1 = 0
c     ICHECK32 should also have been set to 0
c----- Modified 20-May-2009
c      There were two errors in setting up the E-F valley width and depth
c      The valley was too wide and too deep.
c      Changes were made to qualscan (this file) and subroutine valley_WandD
c      which is in qualscan_subs.
c      Search for the string "c----- Modified 20-May-2009" 

c----- NOTE on 03-april-2009
c      POLAN gives some strange profiles for Hermanus/ARTIST 5  Nov 2008
c      The ones checked have important sections of the trace missing (around foF1).
c      POLAN does not crash, so no fix has been added.
c      The edp2 files have large errors bars
c----- NOTE on 03-april-2007

c----- Modified 22-march-2009
c----- qs_check11 modified 22-march-2009 to avoid crash with Ionogram for JI91J 2004 239 2100
c----- A4 scaled the second hop. All h' > 1000. [A5 was OK.]

c----- Modified MOD 12-March-2009 Options for GAIM file name [\gaim_edp2\]
c----- NEW last line in qualscan_input.dat
c----- IwantSecs = 0 gives standard GAIM file name, XXXXX_yyydddhhmm.edp2 (no seconds)
c----- IwantSecs = 1 gives file name as XXXXX_yyydddhhmmss.EDP (with seconds, diff extension)
c+++++ NOTE: The file name is actually defined in TWO places.
c      First place is for normal output
c      Second place is for files with headers only (no profiles) - see IhaveNoProfile.ge.90

c----- Modified MOD 09-march-2009. 
c      In the \polan_profiles\ files, the POLAN virtual heights were not being moved
c      up 5 locations to allow for the five extra valley points. Code was wrong.
c      The virtual heights corresponding to the valley freqs are set to 0.0.

c----- Modified 23-February-2009
c      Hermanus 2008 318 1030 crashed POLAN because there is a steep downgoing
c      F2 trace.above the gap 
c      gapmax was lowered to 1.5. but the gap is only 1.16 MHz
c      ICHECK33 has been modified to include a check on h' > 300

c----- 29-april-2008
c      calling sequence to s/r oblique_propagation modified

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


c+++++ Updates since August 2007 release of qualscan V2007.7
c----- 13 January 2008
c      POLAN called twice (always), not four times
c      code that used IwantMultiProfiles has been deleted

c      IwantProfiles = 1/2 POLAN 1/2 profiles are saved. 
c      Both profiles are always calculated (to set min fn error bars)

c      prof_min_error = 0.2!! min allowed error in GAIM fn	!! new 13-january-20088

c      Some minor clean-up was performed.

c----- Note some things that might need attention in the future:
c-----Overwrite fof2_ART if not equal to last F2 freq [LOOK FOR STRING]
c      Values of foF2 are expected to be like 10.1, not 10.15

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c+++++ Updates since February 2007 release of qualscan V2007.2 

c----- QS has been modified to cope with issues arising from the ARTIST 5 testing
c      that is described in the report Validation of QualScan when applied to
c      Ionograms scaled by ARTIST 5 (A5V.book.pdf, July 2007).
c----- That report is considered to be the documentation of those modifications.
c      No new Checks or Problems were introduced.

c----- mod 10-june-2007
c      dimensions changed 10-june-2007 to cope with Grahamstown ionograms +100
c----- mod 9-april-2007 qs_check32 modified for case where all F1 amps
c      are zero - skips to 121. Quality Figure set to 2 (no POLAN profile)
c----- mod 27-march-2007
c      Calculation of X trace, given the tabulated profile
c      Look for calculate_X_trace
c      The code in QualScan could be deleted, along with the s/r
c      if it is not wanted.
c----- Modified 8-march-2007
c      If the first POLAN profile is non-monotonic, POLAN is deemed to have failed


c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      program qualscan

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


c----- Prog to scan the h'f trace in an SAO file, flag the pecularities,
c      smooth the trace, invert the ionogram to get the N(h) profile using 
c      POLAN, assign a quality figure to an ionogram, and determine the
c      plasma frequency error bars.

c----- Prog also calculates oblique ionograms if asked nicely (IwantOblique = 1)
c----- Prog also calculates the X trace if IwantXtrace = 1
c      Look for calculate_X_trace

c----- POLAN crashes (usually SQRT error) if the ionogram is not physically
c      reasonable. To avoid irregular traces, we smooth the F1 and F2 traces
c      and give these to POLAN (if they are OK). POLAN is heavily protected
c      against crashes.

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c      						NOTES
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- The input file must have the generic name SAO.SAO (upper case for Unix scripts)

c----- Prog is controlled by the file qualscan_input.dat

c----- Prohibited freqs for some stations are provided in prohibited.dat

c----- The file flux.dat must be kept up to date

c----- fof2_ART is overwritten if not equal to last F2 freq 

c----- Asterisks in the SAO file lead to a message "QualScan does not 
c      work for ARTIST 3", and the program stops, creating an error file
c      fortran_stop.dat. Replacing all * by blank or zero in the SAO
c      file beforehand solves this problem.

c----- Fortran crashes are trapped into fortran_stop.dat

c----- The version of POLAN used is not the latest (POLAN04), but tests showed there
c      are no significant differences between the two versions, and the current
c      version is heavily protected against crashes.

c----- Directory structure: (\multi_profiles no longer required 13-january-2008)

c      qualscan
c      	artist_profiles
c      	gaim_edp2
c      	oblique
c      	plot_files
c      	polan_profiles

c===========================================================================

c-----ICHECK = 1 No legitimate foF2 or Cheby Coeffs supplied
c-----ICHECK = 2 Trace too short to process
c-----ICHECK = 3 Compare the magnetic dip angle with IGRF
c-----ICHECK = 4 Compare the gyrofrequency with IGRF
c-----ICHECK = 5 Check ARTIST scaled value of foE
c-----ICHECK = 6 Check ARTIST value of hmE
c-----ICHECK = 7 Check ARTIST scaled value of foF1 against OT model
c-----ICHECK = 8 No longer used
c-----ICHECK = 9 The amplitude quality figure
c      	PROBLEM 1---The Amplitude Quality Figure is too small
c-----ICHECK = 10 No longer used
c-----ICHECK = 11 Check the scaled F2 h' trace for smoothness & validity
c      	PROBLEM 6---smoothed F2 trace is not good or not valid
c-----ICHECK = 12  Look for any discontinuities in the F2 trace
c      	PROBLEM 7---Too many sudden jumps in F2 trace
c-----ICHECK = 13 No longer used
c-----ICHECK = 14 No longer used
c-----ICHECK = 15 Check the ARTIST value of hmF2 against the Dudeney value
c-----ICHECK = 16 Reject M3000 value if it comes from one end of the trace
c      	PROBLEM 2---M(3000)F2 comes from the end of the F2 trace
c-----ICHECK = 17 No longer used
c-----ICHECK = 18 Scan for flat sections in the F2 trace (probably Es)
c      	PROBLEM 5---Too long a horizontal section in F2 trace (ES?)

c***** 19,20,21,22,23,24 performed after call to POLAN

c-----ICHECK = 25 Compare the first ARTIST real and virtual heights 
c      	PROBLEM 3---Real ht is too close to the virtual ht at start of F2
c-----ICHECK = 26 Check for discontinuous start of F2 trace
c-----ICHECK = 27 Check for virtual heights not set (=9999 or 0)
c-----ICHECK = 28 Check that the value of hmF2 is not too low
c      	PROBLEM 9---ARTIST value of hmF2 too low
c-----ICHECK = 29 look for foF2 very near prohibited frequency
c      	PROBLEM 14---foF2 is very near a prohibited frequency
c-----ICHECK = 30 Last h' segment(s) has too high a slope - chop the ARTIST trace
c-----ICHECK = 31 Too long a linear segment in F2 trace
c-----ICHECK = 32 Check the scaled F1 h' trace for smoothness
c      	PROBLEM 10---Could not fit good or any LSF curve through F1 trace	  
c-----ICHECK = 33  Check for too long a gap between trace segments
c      	PROBLEM 12---Too long a gap in trace above a critical
c-----ICHECK = 34  Check if there is a corner in the F2 trace
c      	PROBLEM 13---There is a corner in the F2 trace
c-----ICHECK = 35  Check that average F2 slope increases over the last half of trace
c      	PROBLEM 11---Average slope decreasing in last half of trace
c-----ICHECK = 36  Check that average F2 slope over last 6 points is > noise
c      	PROBLEM 15---Slope of F2 trace is too low at end
c-----ICHECK = 37 No longer used 
c-----ICHECK = 38  Check if fmin is too high to get reliable profile
c      	PROBLEM 16--- fmin too high
c-----ICHECK = 39  The scaled trace does not match the ionogram echoes
c      	PROBLEM 17--- too few non-zero amplitudes along trace
c-----ICHECK = 40  The F2 virtual heights are probably mostly from ES echoes
c-----ICHECK = 41  Check that foF2 is not too close to foF1
c         PROBLEM 18--- foF2 is suspiciously close to OT model value of foF1

c***** After call to POLAN

c-----ICHECK = 19 check differences between ARTIST & POLAN foF2
c-----ICHECK = 20 Compare POLAN vs ARTIST hmF2
c      	PROBLEM 4---Too large a difference between POLAN & ARTIST hmF2
c-----ICHECK = 21  The quality of the POLAN peak fit
c      	PROBLEM 8---Large errors in POLAN peak fit
c-----ICHECK = 22 No longer used
c-----ICHECK = 23 No longer used
c-----ICHECK = 24 No longer used  

c**********************************************************************

c polpars.pol  --  INCLUDE file for all POLAN subroutines.                 July 2003.
c Input data transferred to FV, HV (index KV).  Calculatd results=> FR,HR (index KR).
c      dimensions changed 10-june-2007 to cope with Grahamstown ionograms +100

      COMMON /POL/ Fv(501), Hv(501), Fr(400), Hr(400), B(99,20),Q(20)        !data arrays
      COMMON /POL/ Fh,ADip, Mode,Mod0, FA,HA, Hs, Fc,Fcc, TCont,List     !analysis params
      COMMON /POL/ HMax,SH, Parht, HVal,VWidth,VDepth, Xwat, TestL,
     a TestM  !profile params
      COMMON /POL/ maxb,nf, nr,nl, nx, ms,MT,jm, lk,Kr,KrM, Kv,maxv,
     a Mf,nc, idx !counters

c----- MOD 25-march-2009 Calculate profile half width
      common/POLAN_halfwidth/polHalfWidth
c----- MOD 25-march-2009 Calculate profile half width

      real*8 date,alt,colat,elong,xx,yy,zz,ff

      INTEGER*4 INUNIT,KOUNT      !! inunit is sent to adep_sub.for
      
c-----Declarations for ARTIST stuff - mainly a copy from adep_sub.for
c      Sporadic E dimensions increased to 250 to cope with a Ramey ionogram
c      FF199917606252130
      LOGICAL   EOF
      INTEGER*2 IREAD,IERR      !! in calling sequence
      INTEGER*2 IDFI(80),IAF(60),IOTF(666),IOTHF(666),
     +IOAF(666),IODF(666),IOTF1(150),IOTHF1(150),IOAF1(150),
     +IODF1(150),IOTE(150),IOTHE(150),IOAE(150),IODE(150),
     +IXTF(400),IXAF(400),IXDF(400),IXTF1(150),IXAF1(150),
     +IXDF1(150),IXTE(150),IXAE(150),IXDE(150),MEDF(20),
     +MEDE(20),MEDES(20),IEDF(120),IOTSE(250),IOASE(250),IODSE(250),
     +IEDFTP(120)
      REAL*4 OTF(666),OTHF(1000),OTF1(150),OTHF1(1000),OTE(150),
     +       OTHE(1000),XTF(400),XTF1(150),XTE(150),OTSE(250),
     +       HTAB(999),FTAB(999)
      REAL*4 SCALED(120),GCONST(16),DTT(16),FTOF(666),FTOF1(150),
     +       FTOE(150),FTXF(400),FTXF1(150),FTXE(150),THF2(20),
     +       THF1(20),THE(20),THVAL(20),FTOSE(250)
      REAL*8 QPCOEF(121)
      CHARACTER*120 SYSDES,OPMSG
      CHARACTER*1 IPREF(120),QL(120),DL(120)

c-----Declarations for ARTIST stuff

      character*5 ctem5,statid
      character*60 filename,profile_name
      character*20 dummy
      character*2 chour,cmin,csec
      character*3 nameofmonth(12),cdayno,cdayno_prev
      character*4 cyear4
      character*11 ctem11
      character*17 version   ! 06Oct09
      character*17 ctem17
      character*19 ctem19
      character*9 ctem9
      character*8 ctem8
      character*1 khit,one,two,three,four,five,six,seven,
     a eight,nine,ten,eleven,twelve,thirteen,fourteen,fifteen,sixteen,
     a seventeen,eighteen,header(80),kh(40),ctemp(20),chits(20)

      character*1 blank
      character*5 ursi_code(100),ctemp5
      character*3 ursi_number(100),ctemp3
c----- Date & time declarations
      character*8 cdate
      character*10 ctime1,ctime2
      character*5 czone
      character*17 creason,blank17


      dimension ivalues(10)

      dimension freq(889),h_prime(889),qq(889)        !!      POLAN
      dimension paul(889),pp(889),coeffs(20),x(889),y(889),
     a z(889),cheb(100),temp(889),fluxmon(30,12)
      dimension fn(889),virtht(889),realht(889)
      dimension diffit(889),jumpht(30),htjump(30),iproblem(50)
      dimension xlsf(889),ylsf(889)
      dimension prohibited(20)

      dimension kday(9000),khour(9000),kmin(9000),khit(18,9000) !! worst cases
      dimension fof2_out(9000),hmf2_out(9000),sh_out(9000),
     a tec_out(9000)

      dimension h_fof2(24,9000),h_hmf2(24,9000),h_shf2(24,9000)	!! vs UT
      dimension k_fof2(24),k_hmf2(24),k_shf2(24)	!! vs UT
      dimension xx(9000),fof2_med(24),hmf2_med(24),shf2_med(24)
      dimension slope(889),correl(889)
      dimension ihmf2_med(24),ishf2_med(24)

      dimension config(4),site(4)		!! POLAN parms
      dimension f1out(889),h1out(889),f2out(889),h2out(889)	!! POLAN is called 4 times
      dimension f3out(889),h3out(889),f4out(889),h4out(889)
      dimension qp(400) !! NOTE: Required, even though QP is optional in POLAN
      dimension fx(889),hx(889),herr(2,889)

      dimension htdiffs(889)
      dimension f2_smoothed(889),f1_smoothed(500)
      dimension obs_fof2(150,24),iobs_fof2(150,24)	  !! 150 days, 24 on the hour
      dimension iqut(96,4),iqut_total(96),iqtem(4)	!! # of cases for each UT and quality figure

      dimension s_freq(889),s_hprime(889)	!! for chopping the end off the trace

      dimension yy(9000),ww(9000),zz(9000),ax(9000),ay(9000)

      dimension ifreq(400),ipolht(4,400),ifx(400),ihx(4,400)
      dimension fn1(600),fn2(600),fn3(600),fn4(600),errorbar(600)
      dimension Y2(1000)	!! for spline interpolation
      dimension jsum(4),kount_of_checks(50)

      dimension art_ht_at_pol_fn(600),art_fn_at_pol_fn(600)
      dimension fnpol(700),realpol(700)
      dimension fnpro_art(1380),fnpro_pol(1380),fnpro_gmf(1380)
      dimension fn_error_bar(700)

      dimension polplot_fr(700),polplot_hp(700),polplot_hr(700)
      dimension polan_fn_errorbars(889)

      dimension freq_iono(300),virt(300)	!! mod 27-march-2007

      dimension kartcon(5,24),artcon(5)	!! LT variation of ARTIST confidence 6-july-2007
      dimension rhf2_art(10)	!! 9-july-2007


      COMMON /site/FB,DIP, aLat,TLoc,aMon,aFlx, cstrt,cvaly,cmod,clst !Field; def params
      
      character*10 error_text,error_sqrt,error_none !! POLAN SQRT protection
      common /lfm_errors/ error_text,error_sqrt,error_none
      common /lfmerrors2/ IprotectSQRT
      common /POLAN_no_O_data / no_O_data	!! flag set if POLAN finds no O data

c      Used to retrieve the error in the scale height that is calculated by
c      POLAN, but not returned in the f,h array. I hate labelled common!
      common / leomac / Ssh,devs	!! dev of scale height

      data nameofmonth / 'JAN','FEB','MAR','APR','MAY','JUN',
     A    'JUL','AUG','SEP','OCT','NOV','DEC' /
      data one,two,three,four,five,six,seven,eight,nine, ten, eleven/
     a     '1','2','3',  '4', '5', '6','7',  '8',  '9', 'A', 'B'/
      data twelve, thirteen, fourteen, fifteen, sixteen, seventeen/
     a      'C',   'D',       'E',      'F',     'G',     'H' /
      data eighteen/
     a      'I' /
      data idayno / 0 /
      data numdays/ 0 / !! number of days processed
      data idoy1 / 0 /

c===========================================================================
c===========================================================================

c----- VERSION NUMBER
      version = "qualscan V2009.10"

c===========================================================================
c===========================================================================

c----- Number of problems considered - dimension KHIT accordingly
c     Also change data statements - look for 18(2x,a1) for 18 problems
      numprob = 18      !! used for writes --- Check formats
      maxkases = 9000   !! max number of ionograms with problems - Dimension
      ndim889 = 889
      ndim = 889			!!		POLAN array size

c----- Initialize khit - hardwired
      blank = " "
      blank17 = "                 " !! not related to numprobs
      DO i = 1,numprob
      DO j = 1,9000
      khit(i,j) = blank
      ENDDO
      ENDDO

c----- Initialize counts of checks
      numcheck = 39
      DO i = 1,numcheck
      kount_of_checks(i) = 0
      ENDDO

c----- Error messages for POLAN calls
      error_sqrt = "Error SQRT"		!! /lfm_errors/
      error_none = "Error None"		!! /lfm_errors/
      error_text = "abcdefghij"

      earthrad  = 6371.   !!      radius of the Earth (for gyro)
      gyro_ht_ART = 300.	!!		height for specified gyro freq
      pi = atan (1.0) * 4.
      izero = 0
      cdayno_prev = "xxx"

      rms_em3 = 0.	!! to get stats of M(3000)F2 ARTIST-smoothed
      num_rms_em3 = 0

      em3_rms_def = 1.5	!!  Default value of the % error bar for M(3000)F2

      IprotectSQRT = 1	!! Set to zero to allow POLAN to crash

      IneedFlux = 1	!! to read flux with first "good" ionogram

c===========================================================================
c===========================================================================

c++++ SPECIFIED PHYSICAL PARAMETERS !!!!!!! Change these at your own risk

c-----Allowable differences between ARTIST and "other" values, + other 
c      allowable errors     / restrictions
      aqf_min = 50.		!!	If AQF is less than this %, get PROBLEM = 1
      delay_min = 5.		!!	min allowed diff between first ARTIST F2 real & virt hts from 10 to 5
      del_foF1F2 = 0.5	!!  min allowed diff between foF2 and model (OT) value of foF1
      diff_dip  = 10.     !!	dip angle ICHECK = 3
      diff_foe  = 0.3     !!	foE   ICHECK = 5
      diff_fof1 = 0.5     !!	foF1  ICHECK = 7
      diff_fof2 = 0.2     !!	foF2  ICHECK = 19
      diff_gyro = 0.2     !!	gyro freq ICHECK = 4
      diff_hme  = 5.      !!	hmE	  ICHECK = 6
      diff_hmf2_DUD = 30. !!	Max diff between Dudeney & ARTIST hmf2 ICHECK = 15
      diff_hmf2_POL = 50. !!	Max diff between POLAN & ARTIST hmf2 ICHECK = 20	
      diffforbfreq = 0.1  !!  check for foF2 close to a prohibited freq PROB 14
      diffitmax = 50.		!!  Max allowable error in Cheby LSF for F2
       eps = 1.e-5			!!  Accuracy figure for Cheby LSF
      eta = 1.e-5			!!  Accuracy figure for Cheby LSF
      fr_max_flat = 0.67	!!	fractional allowed length of F2 flat section PROBLEM 5
      fmin_ratio = 0.5	!!  require that fmin/foF2 < fmin_ratio	CHECK = 38
      gapmax = 1.8		!!  allowable freq gap after foE or foF1 PROBLEM 12
      hmf2_min = 200.     !!	Assume hmF2 cannot be below this value. PROBLEM 9
      hseclastmin = 200.	!!  Second last F2 virtual height must exceed this value (Check 40)
      max_same_slope = 20	!!  CHECK 31 - max # of points in F2 trace with same slope
      nchebF1 = 6			!! default order of Cheby LSF for F1 (could be decreased)
      nchebF2 = 10		!! default order of Cheby LSF for F2 (could be decreased)
      nslope = 6			!!  Aver F2 slope over last NSLOPE points = slope_end_min
      percslope_min = 0.2 !!  If % slope of F2 trace, CHECK 11, IsStraightLine = 1 
      prof_min_error = 0.2!! min allowed error in GAIM fn	!! new 13-january-2--8
      rms_fac = 10.       !!	Factor for RMS diff of scaled & fitted h' PROBLEM 6
      rms_F1 = 35.        !!	Allowable error in LSF for F1 trace	 PROBLEM 10
      sigf_pol = 0.5		!!	Allowable errors in POLAN foF2	PROBLEM = 8
      sigh_pol = 15.		!!	Allowable errors in POLAN hmF2	PROBLEM = 8
      sigsh_pol = 15.		!!	Allowable errors in POLAN shF2	PROBLEM = 8
      slope_end_min = 10	!!  min aver slope of last NSLOPE points (must > h' noise) PROBLEM 15
      slopechange = 700.  !!  change in slope that defines a corner PROBLEM 13
      spline_ht_gap = 50. !! max allowed E-F height gap (else no spline interpolation)
      tan_freq_min = 0.7	!! tangent freq must exceed tan_freq_min * foF2 Check 16
      too_high_slope= 900.!!  max value for slope at end.
      trace_len_min = 0.5 !!  trace must be at least this long ICHECK = 2 & others
      start_uncert = 20.	!!  starting height is uncertain to +/- this percentage
      valley_uncert = 20.	!!  valley width is uncertain to +/- this percentage
      virtht_max = 1000.	!!  maximum value of F2 virtual height (trace chopped)

cXXXXX valley_uncert and virtht_max  are not used in QualScan V2009.6
      
c++++ END OF SPECIFIED PARAMETERS !!!!!!! Change these at your own risk

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c       LOGICAL UNIT NUMBERS2
      ipolout   = 2   !!      POLAN output file (hard-wired to unit 2 in POLAN)
      iflagfile = 3   !!      Output file showing uncertain (flagged) values
      inunit    = 4   !! IN   SAO file
      ifluxunit = 7   !! IN   Observed 10 cm flux, monthly median 1990 2010 (nominally)
      iusefuls  = 9   !!      Output file of useful information
      idb       = 13	!!		Debug file
      ioutput   = 19  !!      Problems, peak parms, etc for each ionogram
      iprohibited= 20	!! IN   prohibited frequency bands
      input_qc =  51	!! IN   Input data file to control the run
      logfile =   52	!!		Log file for any Fortran STOPs
      ipolpro =   31      !!		POLAN N(h) profile (one per iono)
      iartpro =   32	!!		ARTIST N(h) profile (one per iono)
      istatlist = 33	!! IN   Corresponding URSI codes and station numbers
      multipro  = 34  !!	    POLAN & ARTIST Profiles + error bars
      NGDCfile =  53  !!		List of ionograms with problems etc
      NGDCqual =  54	!!		List of ionograms plus quality figure
      iob_unit =  55	!!      Oblique ionogram or elevation angles
      no_call =   57	!! OUT  List of ionograms for which POLAN was not called
      igaim	=   59	!! OUT  GAIM EDP2 file with additional parms


c     Plot files - You can change the writes to these units (Voids warranty)
      ipeakparm = 14 !!		POLAN & ARTIST fof2, hmF2, shf2
      idudhmf2  = 17  !!      Dudeney vs ARTIST hmF2
      iherrvsaqf =18	!!      POLAN - ARTIST hmF2 error vs AQF
      ipeakT  =   41	!!		ARTIST fof2 & hmF2 vs UT (everything you could ask for)
      i3hmf2 =    46	!!		ART, DUD & POL values of hmf2
      ipeak =     49	!!		Peak parms vs UT
      ipoldev =   56	!!		POLAN dev f, h, sh + slope at end
      intf =      58	!!		Normalized tangent frequency

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      open (unit=inunit,   file='SAO.SAO')								!!  4	INPUT
      open (unit=ifluxunit,file='flux.dat')								!!  7	INPUT
      open (unit=iprohibited,file="prohibited_frequencies.dat")			!!  20	INPUT
      open (unit=istatlist,file='stationlist.dat')						!!  33	INPUT
      open (unit=input_qc, file='qualscan_input.dat')						!!  51	INPUT

c LATER      	open(unit=idb,file="debug.dat")								!!  13  debug  modified 16-may-2008

      open (unit=ipolout,  file='polout.dat')								!!  2
      open (unit=iflagfile,file='flags.dat')								!!  3
      open (unit=iusefuls, file='usefuls.dat')							!!  9
      open (unit=ioutput,  file='processed.dat')							!!  19
      open (unit=NGDCfile, file="ngdc_unreliable_f2_parms.dat")			!!  53
       open (unit=NGDCqual, file="ngdc_quality_figures.dat")				!!  54
      open(unit=no_call,file="ionograms_no_call_to_POLAN.dat")			!!  57

c LATER      open(unit=ipolpro,file=filename)	!! POLAN profile			!!  31
c LATER      open(unit=iartpro,file=filename)	!! ARTIST profile			!!  32
c LATER      open (unit=multipro ,file="multi_profiles/........				!!  34
c LATER      open(unit=iob_unit,file=filename) -- in s/r oblique_propagation	!!  55 
c LATER      open (unit=igaim,file="gaim_edp2/........						!!  59

c      See also if(IwantPlotFiles.eq.1) THEN open the plot files

c===========================================================================
c      Using POLAN (Notes from John Titheridge - see UAG-93, page 128)
c===========================================================================

c      hprime_E	h' at foE = 0 for Chapman peak and normal valley
c      			h' = 10 for a peak, with no valley (monotonic)
c      			h' = negative for cusp-type discontinuity only
c      hprime_F1	h' at foF1 = 0 for Chapman peak and normal valley
c      			h' = 10 for a peak, with no valley (monotonic)
c      			h' = negative for cusp-type discontinuity only

      hprime_E = 0
      hprime_F1 = -1 !! (for cusp-type discontinuity)

c-----VALLEY= 0.0 or 1.0  uses a valley width equal to the initial default
c      value of twice the local scale height.  The initial default depth is 0.05
c      MHz.  The calculated depth is scaled according to (calculated width)**2. 
c        Alternative solutions may be obtained as follows:
c     VALLEY = 10.0  gives a monotonic (no valley) analysis.
c     Valley =  5.0  gives a maximum valley (upper reasonable limit) analysis.
c     Valley =  0.1 to 5.0  multiplies the standard valley width by this factor.
c     Valley = -.01 to -.99 uses  -2.0 * Valley  as the initial depth
c                                (instead of the default value of 0.05 MHz).
c     Valley = -1.0  iterates both valley depth and width for best fit, with 
c                 x-ray data.  (-1.D iterates from an initial depth of 0.D MHz).
c     Valley = -2.0 to -50. specifies a fixed valley width of 2*int(-Valley) km.
c                           Any decimal part D specifies a depth of 2*D in MHz.

cxxxxx valley = 0.      !! Standard valley - Use 10 and 5 to get limits of valley
cxxxxx SET UP after call to valley_WandD

c-----Mode of operation
c      AMODE  sets the type of analysis, as listed below.   Zero uses mode 6.
c      Use Amode+10. for 12-point integrals, for high accuracy at large dip
c      angles (this is done automatically, at  DIP > 60, when Amode=0).
c      For denser (e.g. digital) data, with more than 30 points in one layer,
c      use a higher-order mode.  Thus AMODE = 9. gives maximum detail,  or
c      AMODE= 95. gives single-polynomials with 5, 9 terms for the E, F2 layers.
c      Values of Amode greater than 29.0 are used to specify the number of
c     polynomial constants to be used to describe each ionospheric layer.
c       e.g. 80.  uses an 8-term real height polynomial for each separate layer.
c            85.  uses 8 terms for the final layer and 5 terms for lower layers.
c      853. uses 8 terms for the last, 3 terms for the first, and 5 terms
c           for any intermediate layer.
c      Setting AMODE negative causes physical relations to be omitted from the
c      start and valley calculations. 

      AMODE= 0.	!! Mode of operation -- Most robust found by LFM

c      Output/printing options	- Output goes to Unit 2 (hardwired in POLAN)
c     LIST = 0   prints results for the start, peak and valley regions only.
c            1   adds one line of output showing the frequency range and the
c                polynomial coefficients calculated at each step.
c            2, 3   add additional output.
c            4 to 9 show the data used at each step, and the calculated
c                   polynomial coefficients:
c               5   shows each set of simult equations, in the call to SOLVE;
c               6/7/8/9 give detail in the start/reduction/peak/valley steps.
c
c            LIST negative  suppresses most trace output below the first peak.
c            LIST= -10 suppresses all output, even the normal layer summaries.

      aLIST = 0	!! NOTE: POLAN writes to unit 2

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c      Control parms qualscan_input.dat
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c   1      IwantUSEFULS; 1 to write LOTS of interesting info to file; else 0
c   1      IwantPlotFiles; 1 to set up useful plot files; ELSE 0
c   0      IwantOblique; 1 to save elev ang vs operating freq; ELSE 0
c   1      IwantProfiles; 1 to save POLAN 1 + ARTIST profile; 2 for POLAN 2 profile ++
c   1      IwantXtrace: 1 to calculate X trace for ARTIST profile (can crash). Else 0 [not calc if IwantUSEFULS = 0]
c   1      IwantGAIMfile; 1 to save EDP2 data for GAIM (in \qualscan\gaim_edp2\); else 0 
c   1      IwantGAIMalts; 1 to save EDP2 recs only for GAIM altitude grid. 0 -> 1 km grid
c   1      IwantDebug; = 1 to write out messages to debug.dat along the way. Else 0
      
      read(input_qc,*) IwantUSEFULS
      read(input_qc,*) IwantPlotFiles
      read(input_qc,*) IwantOblique
      read(input_qc,*) IwantProfiles
      read(input_qc,*) IwantXtrace
      read(input_qc,*) IwantGAIMfile
      read(input_qc,*) IwantGAIMalts
      read(input_qc,*) IwantDebug
      read(input_qc,*) IwantSecs	!! MOD 12-March-2009

      if(IwantDebug.eq.1) open(unit=idb,file="debug.dat")			!!  13  debug

      if(IwantProfiles.eq.0) IwantProfiles = 1	!! 0 is not valid option
c      makeGAIMfile also requires that IwantProfiles be set to 1 or 2.

c      if(IwantGAIMfile.eq.1) IwantMultiProfiles = 1
c      The 2 POLAN profiles are used to set a threshold fn error

c===========================================================================
c===========================================================================

c----- Write out header for processed.dat
      write(ioutput,7653)
7653  format(9x,'YY DDD HHMMSS',2x,"Problems Found",6x,"POLAN #1",
     a 4x,"POLAN #2",4x,"ARTIST",3x,"Slope"," FOM_F1 FOM_F2 AMP QUAL"/) 

c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c      Open plot files. The Windows \ can be replaced successfully by the Unix /
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c-----Plot files
      if(IwantPlotFiles.eq.1) THEN

c      epoch + POLAN & ARTIST fof2, hmF2, shf2 ,slope at end of trace
      open(unit=ipeakparm,file='plot_files/peakparms.dat')	!!  14
c      Dudeney hmF2 vs ARTIST hmF2
      open (unit=idudhmf2,file='plot_files/dud_hmf2.dat')		!!  17
c      hmf2_pol - hmf2_art vs amplitude quality figure
      open(unit=
     a iherrvsaqf,file='plot_files/herrvsaqf.dat')      		!!  18
c----- ARTIST foF2 and hmF2 vs UT and LT
      open(unit=ipeakT,file ="plot_files/peak_vs_time.dat")	!!  41
      open(unit=i3hmf2,file="plot_files/hmf2_3vals.dat")		!!  46
c----- POLAN deviations in fitted peak parms
      open(unit=ipoldev,file="plot_files/pol_devs.dat")		!!  56
c----- Normalized tangent frequency
      open(unit=intf,file="plot_files/tangent_freq.dat")		!!  58

      ENDIF	!! IwantPlotFiles
      	
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Read in corresponding URSI codes and numbers from stationlist.dat
      kll = 0
      DO i = 1,200
      read(istatlist,4443,end=4445) ctemp5,ctemp3
4443  format(a5,1x,a3) 
      kll = kll + 1
      ursi_code(kll) = ctemp5
      ursi_number(kll) = ctemp3
      ENDDO
4445  continue
      num_ursi = kll

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Initialize the problem counters
      kasenum = 0	!!	counter for those ionograms with PROBLEMS
      kount = 0   !!  incrementing count of number of ionograms
      kprob1 = 0   !!    number of cases with PROBLEM 1
      kprob2 = 0   !!    number of cases with PROBLEM 2
      kprob3 = 0   !!    number of cases with PROBLEM 3
      kprob4 = 0   !!    number of cases with PROBLEM 4
      kprob5 = 0   !!    number of cases with PROBLEM 5
      kprob6 = 0   !!    number of cases with PROBLEM 6
      kprob7 = 0   !!    number of cases with PROBLEM 7
      kprob8 = 0   !!    number of cases with PROBLEM 8
      kprob9 = 0   !!    number of cases with PROBLEM 9
      kprob10 = 0  !!    number of cases with PROBLEM 10
      kprob11 = 0  !!    number of cases with PROBLEM 11
      kprob12 = 0  !!    number of cases with PROBLEM 12
      kprob13 = 0  !!    number of cases with PROBLEM 13
      kprob14 = 0  !!    number of cases with PROBLEM 14
      kprob15 = 0  !!    number of cases with PROBLEM 15
      kprob16 = 0  !!    number of cases with PROBLEM 16
      kprob17 = 0  !!    number of cases with PROBLEM 17
      kprob18 = 0  !!    number of cases with PROBLEM 18

c======================================================================
c======================================================================

      iononumber = 0				!! ionograms read from SAO
      num_trace_too_short = 0		!! F2 trace is too short for tests
      num_no_call_POLAN = 0		!! POLAN not called
      num_call_to_POLAN = 0		!! POLAN called
      num_POLAN_had_sqrt_errors=0 !! Error return from POLAN
      num_no_good_value_fof2 = 0	!! foF2 is no good
      num_no_O_data = 0			!! POLAN checks for no O data
      num_ionograms_QCd = 0	    !! # of ionograms QCd (long enough)
      num_fmin_too_high = 0		!! # with fmin > fmin_ratio * foF2
      num_smoothed_no_good = 0	!! bad smoothed F2 fit
      num_ht_9999 = 0				!! some virtual heights not set (9999)
      num_ARTIST_no_confidence =0	!! # with ARTIST confidence (iaafcon) > 40
      num_POLAN_equal_heights = 0	!! POLAN (E) profile has equal heights
      num_POLAN_gave_no_points = 0 !! POLAN returned no profile points
      num_no_good_value_hseclast = 0	!! Second last h'(F2) is too low

      num_IhaveNoProfile90 = 0	!! no GAIM EDP2 profile for different reasons
      num_IhaveNoProfile91 = 0
      num_IhaveNoProfile92 = 0
      num_IhaveNoProfile93 = 0
      num_IhaveNoProfile94 = 0
      num_IhaveNoProfile95 = 0
      num_IhaveNoProfile96 = 0
      num_IhaveNoProfile97 = 0
      num_IhaveNoProfile98 = 0
      num_IhaveNoProfile99 = 0
      num_IhaveNoProfile100 = 0

c======================================================================
c======================================================================

c-----Read in the ionograms one at a time, and process them

      call DATE_AND_TIME(cdate, ctime1, czone, ivalues)

 15   CONTINUE  !! prog cycles back to here for new ionogram

c======================================================================
c======================================================================

      kflag = 0   !! set to 1 if a Problem is encountered with this ionogram
      IhaveNoProfile = 0	!! flag used to write headers only to GAIM EDP2 file

      istop_error = 0	!! Fortran STOPs reset this parm
      idprev = idayno !! idayno is initialized to zero by DATA statement
      DO i = 1,50
      iproblem(i) = 0
      creason = blank17
      ENDDO

      FOM_F1fit = 0.
      FOM_F2fit = 0.
      DO i = 1,ndim889
      freq(i) = 0
      s_freq(i) = 0
      h_prime(i) = 0
      s_hprime(i) = 0
      polan_fn_errorbars(i) = prof_min_error	!! default min error - used for GAIM profiles
      f1out(i) = 0.	  !! POLAN output
      f2out(i) = 0.
      f3out(i) = 0.
      f4out(i) = 0.
      h1out(i) = 0.
      h2out(i) = 0.
      h3out(i) = 0.
      h4out(i) = 0.
      ENDDO

      no_O_data = 0	!! set to 1 by POLAN if there is no O data
      devs = 0
      iPOLANok = 1
      second_deriv_at_end = 999. !! PROBLEM = 11
      h1_pol = 0.	!! real height at first F2 freq
      h1_art = 0.

      icheck1 = 0		  !! "ugly is as ugly does"
      icheck2 = 0
      icheck3 = 0
      icheck4 = 0
      icheck5 = 0
      icheck6 = 0
      icheck7 = 0
      icheck8 = 0
      icheck9 = 0
      icheck10 = 0
      icheck11 = 0
      icheck12 = 0
      icheck13 = 0
      icheck14 = 0
      icheck15 = 0
      icheck16 = 0
      icheck17 = 0
      icheck18 = 0
      icheck19 = 0
      icheck20 = 0
      icheck21 = 0
      icheck22 = 0
      icheck23 = 0
      icheck24 = 0
      icheck25 = 0
      icheck26 = 0
      icheck27 = 0
      icheck28 = 0
      icheck29 = 0
      icheck30 = 0
      icheck31 = 0
      icheck32 = 0
      icheck33 = 0
      icheck34 = 0
      icheck35 = 0
      icheck36 = 0
      icheck37 = 0
      icheck38 = 0
      icheck39 = 0
      icheck40 = 0

c----- Zero the E and F1 arrays in case there is none for this iono
      DO i = 1,150
      ftoE(i) = 0.
      otE(i) = 0.
      ftoF1(i) = 0.
      otF1(i) = 0.
      ENDDO
c----- Re-set Cheby coeffs in case not supplied with this ionogram
      DO i = 1,20
      THF2(i) = 0.
      THF1(i) = 0.
      THE(i) = 0.
      THVAL(i) = 0.
      ENDDO

      polHalfWidth = 0.	!! mod 26-march-2009
      
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Read SAO file - 1996 version

ccc      if(cdayno.eq."302") go to 16 To terminate a run before crazy SAO files crash qualscan

      write(idb,1325)
1325      format(/" Entering READSAO")
      call READSAO  !! order of EOF & inunit changed for Version 96050810
     +   (EOF,inunit,IDFI,GCONST,Sysdes,IPREF,SCALED,IAF,
     +   DTT,IOTF,IOThF,IOAF,IODF,ftOF,IOTF1,IOThF1,IOAF1,IODF1,ftOF1,
     +   IOTE,IOThE,IOAE,IODE,ftOE,IXTF,IXAF,IXDF,ftXF,IXTF1,IXAF1,
     +   IXDF1,ftXF1,IXTE,IXAE,IXDE,ftXE,MEDF,MEDE,MEDES,THF2,THF1,
     +   THE,QPCOEF,THVAL,IedF,IOTsE,IOAsE,IODsE,ftOsE,
     +   OTF,OThF,OTF1,OThF1,OTE,OThE,XTF,XTF1,XTE,OTsE,
     +   HTAB,FTAB,QL,DL,IedFTP,
     +   IREAD,IERR)

      if(EOF) go to 16	!! no more ionograms

      write(idb,1319) EOF
1319  format(" Returned from READSAO",L3)	!! modified 16-may-2008 F3.0 to L3

c      write(6,660) (idfi(i),i=1,80)
660   format(" IDFI",10i3)
c      write(6,660)

c----- Count the number of ionograms processed

      num_ionograms_QCd = num_ionograms_QCd + 1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- See if this is an ARTIST 5 SAO file (look for "ARTIST 5")
      IhaveArtist5 = 0
      DO i = 10,60
      j = i + 8
      ctem8 = sysdes(i:j)
      if(ctem8.eq."ARTIST 5") THEN
      IhaveArtist5 = 1
      go to 1733
      ENDIF
      ENDDO
1733  continue

c      print*," IhaveArtist5 =",IhaveArtist5
c      pause

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- 3-july-2007 This section reactivated (and modified).
c----- Ionograms with iaf(10) = 44 or 55 are skipped as "could not scale"

c----- ARTIST confidence level (Artist Analysis Flags -> aaf)
c      A value of 55 (actually 5 and 5) sets the Quality Figure to 1. [icheck=1]
c      Check is for iaafcon > 40
      iaafcon = 55	!! no confidence at all
      if(idfi(5).gt.0) iaafcon = iaf(10)
c----- If not ARTIST 5, we dont trust the Confidence Levels
      if(IhaveArtist5.eq.0) iaafcon = 11
      if(iaafcon.gt.40) THEN
      num_ARTIST_no_confidence = num_ARTIST_no_confidence + 1
      ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Re-name counters for convenience
      idfi7 = idfi(7)
      idfi9 = idfi(9)	 !! number of amplitudes; ioaf = amplitudes
      idfi11 = idfi(11)
      idfi12 = idfi(12) !! F1 layer
      idfi16 = idfi(16)
      idfi17 = idfi(17) !! E layer
      idfi21 = idfi(21)
      idfi80 = idfi(80)

c----- Check for X trace
      if(idfi(22).gt.0) THEN
c      print*, " Have X-trace points",idfi(22),idfi(23),idfi(25)
c      pause
      ENDIF

c----- See if there are any F2 Chebychev coeffs
      num_cheby = 0
      DO i = 1,5
      if(thf2(i+4).ne.0.) num_cheby = num_cheby + 1
      ENDDO

c-----Define the frequency interval
      freq_int = ftof(2) - ftof(1)

c-----Geophysical constants -- GCONST
      gyrofreq = gconst(1)
      dipangle = gconst(2)

      statlat  = gconst(3)
      statlon  = gconst(4)        !!      EAST longitude
      if(statlon.lt.0.) statlon = statlon + 360.      !!  if negative

c----- Ionogram counter
      iononumber = iononumber + 1

c----- Find the URSI station ID - do not include different stations in sao.sao
      if(iononumber.eq.1) THEN
      call find_ursi_code
     a (sysdes,num_ursi,ursi_code,ursi_number,statid,iderror)

c      DO i = 1,num_ursi
c      print*,i,"  ",ursi_code(i),"  ",ursi_number(i)
c      ENDDO
c      print*,statid,ierror

      if(iderror.ne.0)  THEN
      istop_error = 1
      print*," Could not determine URSI 5-char code"
      go to 6666	!! effectively a Fortran STOP 
      ENDIF
      ENDIF	!! iononumber.eq.1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----The Ionogram Sounding Preface gives the universal time
c     We need to calculate local time, solar zenith angle, etc
c
c    Find the date - YEAR, DOY, HH, MM
c    All IPREF(I) in all sao versions are read from the SAO file with
c    format fm4='(120A1)'       (Old READ_ADEP used 60I2)
c    BUT the date, etc. are not in the same part of the preface in all versions:
c    for example,in older versions the preface starts with the 2-digit year;
c    the preface in version 4.2 starts with a 2-letter code followed by the
c    4-digit year.

c----- Check for error in file format (probably an overflow *)

      if(idfi80.eq.0) THEN	!! Program will not handle ARTIST 3 format
      write(6,6098)(idfi(i),i=1,80)
6098  format(20i3)
      print*,"/QualScan will not handle ARTIST 3 format - IDF(80) = 0"
c      pause
      istop_error = 2
      go to 6666
      ENDIF

      IF (IDFI80.gt.2) THEN      !! 23-apr-04 changed GE to GT
         WRITE(DUMMY,'(2A1)') (IPREF(I),I=5,6)
         READ(DUMMY,'(I2)')  IYEAR
         WRITE(DUMMY,'(3A1)') (IPREF(I),I=7,9)
         READ(DUMMY,'(I3)')  IDAYNO
         READ(DUMMY,'(a3)')  cdayno
         WRITE(DUMMY,'(4A1)') (IPREF(I),I=14,17)
         READ(DUMMY,'(2I2)')  IHOUR,IMIN
         READ(DUMMY,'(2a2)')  chour,cmin
      ELSE
         WRITE(DUMMY,'(2A1)') (IPREF(I),I=1,2)
         READ(DUMMY,'(I2)')  IYEAR
         WRITE(DUMMY, '(3A1)') (IPREF(I),I=3,5)
         READ(DUMMY,'(I3)')  IDAYNO
         READ(DUMMY,'(a3)')  cdayno 
               WRITE(DUMMY,'(4A1)') (IPREF(I),I=6,9)
         READ(DUMMY,'(2I2)')  IHOUR,IMIN
         READ(DUMMY,'(2a2)')  chour,cmin
      ENDIF

c----- convert to 4-digit year
      IF(IDFI80.eq.2)cyear4 = "19"//ipref(1)//ipref(2)	!! 23-apr-04
      IF(IDFI80.gt.2)cyear4 = ipref(3)//ipref(4)//ipref(5)//ipref(6)	!! 23-apr-04
      WRITE(DUMMY,'(a4)') cyear4
      READ(DUMMY,'(I4)')  IYEAR

      WRITE(DUMMY,'(2A1)') (IPREF(I),I=18,19)
      READ(DUMMY,'(I2)')  ISEC
      READ(DUMMY,'(a2)')  csec

c---- Save the first day number
      if(idoy1.eq.0) idoy1 = idayno

      utime = float(ihour) + float(imin)/60.
      flocaltime = utime + gconst(4)/15.
      if(flocaltime.gt.24.) flocaltime = flocaltime - 24.

c----- Save the ARTIST confidence level vs LT      	MOD 6-july-2007
      ihrart = flocaltime + 0.5
      ihart = ihart + 1
      if(ihart.gt.24) ihart = ihart - 24
      if(iaafcon.eq.11) kartcon(1,ihart) = kartcon(1,ihart) + 1
      if(iaafcon.eq.22) kartcon(2,ihart) = kartcon(2,ihart) + 1
      if(iaafcon.eq.33) kartcon(3,ihart) = kartcon(3,ihart) + 1
      if(iaafcon.eq.44) kartcon(4,ihart) = kartcon(4,ihart) + 1
      if(iaafcon.eq.55) kartcon(5,ihart) = kartcon(5,ihart) + 1

      if(IwantDebug.eq.1) write(idb,1312) iyear,cdayno,chour,cmin
1312  format(" Progress for ionogram",i5,1x,a3,1x,a2,a2)

c----- Scan the traces for zeros or 9999 - use to fail Check 27

c----- First patch any file that has OTF(1) not set
c      Problem arises with some hand-scaled SAO. 
c       Last point is also sometimes bad, but this case is ignored and the ionogram skipped
      if(otf(1).eq.0.or.otf(1).gt.9998.) THEN
      if(otf(2).gt.0.and.otf(2).lt.9998.) THEN	!! check that second point is OK
      otf(1) = otf(2)
      ENDIF
      ENDIF

      ibade = 0
      ibadf1 = 0
      ibadf2 = 0
      DO i = 1,idfi17
      if(otE(i).le.0.or.otE(i).gt.9990) THEN
      ibade = ibade+1
c      print*," Bad E-layer point", idfi17,i,FTOE(i),ote(i)
      ENDIF
      ENDDO
      DO i = 1,idfi12
      if(otF1(i).le.0.or.otF1(i).gt.9990) THEN
      ibadf1 = ibadf1 + 1
c      print*," Bad F1-layer point",idfi12,i,ftoF1(i),otF1(i)
      ENDIF
      ENDDO
      DO i = 1,idfi7
      if(otF(i).le.0.or.otF(i).gt.9990) THEN
      ibadf2 = ibadf2 + 1
c      print*," Bad F2 point ",cdayno," ",chour,cmin,i,ftoF(i),otF(i)
      ENDIF
      ENDDO
      if(ibade+ibadf1+ibadf2.ne.0) THEN
c      print*,cdayno,chour,cmin,ibade,ibadf1,ibadf2	
      ENDIF

c      pause "CHECK 27"

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 1 No foF2 or Cheby Coeffs supplied
c      Skip this ionogram if there is no legitimate value of foF2 or
c      if there are no Cheby coeffs / N(h) table
c      also make sure N(h) profile extends up to foF2
c----- 3-july-2007 Also use this code if confidence levels are 44 or 55

      icheck = 1
      icheck1 = 0
      mflag1 = 0
      if(iaafcon.gt.40) mflag1 = 1
      if(scaled(1).le.0.or.scaled(1).gt.30.or.idfi(37).eq.0) mflag1=1
      if(mflag1.eq.1) THEN
c      print*,cdayno," ",chour,cmin," Iono skipped on Check 1"
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a scaled(1)
      if(iaafcon.lt.40) write(NGDCfile,1770) statid,cyear4,cdayno,
     a chour,cmin,("f",i=1,numprob),izero,izero
      if(iaafcon.gt.40) write(NGDCfile,1770) statid,cyear4,cdayno,
     a chour,cmin,("q",i=1,numprob),izero,iaafcon
      num_no_good_value_fof2 = num_no_good_value_fof2 + 1
      icheck1 = 1
      IhaveNoProfile = 90
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
      go to 7502	!! to write out just the header for the GAIM file
      ENDIF
1770  format(1x,a5,1x,a4,1x,a3,1x,a2,a2,1x,18(1x,a1),2i2)
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
1313  format(" Finished Check #",i3)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 2 Trace too short to apply checks
c      Many checks require a "long-enough" F2 trace
c      This check should catch all such problems
c----- This check is also applied to truncated traces (CHECK 30)

      icheck = 2
      icheck2 = 0

      if(idfi(7).le.5.or.scaled(1) - ftof(1).le.trace_len_min) THEN
      icheck2 = 1
c      print*,cdayno," ",chour,cmin," Iono skipped on Check 2"
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a scaled(1),ftof(1)
      write(NGDCfile,1770) statid,cyear4,cdayno,chour,cmin,
     a ("s",i=1,numprob),izero,izero
      num_trace_too_short = num_trace_too_short + 1
      IhaveNoProfile = 91
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
      go to 7502	!! to write out just the header for the GAIM file
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 27 Check for virtual heights not set (=9999 or 0)
      ICHECK = 27
      icheck27 = 0

c----- Bypass for Kwajalein ARTIST 4.5
      if(IhaveArtist5.eq.0) THEN
      if(statid.ne."KJ609") THEN
      DO i = 1,idfi7
      if(otf(i).gt.9998.) icheck27 = 1
      if(otf(i).gt.9998.) h9999 = otf(i)
      ENDDO
      if(ibade+ibadf1+ibadf2.ne.0) icheck27 = 1
      if(icheck27.eq.1) THEN
      print*,cdayno," ",chour,cmin," Iono skipped on Check 27"
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,
     a cmin,h9999
      write(NGDCfile,1770) statid,cyear4,cdayno,chour,cmin,
     a ("u",i=1,numprob),izero,izero
      num_ht_9999 = num_ht_9999 + 1
      IhaveNoProfile = 91
      go to 7502	!! to write out just the header for the GAIM file
      ENDIF !! icheck27.eq.1

      ENDIF	!! Bypass for Kwajalein	
      ENDIF	!! IhaveArtist5.eq.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 40 Scaled trace seems to be all sporadic E - Skip this ionogram 

      icheck = 40
      icheck40 = 0
      hseclast = otf(idfi7-1)	!! check the second last value of h' for F2 trace
      if(hseclast.lt.hseclastMIN) THEN
c      print*,cdayno," ",chour,cmin," Iono skipped on Check 40"
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a hseclast
      write(NGDCfile,1770) statid,cyear4,cdayno,chour,cmin,
     a ("f",i=1,numprob),izero,izero
      num_no_good_value_hseclast = num_no_good_value_hseclast + 1
      icheck40 = 1
      IhaveNoProfile = 99
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
      go to 7502	!! to write out just the header for the GAIM file
      ENDIF
      if(IwantDebug.eq.1) write(idb,1340) ICHECK
1340  format(" Finished Check #",i3)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Define prohibited frequencies (lower edges)
c-----The first ionogram(s) might have been no good, so we cannot use iononumber
c      to bypass this setup

      if(IneedFlux.eq.1) THEN	!! First ionogram we are going to process

      call prohibited_frequencies 
     a (statid,iprohibited,prohibited,numprohibited)
c      print*,(prohibited(i),i=1,numprohibited)

c----- No frequencies defined for this station
      if(numprohibited.eq.0) THEN
c      write(6,6) statid
6      format(//" No prohibited frequencies have been defined for",a6,/
     a " DEFAULT is none (hit Enter)"/)
c      PAUSE
      ENDIF

      ENDIF	!! IneedFlux.eq.1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Read in the 10.7 cm flux for first iono -- max of 30 years
c      used to calculate model values for E & F1
c-----The first ionogram(s) might have been no good, so we cannot use iononumber

      if(IneedFlux.eq.1) THEN
      IneedFlux = 0
      read(ifluxunit,1111) iyflux	!! first year 
      rewind(ifluxunit)
      call dayofmon (iyear,idayno,month,iday)	!! Get the month
      iy1 = iyflux - 1

      iyy = 1
1110  continue
      read(ifluxunit,1111,end=1112) iy,(fluxmon(iyy,i),i=1,12)
1111  format(i4,3x,12f6.1)
cc      write(6,1111) iy,(fluxmon(iyy,i),i=1,12)
      iyy = iyy + 1
      go to 1110
1112  continue
      close (ifluxunit)
      if(fluxmon(iyear-iy1,month).lt.0.or.fluxmon(iyear-iy1,month)
     a .gt.400.) THEN
      print*," No flux data for year/month",iyear,month
      istop_error = 3
      go to 6666
c      stop
      ENDIF	!! fluxmon(iyear-iy1,month
      ENDIF	!! iononumber.eq.1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      if(iwantusefuls.eq.1) THEN
      write(iusefuls,3099) statid,iyear,cdayno,chour,cmin,scaled(1),
     a thf2(3),ftof1(1),scaled(2),scaled(9),iaafcon      !! foF2_ART,hmF2_ART,First F2 freq, foF1,foE, ARTIST confidence
      ENDIF
3099  format(//"+++++++++ Ionogram for ",a5,i5,a4,a3,a2,5f8.2,i3/)

      hour = ihour
      fmin = imin

      kount = kount + 1       !! Ionogram Number - not same as iononumber
      print*
      print*,statid," Ionogram # ",kount,idayno," ",chour,cmin,iononumber
      print*

      if(kount.gt.maxkases) THEN
      print*,maxkases
      print*," Too many ionograms - stopping at MAXKASES ="
      istop_error = 4
      go to 6666 !!	Error exit
      ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      hourut = hour + fmin / 60.
      hourlt = hourut + statlon / 15.
      jdayno = idayno
      if(hourlt.gt.24.and.jdayno.le.364) jdayno = jdayno + 1    !!  ignoring UT/LT
      if(hourlt.gt.24.) hourlt = hourlt - 24.
      call dayofmon (iyear,jdayno,month,locday) !! locday is used for foE etc
      lhour = hourlt
      lmin = (hourlt - lhour) * 60. + 0.5

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----The ARTIST scaled parameters, SCALED, which we are going to check
      fof2_ART = scaled(1)
      fof1_art = scaled(2)
      em3_art  = scaled(3)
      if(em3_art.gt.99.) em3_art = 0.
      if(foF1_art.gt.99.) foF1_art = 0.
      if(scaled(2).lt.0.or.scaled(40).gt.998.) scaled(2) = 0.
      if(scaled(9).lt.0.or.scaled(9).gt.10.) scaled(9) = 0. 
      foe_art  = scaled(9)
      hme_art  = the(3)
      hmf2_art = thf2(3)
      if(scaled(40).le.0.or.scaled(40).gt.998.) scaled(40) = -1.
      shf2_art = scaled(40)
      tec_art  = scaled(39)
      if(abs(tec_art).gt.250.)  tec_art = -1.	!! Could get 9999 values

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Overwrite fof2_ART if not equal to last F2 freq 
      if(fof2_art.gt.ftof(idfi(11))) THEN
      fof2_art = ftof(idfi(11))
      ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Calculate the solar zenith angle
      reflon = statlon        !! longitude at which "local time" is given
      call solar
     a    (iyear,month,locday,lhour,lmin,statlat,statlon,reflon,
     a     solardec,zenangle,sunrise,sunset)

c-----The 10.7 cm flux for the month - monthly values
      iy1 = iyear - iyflux + 1
      fluxval = fluxmon(iy1,month)
c      print*," FLUXVAL",fluxval
      fluxtoday = fluxval	 !! use monthly value (for foE calculation)
      r12=sqrt(93918.4+1117.3*fluxval)-406.37	!! [D:\IRI2001\lfm_irine.for]

c-----Calculate the gyrofrequency and dip angle at the ground
c      Gyro varies significantly with height. Dip does not.
      zero_km = 0.
      call IGRF10
     a        (statlat,statlon,iyear,zero_km,dip_IGRF,declin,gyro_zero)

c-----Calculate the modified dip angle
      fac = cos(statlat*pi/180.)
      fac = sqrt(fac)
      fac = atan(dip_IGRF/fac*pi/180.)
      dipmod = fac * 180. / pi   !! Modified dip is used in foF1 calculation

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Write out a warning if the differences in the dip and gyrofreq
c      are suspiciously large

c-----ICHECK = 3 Compare the magnetic dip angle with IGRF (used by POLAN)
      ICHECK = 3
      ICHECK3 = 0

      if(abs(dip_IGRF - dipangle).ge.diff_dip) THEN
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,
     a cmin,dipangle,dip_IGRF
      ICHECK3 = 1
9002  format(a6,' ICHECK ',i3,a5,a4,a3,a2,2x,10f8.2)
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 4  Compare the gyrofrequency with IGRF (used by POLAN)
      ICHECK = 4
      ICHECK4 = 0

      gyroh = gyro_zero * (earthrad/(earthrad + gyro_ht_ART))**3

      if(abs(gyroh - gyrofreq).ge.diff_gyro) THEN
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  gyrofreq,gyroh
      icheck4 = 1
      ENDIF

      if(iwantusefuls.eq.1) THEN
      write(iusefuls,7055) gyroh,dip_IGRF,gyro_ht_ART
      write(iusefuls,7060) gyrofreq,dipangle
      ENDIF
7055  format(/5x,'IGRF   values of gyro freq & dip angle',2f6.2,
     a    /5x,'This gyrofreq is for an altitude of',f6.0)
7060  format(/5x,'ARTIST values of gyro freq & dip angle',2f6.2)
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 5 Check ARTIST scaled value of foE - SOLAR CONTROLLED

c       The ARTIST value of foE should be consistent with the CCIR value.
c       Note that this s/r returns the solar zenith angle, which we have 
c       already calculated separately. We keep the previous call because
c       it also returns SUNRISE & SUNSET.

      ICHECK = 5
      ICHECK5 = 0
      call Elayer
     a (fluxtoday,r12,iyear,month,locday,lhour,lmin,statlat,
     a  statlon,reflon,zenangle,chi_noon,foe_ccir,yme_lfm,hme_jet)
      yme_art = 0.    !! no checks on this
      if(abs(foe_ccir - foe_art).gt.diff_foe) THEN
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  foe_art,foe_ccir,zenangle,sunrise,sunset
       icheck5 = 1
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 6 Check ARTIST value of hmE against the Titheridge [mid-latitude]
c       value - given by ELAYER as foe = 108 + 8 ln(sec chi) [Chapman-like
c       with overhead-sun value of 108 km, and a scale height of 8 km]

      ICHECK = 6
      ICHECK6 = 0
      if(abs(hme_jet - hme_art).gt.diff_hme.and.hme_art.gt.0.) THEN
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  hme_art,hme_jet
      ICHECK6 = 1
      ENDIF

      if(iwantusefuls.eq.1) THEN
       write(iusefuls,7020) foe_ccir,yme_lfm,hme_jet
      ENDIF
      if(foe_art.gt.90.) foe_art = 99.9
      if(iwantusefuls.eq.1) THEN
       write(iusefuls,7025) foe_art,yme_art,hme_art,flocaltime
      ENDIF
7020  format(/5x,'Model  values of foE, ymE & hmE',f6.3,3f7.2)
7025  format(/5x,'ARTIST values of foE, ymE & hmE',f6.3,3f7.2,"LT")
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 25 Compare the first (10) ARTIST real and virtual heights
c      F2 frequency -- profile is possibly too low (at night)
c----- Mod 9-july-2007      Check extended to first 10 points in F2 trace
c      Previous check was at first freq with LSF h'

      ICHECK = 25
      icheck25 = 0

c----- Cannot do this test if no Cheby coeffs
      numb = 10
      if(numb.gt.idfi7) numb = idfi7	!! use first 10 points if they all exist
      DO i = 1,numb	!! use first 10 points if they all exist MOD 9-july-2007
      rhf2_art(i) = 0.
      ENDDO
      if(num_cheby.ne.0) THEN

c      Real height at the first numb freqs in ARTIST profile
      f_start = thf2(1)
      f_end = thf2(2)
      DO i = 1,5
      coeffs(i) = thf2(i+4)
      ENDDO
      DO inumb = 1,numb
      plasmafreq = ftof(inumb)
      gg = alog(plasmafreq/f_end) / alog(f_start/f_end)
      rhf2_art(inumb) = z_cheb (coeffs,gg,hmf2_art)	!!	real height
c      print*," Check 255",inumb,ftof(inumb),otf(inumb),rhf2_art(inumb) 
      ENDDO

      iproblem(3) = 0
      DO i = 1,numb
      diffh = otf(i)-rhf2_art(i)
      if(otf(i) + rhf2_art(i).eq.0.) diffh = 999. !! allow for no F2 coeffs
      if(diffh.le.delay_min) icheck25 = 1
      ENDDO

      IF (icheck25.eq.1) THEN	!!	the delay is too small
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a      rhf2_art(1),otf(1),diffh
       iproblem(3) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob3 = kprob3 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(3,kasenum)  = three
      ENDIF	!! icheck25.eq.1

      ENDIF	!! num_cheby.ne.0

      if(IwantDebug.eq.1) write(idb,1313) ICHECK
 
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 28  Check that the value of hmF2 is not too low
c
      ICHECK = 28      !! and PROBLEM(9)
      icheck28 = 0
      iproblem(9) = 0
      IF(hmf2_art.lt.hmf2_min.and.hmf2_art.gt.10.) THEN
       iproblem(9) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       icheck28 = 1
       kprob9 = kprob9 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(9,kasenum)  = nine
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a hmf2_art
      ENDIF	!! hmf2_art.lt.hmf2_min
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
      
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 15  Check the ARTIST value of hmF2 against the Dudeney value

      if(hmf2_art.le.1.or.hmf2_art.gt.900.) go to 1201 !! no N(h) profile
      if(em3_art.le.0.or.em3_art.gt.9.) go to 1201	!! no M3000 value
      hmf2_dud = 0.
      ICHECK = 15
      icheck15 = 0

c-----Dudeney (1983) formula for hmf2 JATP 45(8/9) 629-640
      em = em3_art
      if(foe_art.ne.0.) xxx = fof2_art / foe_art
c      Allow for no scaled value of foE
      if(foe_art.le.0.or.foe_art.gt.33.)  xxx = fof2_art / foe_ccir
      if(xxx.le.1.215) xxx = 1.216
      dm = 0.253 / (xxx-1.215) - 0.012
      f = em * sqrt((0.0196*em*em + 1.)/(1.2967*em*em - 1.))
      hmf2_dud = 1490. * f / (em + dm) - 176.

      if(hmf2_dud.le.200.) hmf2_dud = 0.

      if(iwantusefuls.eq.1) write(iusefuls,7045)hmf2_dud,hmf2_art
7045  format(/5x,'Dudeney & ARTIST values of hmF2  ',2f6.1)

      if(IwantPlotFiles.eq.1) THEN
      if(hmf2_dud.ne.0.) THEN
       write(idudhmf2,765) hourUT,hourLT,hmf2_art,hmf2_dud,  !! Plot file
     a statid,cyear4,cdayno,chour,cmin
      ENDIF	!! hmf2_dud.ne.0.
      ENDIF	!! IwantPlotFiles.eq.1

      if(abs(hmf2_dud - hmf2_art).gt.diff_hmf2_DUD) THEN
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  hmf2_dud,hmf2_art
      icheck15 = 1
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

1201  continue  !! arrive here if no ARTIST N(h) profile

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 38  Check if fmin is too high to get reliable profile
c      Errors decay as 1/f, so the longer the trace the better

      ICHECK = 38
      icheck38 = 0
      iproblem(16) = 0

      fmini = ftoE(1)
      if(idfi21.eq.0.and.idfi16.ne.0.) fmini = ftoF1(1)	!! first point is F1
      if(idfi21.eq.0.and.idfi16.eq.0.) fmini = ftoF(1)	!! first point is F2

      fmini_rat = fmini / fof2_ART
      if(fmini_rat.gt.fmin_ratio) icheck38 = 1

      if(icheck38.eq.1) THEN

      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a fmin_ratio,fmini,fmini_rat,ftoE(1),ftoF1(1),ftoF(1),foF2_ART

      num_fmin_too_high = num_fmin_too_high + 1
      
       iproblem(16) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob16 = kprob16 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(16,kasenum)  = sixteen	!!	PROBLEM = 16

      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 7 Check ARTIST scaled value of foF1

c      The ARTIST value of foF1 is compared with the Rosich & Jones 
c      model value (See the OT report). 
c-----"The numerical representation of the critical frequency of
c      the F1 region of the ionosphere", U.S. Dept of Commerce Office of
c      Telecommunications report 73-22 by R.K.Rosich & W.B.Jones, 1973
c      foF1 is zero for solar zenith angle > chimax
c
      ICHECK = 7
      icheck7 = 0

      zenith = zenangle
      call fof1OT (zenith,r12,month,dipmod,fof1_OT,chimax)
      if(fof1_art.gt.10.) fof1_art = 0.   !!  avoid values of 999.990
      if(fof1_art.gt.0.and.abs(foF1_ot - foF1_art).gt.diff_foF1) THEN
       icheck7 = 1
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  foF1_art,foF1_ot,zenangle,chimax
      ENDIF

      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 30 Last h' segment(s) has too high a slope - chop the ARTIST trace
c      Note: This check might also truncate because of a single high value of h'

      ICHECK = 30
      icheck30 = 0
      delfreq = ftof(idfi7) - ftof(idfi7-1)
      too_high = too_high_slope * delfreq
      nv1 = idfi7 - 1
      nv2 = nv1 / 2	!! search the top half of the F2 trace
      newnum = idfi7
      DO i = nv2,nv1
      slopi = otf(i+1)- otf(i)
      if(slopi.gt.too_high) THEN
      newnum = i
      icheck30 = 1
      go to 1777
      ENDIF
      ENDDO
1777  continue
      numold = idfi7
      idfi7 = newnum
      idfi11 = newnum
      idfi(7) = newnum
      idfi(11) = newnum
c      print*," NEWNUMMMM", idfi(7),idfi(11),newnum,numold
       if(icheck30.gt.0) THEN
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,
     a cmin,slopi
c      print*," Check 30 Trace truncated",nv1+1,newnum,slopi,too_high
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c----- Check that truncated trace is not too short
      icheck = 2
      icheck2 = 0
      if(ftof(idfi7) - ftof(1).le.trace_len_min) THEN
      icheck2 = 1
      write(iflagfile,9002) statid,-icheck,cyear4,cdayno,chour,cmin,
     a scaled(1),ftof(1)
      write(NGDCfile,1770) statid,cyear4,cdayno,chour,cmin,
     a ("t",i=1,numprob),izero,izero
      num_trace_too_short = num_trace_too_short + 1
      IhaveNoProfile = 93
      go to 7502	!! to print GAIM headers only, and skip other tests - get new ionogram
      ENDIF
      if(IwantDebug.eq.1) write(idb,1317) ICHECK
1317  format(" Finished Second (from Check 30) Check #",i3)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 9 The amplitude quality figure      
c      This check is to see if the end of the F2 trace follows actual echoes,or
c      is just an inspired extrapolation - requires at least 20 points,
c      which is usually 2 MHz. The 20 is hard-wired in AQF().
c---- BUT uses last half of trace is fewer than 20 points

      ICHECK = 9      !! and PROBLEM(1)
      icheck9 = 0

      ampquality = -999.
      delta_f = ftof(2) - ftof(1)	!! scaled frequency spacing

      call aqf (ioaf,idfi9,delta_f,ampquality)

c-----Check that the value of ampquality is not too low
      iproblem(1) = 0
      IF(ampquality.gt.0.) THEN	!! AQF has been set, so we can do the test
      IF (ampquality.lt.aqf_min) THEN
       iproblem(1) = 1  !! this ionogram has a problem
       icheck9 = 1
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob1 = kprob1 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(1,kasenum)  = one
      ENDIF	!! ampquality.lt.aqf_min
      ENDIF	!! ampquality > 0 

c----- Errors & info
      IF(ampquality.lt.aqf_min.and.ampquality.ge.0.) 
     a write(iflagfile,9002)statid,icheck,cyear4,cdayno,chour,cmin,
     a ampquality
      if(iwantusefuls.eq.1) THEN
      write(iusefuls ,1000) cyear4,cdayno,chour,cmin,
     a    nameofmonth(month),locday,lhour,lmin,ampquality
1000  format(//5x,'IONOGRAM UT',a5,a4,a3,a2,3x,
     a    'LT ',a3,i3,i3,i2,'  AQF =',f6.0)
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 39  The scaled trace does not match the ionogram echoes
c      	PROBLEM 17--- too few non-zero amplitudes along trace

      ICHECK = 39	!! and Problem 17
      icheck39 = 0

      call qs_check39
     a (cyear4,cdayno,chour,cmin,ioaf,idfi9,otf,idfi7,
     a iwantusefuls,iusefuls,iflagfile,iamp_flag,icheck39)

c-----Check that there were enough non-zero amplitudes
      iproblem(17) = 0
      IF (icheck39.gt.0) THEN
       ICHECK39 = 1
       iproblem(17) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob17 = kprob17 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(17,kasenum)  = seventeen
      ENDIF	!! not enough non-zero amplitudes
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 26 Check for discontinuous start of F2 trace (bad scaling)
c      If first F2 point is actually E-layer, replace h' (e.g.,WAL 2002 118 0715)
c      If nighttime, can have no retardation (IDFI17 = 0, no E layer)

      ICHECK = 26
      icheck26 = 0

c----- Allow for first point being nES and second point being on line up to F trace
c      Original check was for first point being E layer
c      if(otf(1).lt.190.) THEN	!! did not catch Boa Vista 298/1752 (h1 = 220)
      if(otf(1).lt.otf(3)-100.) THEN	!! 
      otf(1) = otf(3)	!! first point is probably E or ES layer
      otf(2) = otf(3)	!! to be safe
      icheck26 = 1
      ENDIF

c----- Overwrite cusp at first 2 points
      if(idfi17.eq.0.and.otf(1).gt.otf(3)) THEN
      otf(1) = (otf(3)+otf(4))/2.
      icheck26 = 2
      ENDIF

      if(idfi17.eq.0.and.otf(2).gt.otf(3)) THEN
      otf(2) = (otf(3)+otf(4))/2.
      icheck26 = 3
      ENDIF

      if(icheck26.eq.1.and.iwantusefuls.eq.1) THEN	!! ignore 2 & 3
       write(iflagfile,8001) icheck,cyear4,cdayno,chour,cmin,icheck26,
     a (otf(i),i=1,5)
8001  format(' ICHECK ',i3,a5,a4,a3,a2,i5,10f8.2)
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 11  Check the scaled F2 h' trace for smoothness. If it is OK,
c      we can fit a LSF curve through it
      icheck = 11
      call qs_check11
     a (cyear4,cdayno,chour,cmin,
     a ftof,otf,ioaf,idfi7,idfi12,idfi17,nchebF2,eps,eta,rms_fac,
     a virtht_max,diffitmax,percslope_min,x,y,z,diffit,cheb,
     a too_high_slope,iwantusefuls,iusefuls,
     a iflagfile,f2_smoothed,FOM_F2fit,ier_cheby,ipoorfitF2,icheck11)

c----- Truncate the smoothed trace if ipoorfitF2 = 6
c----- The logic here is the same as used for ICHECK = 30
c----- NOTE that this invalidates any POLAN-ARTIST comparison of foF2 for 
c      this ionogram

      IF (icheck11.ne.0) THEN
      IF(ipoorfitF2.eq.6) THEN
      delfreq = ftof(idfi7) - ftof(idfi7-1)
      too_high = too_high_slope * delfreq
      nv1 = idfi7 - 1
      nv2 = nv1 / 2	!! search the top half of the F2 trace
      newnum = idfi7
      DO i = nv2,nv1
      slopi = f2_smoothed(i+1)- f2_smoothed(i)
      if(slopi.gt.too_high) THEN
      newnum = i
      icheck30 = 1
      go to 2777
      ENDIF
      ENDDO
2777  continue
      numold = idfi7
      idfi7 = newnum
      idfi11 = newnum
      idfi(7) = newnum
      idfi(11) = newnum
      icheck11 = 0	!! re-set to no problem
      ENDIF	!! ipoorfitF2.eq.6
      ENDIF	!! icheck11.ne.0

c----- Check that the truncated trace is not too short
      if(ftof(idfi7) - ftof(1).le.trace_len_min) THEN
      icheck2 = 1
      write(iflagfile,9002) statid,-icheck,cyear4,cdayno,chour,cmin,
     a scaled(1),ftof(1)
      write(NGDCfile,1770) statid,cyear4,cdayno,chour,cmin,
     a ("t",i=1,numprob),izero,izero
      num_trace_too_short = num_trace_too_short + 1
      IhaveNoProfile = 94
      go to 7502	!! to print GAIM headers only, and skip other tests - get new ionogram
      ENDIF
c----- Program then goes back for new ionogram

c---- Set the error flag (but not for ipoorfitF2 = 5)
      iproblem(6) = 0

      IF(ipoorfitF2.eq.5) icheck11 = 0

      IF (icheck11.ne.0) THEN	!! no fit possible or non-physical fit
       iproblem(6) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob6 = kprob6 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(6,kasenum)  = six	!!	PROBLEM = 6
      ENDIF	!! icheck11.ne.0
      
c----- Count bad smoothed fits
      if(ipoorfitF2.ne.0.) THEN
      num_smoothed_no_good = num_smoothed_no_good + 1
      ENDIF

      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Find the elevation angles for a given circuit

      if(IwantOblique.eq.1) THEN	!! do this only for hourly ionograms
      IF (icheck11.eq.0) THEN		!! able to fit a LSF curve through F2
      ctem11 = cyear4//cdayno//chour//cmin
      filename = "oblique/"//statID//"_"//ctem11//".dat"
cc      if(cmin.eq."00".and.idfi(7).ge.5) call oblique_propagation 
      if(imin.le.3.and.idfi(7).ge.5) call oblique_propagation		!! Hourly ionos
c     a (ftof,otf,idfi(7),f2_smoothed,iob_unit,filename)
     a (ftof,otf,idfi(7),THF2,iob_unit,filename,em3_art,fof2_art)      !! modified 29-april-2008

      ENDIF
      ENDIF	!! IwantOblique.eq.1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 12  Look for any discontinuities in the F2 trace 
      icheck = 12
      call qs_check12
     a (cyear4,cdayno,chour,cmin,ftof,otf,idfi7,
     a x,y,jumpht,htjump,iwantusefuls,iusefuls,iflagfile,
     a jumpfail,icheck12)

      iproblem(7) = 0
      if(icheck12.ne.0) THEN
       iproblem(7) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob7 = kprob7 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(7,kasenum)  = seven	!!	PROBLEM = 7
       ENDIF	! icheck12.ne.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK
      
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 16  See if M3000 value comes from one end of the trace
      icheck = 16
      call qs_check16
     a (cyear4,cdayno,chour,cmin,ftof,otf,idfi7,fof2_art,tan_freq_min,
     a x,iflagfile,tangent_freq,iflagpaul,icheck16)

      if(IwantPlotFiles.eq.1) THEN
      eftn = tangent_freq / fof2_ART
      write(intf,5858) cyear4,cdayno,chour,cmin,em3_art,fof2_art,
     a tangent_freq,eftn,hmf2_art
5858  format(1x,a4,1x,a3,1x,a2,1x,a2,8f8.3)
      ENDIF

      IF(iflagpaul.ne.0) THEN
       iproblem(2) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob2 = kprob2 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(2,kasenum)  = two
      ENDIF	!! iflagpaul.ne.0

c      print*," Returned from Check16"

c----- Calculate M(3000)F2 for the smoothed trace
      em3_smoothed = 0.
      if(icheck11.eq.0) THEN
      call smoothed_m3000
     a (ftof,f2_smoothed,idfi7,fof2_ART,em3_art,iwantusefuls,iusefuls,
     a iflagfile,em3_smoothed)
      ENDIF

c---- Build up the RMS fractional discrepancy for later use
      if(em3_art.gt.0.and.em3_smoothed.gt.0.) THEN
      emtemp = (em3_art - em3_smoothed) / 
     a        ((em3_art + em3_smoothed) / 2.)
      rms_em3 = rms_em3 + emtemp**2
      num_rms_em3 = num_rms_em3 + 1
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 18  Scan for flat sections in the F2 trace (probably Es)
c      PROBLEM = 5
      icheck = 18
      call qs_check18
     a (cyear4,cdayno,chour,cmin,ftof,otf,idfi7,fr_max_flat,
     a iwantusefuls,iusefuls,iflagfile,flat_trace_rat,icheck18)
      
      if(icheck18.ne.0) THEN
       iproblem(5) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob5 = kprob5 + 1
       kflag = 1
       khit(5,kasenum)  = five
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
      ENDIF	!! nflat.gt.max_flat
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 29 look for foF2 very near prohibited frequency
      ICHECK = 29 
c
      iproblem(14) = 0
      icheck29 = 0
      if(numprohibited.ne.0) THEN
      do i = 1,numprohibited
      forbfreq = prohibited(i)
      if(abs(fof2_art - forbfreq).le.diffforbfreq) THEN
      icheck29 = 1
      iproblem(14) = 1
      ENDIF
      ENDDO
      ENDIF

      IF (iproblem(14).eq.1)  THEN
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a forbfreq,fof2_art
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob14 = kprob14 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(14,kasenum)  = fourteen
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 41  Check that foF2 is not too close to foF1
c       PROBLEM 18--- foF2 is suspiciously close to OT model value of foF1
      ICHECK = 41 
c
      iproblem(18) = 0
      icheck41 = 0
      if(abs(foF2_ART - foF1_OT).lt.del_foF1F2) THEN
      write(idb,1318) fof2_art,fof1_OT,fof1_ART
1318  format(" foF2 is very close to foF1",3f8.1)
      icheck41 = 1
      iproblem(18) = 1
      ENDIF

      IF (iproblem(18).eq.1)  THEN
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a fof2_art,foF1_OT
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob18 = kprob18 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(18,kasenum)  = eighteen
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 32 Check the scaled F1 h' trace for smoothness. If it is OK,
c       we should be able to fit a LSF curve through the points.
c      Require at least 3 points
      icheck = 32
      icheck32 = 0
      ipoorfitF1 = 0

      if(idfi12.ge.3) call qs_check32
     a (cyear4,cdayno,chour,cmin,
     a ftof1,otf1,ioaf1,idfi12,nchebF1,eps,eta,rms_fac,
     a diffitmax,percslope_min,x,y,z,diffit,cheb,iwantusefuls,iusefuls,
     a iflagfile,f1_smoothed,FOM_F1fit,ier_cheby,ipoorfitF1,icheck32)

c----- mod 9-july-2007 Ignore convex upwards flag
c      if(ipoorfitF1.eq.5) print*," qs_check32"
      if(ipoorfitF1.eq.5) icheck32 = 0	!! Line added Modified 03-june-2009
      if(ipoorfitF1.eq.5) ipoorfitF1 = 0

c----- Set the error flag
      if(ipoorfitF1.ne.0) THEN
       iproblem(10) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 !!	increment worst cases
       kprob10 = kprob10 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(10,kasenum)  = ten	!!	PROBLEM = 10
      ENDIF	!! ipoorfitF1.gt.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
c-----ICHECK = 33  Check for too long a gap between trace segments
      icheck = 33
      call qs_check33
     a (cyear4,cdayno,chour,cmin,
     a ftof,ftof1,ftoe,idfi7,idfi12,idfi17,gapmax,iflagfile,
     a gapmaxobs,icheck33)

c----- Modified 23-February-2009
c----- POLAN will crash if there is a steep downgoing trace and no underlying layer      	
      if(gapmaxobs.gt.0.5) THEN
      if(idfi(12).ne.0.and.otf1(1).gt.300.) icheck33 = 8	!! F1 trace
      if(idfi(12).eq.0.and.otf(1).gt.300.) icheck33 = 9	!! F2 trace
      ENDIF	!! gapmaxobs.gt.0.5
c----- Modified 23-February-2009
   
c-----If gap is far too wide, the data are considered bad
      if(icheck33.ne.0) THEN
       iproblem(12) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob12 = kprob12 + 1
       kflag = 1
       khit(12,kasenum)  = twelve
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
      ENDIF	!! icheck33.ne.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 34  Check if there is a corner in the F2 trace
      icheck = 34
      call qs_check34
     a (cyear4,cdayno,chour,cmin,ftof,otf,idfi7,slopechange,
     a iflagfile,icheck34)

      iproblem(13) = 0
      IF (icheck34.ne.0) THEN
       iproblem(13) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob13 = kprob13 + 1
       kflag = 1
       khit(13,kasenum)  = thirteen
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
      ENDIF      !! icheck34.ne.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 35  Check that the average slope increases over the last
c     part of the F2 trace. A decrease is (very) non physical.
c     If the slope decreases, there is probably a section of trace with
c     a very steep gradient (not at foF2)

      ICHECK = 35
      icheck35 = 0
      iproblem(11) = 0       
c       tempf = ftof(idfi7)*(1.-frac_lsf)
c----- Mod 11-july-2007 allow for short F1-F2 sections. Use second half of F2 trace
      if(foF1_ART.gt.0.) tempf = foF1_ART + (foF2_ART - foF1_ART) / 2.
      if(foF1_ART.le.0.) tempf = ftof(1) + (ftof(idfi7) - ftof(1)) /2.
      
      if(tempf.gt.ftof(idfi7)-0.1) THEN	!! trace has probably been shortened by Check 30
      first_deriv_at_end = -99.	!! fail ionogram on this check
      go to 1734
      ENDIF

      nlsf = 0
      DO i = 1,idfi7   !! for each F2 point
c      print*," check3555",i,idfi7,ftof(i),tempf
      if(ftof(i).gt.tempf) THEN
      nlsf = nlsf + 1
      xlsf(nlsf) = ftof(i)
      ylsf(nlsf) = otf(i)
c      print*," check3555",nlsf,xlsf(nlsf),ylsf(nlsf)
      ENDIF
      ENDDO
c      pause "3555"
      call correlation	!! to get LSF slope
     a  (xlsf,ylsf,nlsf,slopelsf,fintercept,xbar,ybar,correl_coeff)
      first_deriv_at_end = slopelsf

1734  continue
      IF (first_deriv_at_end.le.0.) THEN
       icheck35 = 1
       iproblem(11) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1 	!!	increment worst cases
       kprob11 = kprob11 + 1
       kflag = 1
       kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(11,kasenum)  = eleven
       write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a      first_deriv_at_end
      ENDIF !! first_deriv_at_end.le.0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 36  Check that average F2 slope over last NSLOPE points is > noise
c      	PROBLEM 15	Not enough curvature relative to noise in h' measurement

      icheck = 36
      icheck36 = 0
      iproblem(15) = 0

c     Calculate the average slope over the last 6 points of trace

      call slope_at_end (idfi7,ftof,otf,ioaf,nslope,slope_end)

      if(slope_end.lt.slope_end_min) THEN
      icheck36 = 1
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a slope_end,slope_end_min
       iproblem(15) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1       !!	increment worst cases
        kprob15 = kprob15 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(15,kasenum)  = fifteen
      ENDIF      !! slope_end.lt.slope_end_min has a problem
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 31 Too long a linear segment in F2 trace
c      This test excludes horizontal segments (handled by Check 18)
c      Check is no good if height step oscillates, e.g., 5,5,5,10,5,5,5,
      icheck31 = 0
      icheck = 31

c      Set up the height differences between freqs
      DO i = 2,idfi(7)
      htdiffs(i-1) = otf(i) - otf(i-1)
      ENDDO

c      Count the number of points with the same slope
      kmax = 0
      kk = 0
      DO i = 2,idfi7-1
      if(htdiffs(i).ne.0.and.htdiffs(i).eq.htdiffs(i-1)) THEN
       kk = kk + 1
       if(kk.gt.kmax) kmax = kk
      ENDIF
      if(htdiffs(i).ne.htdiffs(i-1)) kk = 0
      ENDDO
      if(kmax.gt.max_same_slope) THEN
      icheck31 = 1
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a float(kmax)
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c---------- END OF pre-POLAN CHECKS ------------------------------------
c---------- END OF pre-POLAN CHECKS ------------------------------------

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Set up the h'(f) trace using POLSETUP, unless any fatal flag is set
c      (Could use iproblem instead of icheck)

      kall_polan = 1
c      print*,"icheck11,icheck32,icheck33",icheck11,icheck32,icheck33
      kall_polsetup = 1
      if(	icheck11 +	!! F2 trace not smoothed successfully		PROBLEM 6
     a      icheck32 +	!! F1 trace not smoothed successfully		PROBLEM 10 [A]
     a      icheck33 	!! too long a gap between trace segments	PROBLEM 12 [C]
     a      .ne.0)	THEN
      kall_polsetup = 0
      kall_polan = 0
      iPOLANok = 0
      ENDIF

c-----Do not call POLAN if no ARTIST profile 
c      This should not arise - treated same as fof2 = 0
      if(idfi(37).eq.0) THEN	!! test on Cheby coeff
      kall_polsetup = 0
      kall_polan = 0
      iPOLANok = 0
      ENDIF

c-----We use the smoothed F1 and F2 traces, not the original ARTIST trace

      f2_critfreq = fof2_ART

      if(kall_polsetup.eq.1) THEN	!! F2 smooth fit was OK, etc

c      Find first virtual height  (for starting height calculation)
      first_vht = f2_smoothed(1)	!! F2
      if(idfi17.ne.0.) first_vht = ote(1)	!! E layer

c----- Calculate the model valley and percentage depth - 27-july-2004
c     Valley = -2.0 to -50. specifies a fixed valley width of 2*int(-Valley) km.
c                           Any decimal part D specifies a depth of 2*D in MHz
      call solar	!! noon zenith angle
     a    (iyear,month,locday,12,0,statlat,statlon,reflon,
     a     solardecz,zen_noon,sunrisez,sunsetz)

c---- Modified 17-april-2008 to check for no flux provided
      if(fluxval.le.0.) THEN	!! modified 23-february-2009
      print*," No flux data for year/month",iyear,month
      istop_error = 3
      go to 6666
      ENDIF

      call valley_WandD
     a(idayno,lhour,lmin,zenangle,zen_noon,fluxval,statlat,width,depth)
      valley_width = width
      vdepth = foe_ART * depth / 100.	!! need depth in MHz
      if(abs(foe_art).gt.5.0) vdepth = 0.1

c----- Modified 20-May-2009
c----- See the paper Titheridge, JATP 65(129-137), 2003
c----- The replaced code misapplied eqn 5 to get the valley depth in MHz
c----- Since depth from eqns 22 & 23 is small, the MHz depth was ~2x correct

      vdepth = foE_ART*(1. - sqrt(1. - depth/100.)) !! <<=== The actual mod
      if(abs(foe_art).gt.5.0) vdepth = 0.1
      depthD = vdepth / 2.
      ivalley = width / 2
      valley = ivalley + depthD
      valley = - valley
c----- Modified 20-May-2009

c-----The starting height for POLAN
      call starth 
     a (statlat,hourlt,solardec,zenangle,r12,first_vht,start)      !! start is in labeled common
      start_height = start

c      start_height = start * 1.1	!! see IRI_POLAN.pdf

c----- Set up the arrays of freq and virtual height for POLAN

      if(idfi12.ne.0) THEN
      do i = 1,idfi12
c      print*,"F1F1F1",i,f1_smoothed(i)
      enddo
      ENDIF

      call setupPOLANarrays 	 !! set up h'(f) as required by POLAN
     a (idfi,ftoe,ftof1,ftof,ote,f1_smoothed,f2_smoothed,      
cccc     a (idfi,ftoe,ftof1,ftof,ote,f1_smoothed,OTF,      	!! to use the original curve (for F3 layer)
     a hprime_E,hprime_F1,f2_critfreq,
     a ndim,nvalpol,freq,h_prime)

      if(iwantusefuls.eq.1) THEN
      DO i = 1,nvalpol
      write(iusefuls,7216) idayno,ihour,imin,freq(i),h_prime(i),
     a start_height,width,vdepth
      ENDDO
      ENDIF !! iwantusefuls.eq.1)
7216  format(10x,"Ionogram ? -> POLAN ",i4,i3,i2,f7.3,f9.3,3f6.1)

      ENDIF !! kall_polsetup.eq.1
 
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      fb = gyrofreq  !! Set negative to assume gyro does not vary with altitude (ARTIST value)
      fof2_pol = 0.
      hmf2_pol = 0.
      shf2_pol = 0.
      devf_pol = -1.
      devh_pol = -1.
      devsh_pol = -1.
      tec_subpeak = 0.
      diffh = 0.

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Call POLAN 0 to 2 times

      fof2_pol1 = 0
      hmf2_pol1 = 0
      fof2_pol2 = 0
      hmf2_pol2 = 0
      numhts = 0

      if(kall_POLAN.eq.0) THEN
      num_no_call_POLAN = num_no_call_POLAN + 1
      write(no_call,1788) statid,cyear4,cdayno,chour,cmin,
     a icheck11,icheck32,icheck33
1788  format(a5,"_",a4,a3,2a2,3x,3i2)
      ENDIF

      if(kall_POLAN.eq.1) num_call_to_POLAN = num_call_to_POLAN + 1

      IF (kall_POLAN.eq.1) THEN

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c----- We run POLAN twice
c      Run 1.	Last point is NOT given to POLAN as foF2. POLAN1 or POLAN #1
c      Run 2.	Last point is given to POLAN as foF2. POLAN2 or POLAN #2

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

c----- Save a second set of data for run 2 of POLAN
      DO i = 1,nvalpol
      s_freq(i) = freq(i)
      s_hprime(i) = h_prime(i)
c      print*," freq,htprime",i,freq(i),h_prime(i)
      ENDDO
      s_hprime(nvalpol-2) = 0.	!! this makes the freq into fc

      DO i = 1,889
      f1out(i) = 0.
      h1out(i) = 0.
      f2out(i) = 0.
      h2out(i) = 0.
      f3out(i) = 0.
      h3out(i) = 0.
      f4out(i) = 0.
      h4out(i) = 0.
      ENDDO
      DO j = 1,4
      DO i = 1,300
      ipolht(j,i) = 0
      ENDDO
      ENDDO

c       Call 11111111111111111111111111111111111111111111111111111111111
Call POLAN with no foF2 specified
c       Call 11111111111111111111111111111111111111111111111111111111111

c-----MUST PRECEDE 1ST CALL TO POLAN with:  CALL POLSITE (FB, DIP [,Site, Config])
c      Config(4)= (/Start,Valley, aMode,aList/)

cx      IF(IwantMultiProfiles.eq.1.or.IwantProfiles.eq.1) THEN
      IF(IwantProfiles.gt.0) THEN	!! always do POLAN 1 and 2

      config(1) = start
      config(2) = valley
      config(3) = amode
      config(4) = alist
      site(1) = statlat
      site(2) = hourlt
      site(3) = month
      site(4) = fluxval
      CALL POLSITE (FB, dipangle ,Site, Config)	!! do for all calls
      error_text = "error_none" !! lfm_sqrt
      n1out = 0
c      print*," CONFIG",(config(i),i=1,4)
c      print*," SITE  ",(site(i),i=1,4)
c      pause

c      print*," Entering POLAN 1"
      DO i = 1,300
c      if(freq(i).gt.0.) print*,i,freq(i),h_prime(i)
      enddo
      call POLAN (freq,h_prime,F1out,H1out,N1out,Config,QP,Fx,Hx,Herr)

c      DO i = 1,N1out
c      write(iusefuls,9875) f1out(i),h1out(i)
c9875      format(" POLAN1 Profile",2f10.3)
c      ENDDO

      write(idb,1321) error_text
1321  format(" Returned from POLAN call 1",2x,a10)

c----- Modified 8-march-2007
c----- Check for non-monotonic profile
      mono1 = 1
      DO i = 5,N1out-3	!! we are really worried about the profile just above the valley
      if(H1out(i).lt.H1out(i-1)) mono1 = 0	!! le changed to lt 13-january-2008
c      if(H1out(i).lt.H1out(i-1)) print*," NONMON1",i,H1out(i),H1out(i-1) 
      ENDDO

c---- Fail ionogram if profile is non-monotonic
      if(mono1.eq.0) n1out = 0
c----- Modified 8-march-2007
      if(N1out.eq.0) THEN	!! POLAN failed
         num_POLAN_gave_no_points = num_POLAN_gave_no_points + 1
         if(iwantusefuls.eq.1) THEN
            write(iusefuls,7236) 
7236        format(" *** POLAN 1 did not return a monotonic profile")
            if(mono1.eq.0) THEN
               DO i = 1,N1out-3
c                 print*," nonmono",i,f1out(i),h1out(i)
               ENDDO
            ENDIF
         ENDIF     !! iwantusefuls.eq.1
         iPOLANok = 0
         IhaveNoProfile = 98 !! Added 05Oct09   
         go to 3455	  !! bypass other calls to POLAN + checks based on POLAN
      ENDIF               !! POLAN failed

c---- Check that POLAN worked OK (no SQRT errors)
      iPOLANok = 1
      if(error_text.eq.error_sqrt) THEN
         num_POLAN_had_sqrt_errors = num_POLAN_had_sqrt_errors + 1
         iPOLANok = 0
         go to 3455   !! bypass other calls to POLAN + checks based on POLAN
      ENDIF

c---- Check that POLAN worked OK (no negative altitudes)      MOD 12-september-2006
      IhaveNegVals = 0
      DO i = 1,n1out
      if(h1out(i).le.0.) IhaveNegVals = 1
      ENDDO
           if(IhaveNegVals.eq.1) THEN
      iPOLANok = 0
      IhaveNoProfile = 100
      go to 7502	!! write GAIM headers only
      ENDIF

c----- Save the POLAN trace & profile for saving to \polan_profiles\
c----- Modified MOD 09-march-2009. 
c      In the \polan_profiles\ files, the POLAN virtual heights were not being moved
c      up 5 locations to allow for the five extra valley points. Code was wrong.
c      The virtual heights corresponding to the valley freqs are set to 0.0.
      IF(IwantProfiles.eq.1) THEN	
      ihtflag = 0
      DO i = 1,700!! MOD 09-march-2009 
      polplot_hp(i) = 0.
      ENDDO
      numpolpro = n1out-5
      DO i = 1,n1out-5
      if(f1out(i).gt.0.) THEN
      if(ihtflag.eq.0.and.h_prime(i).le.0.) THEN	!! at foE
      ihtflag = 5	
      ibotval = i+1
      itopval = i+4
      ENDIF
c      print*, "PPOLL 1",i,freq(i),f1out(i+2),h_prime(i),h1out(i+2)
      polplot_fr(i) = f1out(i+2)
      polplot_hp(i+ihtflag) = h_prime(i)
      polplot_hr(i) = h1out(i+2)
      ENDIF
      ENDDO
c----- Need to move the ionogram trace up 5 locations because of valley
      DO i = ibotval,n1out-5 !! MOD 09-march-2009
      ji = n1out-5 - ibotval + 1
      polplot_hp(i+ji) = polplot_hp(i)
      ENDDO
c----- Set the undefined virtual heights to zero
      DO i = ibotval-1,itopval
      polplot_hp(i) = 0.0
      ENDDO
      DO i = 1,n1out-5
c      print*," POL11",i,polplot_fr(i),polplot_hp(i)
      ENDDO
      ENDIF	!! IwantProfiles.eq.1

c      print*," Leaving POLAN 1 ",error_text

      fof2_pol1 = 0.
      hmf2_pol1 = 0.
      shf2_pol1 = ssh	!! (from labelled common - could be +/-)
      if(N1out.gt.3) THEN
      fof2_pol1 = F1out(N1out-3)
      hmf2_pol1 = H1out(N1out-3)
      devf_pol1 = F1out(N1out+1)
      devh_pol1 = H1out(N1out+1)
      devsh_pol1 = devs	!! from labelled common
      ENDIF

c      print*," N1OUT",n1out
      DO i = 1,n1out+2
c      print*," POLAN1 Profile",i,f1out(i),h1out(i)
      ENDDO
c      print*,fof2_pol1,hmf2_pol1,shf2_pol1
c      print*,devf_pol1,devh_pol1,devsh_pol1
c      pause

c----- Heights at 0.1 MHz steps
      ifmin = 10 * s_freq(1) + 0.5	!! counter runs 1 to 200
      DO i = 1,n1out
      if(H1out(i).le.hmf2_pol1) THEN
      ifreq(i) = F1out(i) * 10 + 0.5
      ipolht(1,ifreq(i)) = H1out(i) + 0.5
      ENDIF
      ENDDO

c----- Check that there are not equal heights, which crash SPLINE
c----- Replace points by a sloping straight line
c----- We assume that this occurs at the start of the E layer
      ieqht = 0
      DO i = 2,n1out
      if(H1out(i).eq.H1out(i-1)) THEN
      ieqht = i
      ENDIF
      ENDDO
      if(ieqht.ne.0) THEN
      same_pol_ht = H1out(ieqht)
      same_pol_fr = F1out(ieqht)
      neqht = ieqht + 2	!! second height above string of equal heights
c----- Replace heights by linearly increasing values
      dellht = (h1out(neqht) - h1out(1))/float(neqht)
      DO i = 2,neqht
      h1out(i) = h1out(1) + float(i - 1) * dellht 
c      print*," EDED1 ",i,f1out(i),h1out(i)
      ENDDO
      num_POLAN_equal_heights = num_POLAN_equal_heights + 1
      ICHECK = 0
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  same_pol_fr,same_pol_ht
      ENDIF	!! ieqht.ne.0

c----- Fit a spline through the profile, and find plasma freqs at each km
c----- Note: This profile could be a bit crazy if the valley is deep and narrow

c----- First check if there is a large height gap (usually E-F) MOD 20-july-2007
      large_height_gap = 0
      DO i = 2,N1out-3
      if(H1out(i)-H1out(i-1).gt.spline_ht_gap) large_height_gap = 1
      ENDDO
      if(large_height_gap.eq.1) THEN
      DO i = 90,600
      fn1(i) = 0.
      ENDDO
      ENDIF

      if(large_height_gap.eq.0) THEN
      yp1 = 1.e31
      ypn = 1.e31
      call spline (H1out,F1out,N1out,YP1,YPN,Y2)
c      print*," Returned from SPLINE 1"

c----- Interpolate to get profile at 1 km
c----- Note: This profile could be a bit crazy if the valley is deep and narrow.
      DO i = 90,600
      fn1(i) = 0.
      hite = i
      if(hite.le.hmf2_pol1) THEN
      call splint(H1out,F1out,Y2,N1out,hite,ffn)
      fn1(i) = ffn	!! smoothed 1 km profile
      ENDIF
      ENDDO
c      print*," Returned from SPLINT 1"
      ENDIF	!! large_height_gap.eq.0
      	!! 
cx      ENDIF	!! IwantMultiProfiles.eq.1.or.IwantProfiles.eq.1
      ENDIF	!! IwantProfiles.eq.1


c       Call 22222222222222222222222222222222222222222222222222222222222
Call POLAN with foF2 specified
c       Call 22222222222222222222222222222222222222222222222222222222222

cx      IF(IwantMultiProfiles.eq.1.or.IwantProfiles.eq.2) THEN
      IF(IwantProfiles.gt.0) THEN	!! always do POLAN 1 and 2
      config(1) = start
      config(2) = valley
      config(3) = amode
      config(4) = alist
      site(1) = statlat
      site(2) = hourlt
      site(3) = month
      site(4) = fluxval
      CALL POLSITE (FB, dipangle ,Site, Config)	!! do for all calls
      error_text = "error_none" !! lfm_sqrt
      n2out = 0

      call POLAN(s_freq,s_hprime,F2out,H2out,N2out,Config,QP,Fx,Hx,Herr)	!! foF2 specified
      write(idb,1322) error_text
1322  format(" Returned from POLAN call 2",2x,a10)

c----- ADDED 12-september-2006, in case IwantProfiles = 2
      if(N2out.eq.0) THEN	!! POLAN failed
      num_POLAN_gave_no_points = num_POLAN_gave_no_points + 1
      if(iwantusefuls.eq.1) THEN
      write(iusefuls,7237) 
7237      format(" *** POLAN 2 did not return a profile")
      ENDIF !! iwantusefuls.eq.1)
      iPOLANok = 0
      go to 3455	!! bypass other calls to POLAN + checks based on POLAN
      ENDIF

c---- Check that POLAN worked OK (no SQRT errors)
      iPOLANok = 1
           if(error_text.eq.error_sqrt) THEN
      num_POLAN_had_sqrt_errors = num_POLAN_had_sqrt_errors + 1
      iPOLANok = 0
      go to 3455	!! bypass other calls to POLAN + checks based on POLAN
      ENDIF

c---- Check that POLAN worked OK (no negative altitudes)      MOD 12-september-2006
      IhaveNegVals = 0
      DO i = 1,n2out
      if(h2out(i).le.0.) IhaveNegVals = 1
      ENDDO
           if(IhaveNegVals.eq.1) THEN
      iPOLANok = 0
      IhaveNoProfile = 100
      go to 7502	!! write GAIM headers only
      ENDIF
c----- ADDED 12-september-2006, in case IwantProfiles = 2

      fof2_pol2 = 0.
      hmf2_pol2 = 0.
      shf2_pol2 = ssh	!! (from labelled common - could be +/-)
      if(N2out.gt.3) THEN
      fof2_pol2 = F2out(N2out-3)
      hmf2_pol2 = H2out(N2out-3)
      devf_pol2 = F2out(N2out+1)
      devh_pol2 = H2out(N2out+1)
      devsh_pol2 = devs	!! from labelled common
      ENDIF

c----- Save the POLAN trace & profile for saving to \polan_profiles\
c----- Modified MOD 09-march-2009. 
c      In the \polan_profiles\ files, the POLAN virtual heights were not being moved
c      up 5 locations to allow for the five extra valley points. Code was wrong.
c      The virtual heights corresponding to the valley freqs are set to 0.0.
      IF(IwantProfiles.eq.2) THEN !! MOD 09-march-2009
      ihtflag = 0	
      numpolpro = n2out-5
      DO i = 1,n2out-5
      if(f2out(i).gt.0.) THEN
      if(ihtflag.eq.0.and.h_prime(i).le.0.) THEN	!! at foE
      ihtflag = 5
      ibotval = i+1
      itopval = i+4
      ENDIF
cc      print*, "PPOLL 2",freq(i),f2out(i+2),h_prime(i),h2out(i+2)
      polplot_fr(i) = f2out(i+2)
      polplot_hp(i+ihtflag) = h_prime(i)
      polplot_hr(i) = h2out(i+2)
      ENDIF
      ENDDO
c----- Need to move the ionogram trace up 5 locations because of valley
      DO i = ibotval,n2out-5 !! MOD 09-march-2009
      ji = n2out-5 - ibotval + 1
      polplot_hp(i+ji) = polplot_hp(i)
      ENDDO
c----- Set the undefined virtual heights to zero
      DO i = ibotval-1,itopval
      polplot_hp(i) = 0.0
      ENDDO
      DO i = 1,n2out-5
cc      print*,"POL22",i,polplot_fr(i),polplot_hp(i)
      ENDDO
      ENDIF	!! IwantProfiles.eq.2

c----- Heights at 0.1 MHz steps
      ifmin = 10 * s_freq(1) + 0.5	!! counter runs 1 to 200
      DO i = 1,n2out
      if(H2out(i).lt.hmf2_pol2) THEN
      ifreq(i) = F2out(i) * 10 + 0.5
      ipolht(2,ifreq(i)) = H2out(i) + 0.5
      ENDIF
      ENDDO

      if(IwantUsefuls.eq.1) THEN
      maxn = N1out
      if(N2out.gt.maxn) maxn = N2out
      DO i = 1,maxn+3
cc      write(iusefuls,6111) i,f1out(i),h1out(i),f2out(i),h2out(i)
6111  format(10x,"Profiles 1 & 2",i5,8f8.2)
      ENDDO
c      pause " DFDFDF"
      ENDIF

c----- Check that there are not equal heights, which crash SPLINE
c------Replace points by a sloping straight line
      ieqht = 0
      DO i = 2,n2out
      if(H2out(i).eq.H2out(i-1)) THEN
      ieqht = i
      ENDIF
      ENDDO
      if(ieqht.ne.0) THEN
      same_pol_ht = H2out(ieqht)	!! ADDED 12-september-2006
      same_pol_fr = F2out(ieqht)
      neqht = ieqht + 2	!! second height above string of equal heights
c----- Replace heights by linearly increasing values
      dellht = (h2out(neqht) - h2out(1))/float(neqht)
      DO i = 2,neqht
      h2out(i) = h2out(1) + float(i - 1) * dellht 
c      print*," EDED2 ",i,f2out(i),h2out(i)
      ENDDO
      num_POLAN_equal_heights = num_POLAN_equal_heights + 1
      ICHECK = 0
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  same_pol_fr,same_pol_ht
      ENDIF	!! ieqht.ne.0

c----- Fit a spline through the profile, and find plasma freqs at each km

c----- First check if there is a large height gap (usually E-F) MOD 20-july-2007
      large_height_gap = 0
      DO i = 2,N2out-3
      if(H2out(i)-H2out(i-1).gt.spline_ht_gap) large_height_gap = 1
      ENDDO
      if(large_height_gap.eq.1) THEN
      DO i = 90,600
      fn2(i) = 0.
      ENDDO
      ENDIF

      if(large_height_gap.eq.0) THEN
      yp1 = 1.e31
      ypn = 1.e31
      call spline (H2out,F2out,N2out,YP1,YPN,Y2)
      do i = 1,n2out
cc      write(88,*) "KKKK",h2out(i),f2out(i)
      ENDDO

c----- Interpolate to get profile at 1 km
      DO i = 90,600
      fn2(i) = 0.
      hite = i
      if(hite.le.hmf2_pol2) THEN
      call splint(H2out,F2out,Y2,N2out,hite,ffn)
      fn2(i) = ffn	!! smoothed 1 km profile
c      print*," KLKLKL",hite,ffn
c      write(88,*) " KLKLKL",hite,ffn
      ENDIF
      ENDDO
c      pause "KLKLKL"
      ENDIF	!! large_height_gap = 0

cx      ENDIF	!! IwantMultiProfiles.eq.1.or.IwantProfiles.eq.2
      ENDIF	!! IwantProfiles.eq.2


CODE DELETED 13-january-2008

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- modified 13-january-2008 - now have 2 POLAN profiles, not 4
c----- We now have the two POLAN profiles for this ionogram
c----  Find plasma frequencies for both profiles, plus fn error bars
c----- Cannot do this if large_height_gap.eq.1 (for any profile)

      if(large_height_gap.eq.0) THEN

c---- First height to consider is highest h(fmin) - should be identical
      hf1 = h1out(1)
      if(h2out(1).gt.hf1) hf1 = h2out(1)
      ihf1 = hf1 + 0.5

      numhts = 0
      DO i = ihf1,600

      errai = 0
c      if(fn3(i).gt.0.and.fn4(i).gt.0) THEN
c      errai = abs(fn3(i) - fn4(i)) / 2.	!! normal situation
c      ENDIF
      errbi = 0
      if(fn1(i).ne.0.and.fn2(i).ne.0) THEN
      errbi = abs(fn1(i) - fn2(i)) / 2.	!! when profiles 1 and 2 separate
      ENDIF
      errci = 0
      ibeyond = 0
      if(fn1(i).ne.0.and.fn2(i).eq.0) THEN
      ibeyond = 1
      errci = abs(fn1(i) - fof2_pol2) / 2.	!! beyond specified foF2
      ENDIF
      errbar = errai
      if(errbi.gt.errbar) errbar = errbi
      if(errci.gt.errbar) errbar = errci

      sum = fn1(i) + fn2(i)

      if(ibeyond.eq.1) errbar = - errbar	!! set negative if beyond scaled foF2

      errorbar(i) = errbar	!! error is +/- errbar
      
      if(sum.ne.0.) THEN
      if(IwantUsefuls.eq.1) THEN		!! makes HUGE usefuls.dat
c      write(iusefuls,6332) i,fn1(i),fn2(i),fn3(i),fn4(i),
c    a errai,errbi,errci,errbar
      ENDIF	!! IwantUsefuls.eq.1

      numhts = numhts + 1	!! counter for # of records
6332  format(i10,8f8.2)

c----- Find the spread in the POLAN values
      f12 = 0.
      if(fn1(i).gt.0.and.fn2(i).gt.0.) f12 = abs(fn1(i)-fn2(i))
c      print*,"spread in the POLAN values",f12,fn1(i),fn2(i)

c----- Minimum error applied to GAIM profiles [default is prof_min_error]
      if(abs(f12).gt.prof_min_error) polan_fn_errorbars(i) = f12

c      print*, "POLLLL",f12,f13,f14,f23,f24,f34
c      print*," POLERRB",i,polan_fn_errorbars(i)
      ENDIF	!! sum.ne.0.

      ENDDO	!!  i = ihf1,600

      ENDIF	!! large_height_gap.eq.0


c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      ENDIF	!!  kall_POLAN.eq.1 (covers all calls to POLAN)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Cannot do the remaining checks if POLAN was not called

      if(kall_POLAN.eq.0.or.ipolanOK.eq.0) go to 3455	!! bypass the POLAN-based checks

c-----ICHECK = 19 check differences between ARTIST & POLAN foF2
      ICHECK = 19
      icheck19 = 0
      fof2_polz = fof2_pol1	!! use POLAN #1
      if(IwantProfiles.eq.2) fof2_polz = fof2_pol2 
      if(abs(fof2_pol - fof2_art).gt.diff_fof2) THEN
      write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  fof2_art,fof2_polz
      icheck19 = 1
      ENDIF
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 20 Compare POLAN vs ARTIST hmF2   PROBLEM 4

      ICHECK = 20
      icheck20 = 0
      hmf2_polz = hmf2_pol1	!! use POLAN #1
      if(IwantProfiles.eq.2) hmf2_polz = hmf2_pol2 

      if(hmf2_ART.gt.200.and.hmf2_POLz.gt.200) THEN      !! Profile 1

      diffh = hmf2_polz - hmf2_art
      if(hmf2_polz.le.0.) diffh = 200.
      if(abs(diffh).gt.200.) diffh = 200.
      if(IwantPlotFiles.eq.1) THEN
      write(iherrvsaqf,7115) ampquality,diffh
7115  format(8f10.2)
      ENDIF	!! IwantPlotFiles
c
      if(abs(hmf2_polz - hmf2_art).gt.diff_hmf2_POL)
     a  write(iflagfile,9002) statid,icheck,cyear4,cdayno,chour,cmin,
     a  hmf2_polz,hmf2_art
      if(abs(hmf2_polz - hmf2_art).gt.diff_hmf2_POL) icheck20 = 1

      if(IwantPlotFiles.eq.1) THEN
      if(hmf2_polz.gt.100.OR.hmf2_dud.gt.100.OR.hmf2_art.gt.100) THEN
      write(i3hmf2,7011) cdayno,chour,cmin,hmf2_pol,hmf2_dud,hmf2_art
7011  format(1x,a3,1x,2a2,3f10.2)
      ENDIF
      ENDIF	!! IwantPlotFiles

      iproblem(4) = 0 
      IF (abs(diffh).gt.diff_hmf2_POL) THEN
       iproblem(4) = 1  !! this ionogram has a problem
       if(kflag.eq.0) kasenum = kasenum + 1
       kprob4 = kprob4 + 1
       kflag = 1
       khit(4,kasenum)  = four
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
      ENDIF

      ENDIF !! hmf2 .ne. 0
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----ICHECK = 21  The quality of the POLAN peak fit (Profile 1 or 2)
c      The quality will not be acceptable if the end of the trace is
c      erratic, or does not have enough curvature. It is assumed that
c      this will results in large errors in the POLAN peak fit.
c-----Negative scale height means peak fit is unreliable, but we don't
c      think this is a necessary test.
c-----This test is applied to the smoothed trace these days
c
      ICHECK = 21
      icheck21 = 0
      iproblem(8) = 0

      devf_polz = devf_pol1	!! use POLAN #1 by default
      if(IwantProfiles.eq.2) devf_polz = devf_pol2
       
      devh_polz = devh_pol1	!! use POLAN #1
      if(IwantProfiles.eq.2) devh_polz = devh_pol2
       
      devsh_polz = devsh_pol1	!! use POLAN #1
      if(IwantProfiles.eq.2) devsh_polz = devsh_pol2 

      shf2_polz = shf2_pol1
      if(IwantProfiles.eq.2) shf2_polz = shf2_pol2

      if(devh_polz.gt.sigh_pol.or.devf_polz.gt.sigf_pol.or.
     a devsh_polz.gt.sigsh_pol) THEN
       iproblem(8) = 1   !! this ionogram has a problem
       icheck21 = 1
       write(iflagfile,9002) statid, 
     a icheck,cyear4,cdayno,chour,cmin,fof2_POLz,hmF2_POLz,shf2_polz,
     a devf_polz,devh_polz,devsh_polz

      ENDIF      !! devh_polz.gt  etc

      IF (iproblem(8).eq.1) THEN
       if(kflag.eq.0) kasenum = kasenum + 1       !!	increment worst cases
       kprob8 = kprob8 + 1
       kflag = 1
        kday(kasenum)  = idayno
       khour(kasenum) = ihour
       kmin(kasenum)  = imin
       khit(8,kasenum)  = eight
      ENDIF      !! iproblem(8).eq.1
      if(IwantDebug.eq.1) write(idb,1313) ICHECK

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CODE DELETED 13-january 2008
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Arrive here if (first) call to POLAN failed (iPOLANok = 0)

3455  continue

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Plot fof2 and hmf2 vs UT, LT
      if(IwantPlotFiles.eq.1) THEN
c----- Calculate ARTIST height for 0.707 foF2
      h_art7 = 0.
      fn7 = 0.707 * fof2_ART
c      if(kka.ne.0) THEN	KKA no longer calculated 13-january-2008
      if(num_cheby.gt.0) THEN
      if(fn7.ge.ftof(1).and.fn7.lt.fof2_ART) THEN
      gg = alog(fn7/f_end) / alog(f_start/f_end)
      h_art7= z_cheb (coeffs,gg,hmf2_art)
      if(h_art7.lt.90.) h_art7 = 0.	!! might get silly answers
      ENDIF
      ENDIF	!! num_cheby.ne.0
cc      if(cdayno.ne.cdayno_prev) write(ipeakT,765)	!! blank REMOVED for USU/JPL work

c---- ipeakT (plot_files/peak_vs_time.dat) saves all sorts of useful stuff

c-----Virtual height at 5.7 MHz (Equiv freq for CHU-HAFB 7.335 MHz)
c      foE and foF21 are always less than 5.7, so just look at F2 trace
      virthMH33 = 0.
      virthMH57 = 0.
      if(cmin.eq."00") THEN
      virthMH57 = 0.
      if(ftof(1).lt.5.7.and.foF2_ART.gt.5.7) THEN
      DO i = 1,idfi(11)
      delMH = abs(5.7 - ftof(i))	!! MH = Millstone Hill
      if(delMH.lt.0.08) virthMH57 = otf(i)
      ENDDO
      ENDIF

c-----Virtual height at 2.2 MHz (Equiv freq for CHU-HAFB 3.330 MHz at night)
      virthMH22 = 0.	!! CHU 3.330MHz
      if(ftof(1).lt.2.2.and.foF2_ART.gt.2.2) THEN
      DO i = 1,idfi(11)
      delMH = abs(2.2 - ftof(i))	!! MH = Millstone Hill
      if(delMH.lt.0.08) virthMH22 = otf(i)
      ENDDO
      ENDIF
c      print*,cdayno,chour,cmin,virthMH23,virthMH57
      ENDIF	!! cmin = 00

ccc      if(hmF2_pol2.gt.0.and.hmf2_dud.gt.0.) THEN

      elapsed_hour = (IDAYNO - idoy1)*24. + hourUT

c      write(ipeakT,765) hourUT,fof2_art,hmf2_art,shf2_art,	!! for JASTP plot files
c     a statid,cyear4,cdayno,chour,cmin

c----- MOD 26-march-2009 WRITE move to later, after calls to SAOPLOT

ccc      ENDIF

      cdayno_prev = cdayno
c      print*," Finished write(ipeakT,765)"
      ENDIF	!! IwantPlotFiles

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Set up the GAIM EDP2 file (if POLAN was called)

      fof2_pol = 0.	!! for writing to plot file
      hmf2_pol = 0.
      DO i = 1,numprob
         chits(i) = blank
      ENDDO

c----- Check to see if just the headers should be written to the GAIM EDP2 file
      if(IwantGAIMfile.eq.1.and.iPOLANok.eq.0) THEN
      if(kasenum.eq.0) go to 7502
      if(khit(6,kasenum).eq.six) IhaveNoProfile = 95	!!	PROBLEM = 6
      if(khit(10,kasenum).eq.ten) IhaveNoProfile = 96	!!	PROBLEM = 10
      if(khit(12,kasenum).eq.twelve) IhaveNoProfile = 97	!!	PROBLEM = 12
      go to 7502
      ENDIF	!! IwantGAIMfile.eq.1.and.iPOLANok.eq.0
c
7503  continue	!! control returns to here
      if(IwantGAIMfile.eq.1.and.iPOLANok.eq.1) THEN
      if(kflag.eq.1) THEN
         DO i = 1,numprob
            chits(i) = khit(i,kasenum)
         ENDDO
      ENDIF

      fof2_pol = fof2_pol1
      hmf2_pol = hmf2_pol1
      shf2_pol = shf2_pol1
      numpol = N1out - 3
      DO i = 1,numpol
      fnpol(i) = f1out(i)
      realpol(i) = h1out(i)
      ENDDO
      if(IwantProfiles.eq.2) THEN
      fof2_pol = fof2_pol2
      hmf2_pol = hmf2_pol2
      shf2_pol = shf2_pol2
      numpol = N2out - 3
      DO i = 1,numpol
      fnpol(i) = f2out(i)
      realpol(i) = h2out(i)
      ENDDO
      ENDIF

c----- Check that the POLAN profile is monotonic - ignore first 2 points
      monop = 1
      DO i = 4,numpol-4	!! avoid points above the peak
c      if(realpol(i).gt.0.) THEN
      if(realpol(i).le.realpol(i-1)) monop = 0
      if(realpol(i).le.realpol(i-1)) imono = i
c      ENDIF
      ENDDO

      if(monop.eq.0.) THEN
c      print*," MONOP =0 ",cdayno,chour,cmin,imono,numpol
      DO i = 4,numpol
c      print*,i,realpol(i),realpol(i-1),realpol(i)-realpol(i-1)
      ENDDO
c      pause
      ENDIF

      if(monop.eq.1) THEN

c----- Set up the GAIM EDP2 profile name

c----- MOD 12-March-2009 Options for GAIM file name
c----- IwantSecs = 0 gives standard GAIM file name, XXXXX_yyydddhhmm.edp2 (no seconds)
c----- IwantSecs = 1 gives file name as XXXXX_yyydddhhmmss.EDP (with seconds, diff extension)

      IF(IwantSecs.eq.0) THEN	!! standard GAIM file name convention -- DEFAULT
      profile_name = "gaim_edp2/"
     a //statid//"_"//cyear4//cdayno//chour//cmin//".edp2"
      ENDIF
      IF(IwantSecs.eq.1) THEN	!! name convention as used at NGDC
      profile_name = "gaim_edp2/"
     a //statid//"_"//cyear4//cdayno//chour//cmin//csec//".EDP"
      ENDIF
c      print*," EDP@ name ",profile_name
c      pause
c----- MOD 12-March-2009 Options for GAIM file name

      close(igaim)
      open(unit=igaim,file=profile_name)

      DO i = 1,700
      fnpro_art(i) = 0.
      fnpro_pol(i) = 0.
      fnpro_gmf(i) = 0.
      fn_error_bar(i) = 0.
      ENDDO

c...Valley parameters from NhPc version 3.01 and greater Sept. 1993
c      IF(IDFI(42).GT.0) print*, "VVV ",IDFI(42),(THVAL(I),I=1,IDFI(42))



c======================================================================
c======================================================================

c----- Calculate extraordinary trace [need to be making GAIM edp2 files]

c======================================================================
c======================================================================

c----- mod 27-march-2007

cxxxxx NOTE: This code crashed on an (now unknown) ionogram with a SQRT error

      if(IwantXtrace.eq.1.and.IwantUsefuls.eq.1) THEN
      iray = -1	!! +1 to test Ordinary ray. Set fb very small to mimic no field

c----- Tabular profile htab,ftab,idfi(51) and 52

      idfi51 = idfi(51)
      if(idfi51.gt.0) THEN	!! Demand a tabulated profile be present


c----- Require a GAIM profile, and fmin not too high
      if(IwantProfiles.lt.90.and.fmini.lt.0.5*foF2_ART) THEN 
c      print*," Started calculating X trace"
c      pause

      call calculate_X_trace
     a(ftab,htab,idfi51,scaled,hmf2_art,freq_int,dipangle,gyrofreq,
     a gyro_ht_ART,freq_iono,virt,realht,numpts,iray)
     
           if(IwantUsefuls.eq.1) THEN
      DO i = 1,numpts
      write(iusefuls,77)cyear4,cdayno,chour,cmin,freq_iono(i),virt(i),
     a realht(i)
77    format(10x," X trace",a5,a4,a3,a2,10f10.3)
      ENDDO
      ENDIF	!! IwantUsefuls

      ENDIF	!! IwantProfiles.lt.90

c      print*," Finished calculating X trace"
      ENDIF	!! idfi51.gt.0

      ENDIF	!! IwantXtrace.eq.1.and.IwantUsefuls.eq.1

c----- mod 27-march-2007

c======================================================================
c======================================================================
c======================================================================
c======================================================================


      if(IwantDebug.eq.1) write(idb,1315)
1315  format(" Entering makeGAIMfile")
      
      call makeGAIMfile
     a(version,igaim,IwantProfiles,devf_pol1,devh_pol1,chits,numprob,
     a statID,statlat,statlon,cyear4,cdayno,chour,cmin,csec,iaafcon,
     a idfi,scaled,ftoE,ftof1,ftof,the,thval,thf1,thf2,
     a fof2_pol,hmf2_pol,shf2_pol,fnpol,realpol,freq_int,slope_end,
     a fnpro_art,fnpro_pol,fnpro_gmf,fn_error_bar,polan_fn_errorbars,
     a IwantGAIMalts)
      if(IwantDebug.eq.1) write(idb,1316)
1316  format(" Leaving makeGAIMprofile")

      ENDIF	!! monop = 1

      ENDIF	!! IwantGAIMfile.eq.1.and.iPOLANok.eq.1

      if(IwantGAIMfile.eq.1.and.iPOLANok.eq.1.and.monop.eq.0) THEN
      IhaveNoProfile = 98	!! flag to write just first two lines of EDP2 file
      go to 7502
      ENDIF
7504  continue	!! control returns to here

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Set up the plot file of FN, h' and h(fn) (POLAN & ARTIST)
c      s/r saoplot writes fn, virtht & realht
c      There may be no POLAN profile (kall_polan = 0, or IpolanOK=0))

      IF (iwantprofiles.eq.1) THEN	!! use POLAN #1 profile

      ctem19 = statid//"_"//cyear4//cdayno//chour//cmin//csec
      filename = "polan_profiles/pol1_"//ctem19//".dat"
      close(ipolpro)
      if(kall_polan.ne.0.and.IpolanOK.eq.1) THEN
      open(unit=ipolpro,file=filename)	!! POLAN1 profile
      filename = "artist_profiles/art_"//ctem19//".dat"
      close(iartpro)
       open(unit=iartpro,file=filename)	!! ARTIST profile

       if(idfi(37).gt.1) call SAOPLOT 
     a      (iartpro,ipolpro,sysdes,idfi,scaled,ftoe,ftof1,ftof,
     a       the,thf1,thf2,ote,otf1,otf,iyear,idayno,ihour,imin,
     a       fof2_pol1,hmf2_pol1,fn,virtht,realht,freq_int,em3_smoothed,	!! em3_smoothed added 23-oct-07
     a     kall_polan,numpolpro,polplot_fr,polplot_hp,polplot_hr)

      ENDIF	!! call_POLAN.ne.0
      ENDIF	!! iwantprofiles

      IF (iwantprofiles.eq.2) THEN	!! use POLAN #2 profile

      ctem19 = statid//"_"//cyear4//cdayno//chour//cmin//csec
      filename = "polan_profiles/pol2_"//ctem19//".dat"
      close(ipolpro)
      if(kall_polan.ne.0.and.IpolanOK.eq.1) THEN
      open(unit=ipolpro,file=filename)	!! POLAN2 profile
      filename = "artist_profiles/art_"//ctem19//".dat"
      close(iartpro)
      open(unit=iartpro,file=filename)	!! ARTIST profile

       if(idfi(37).gt.1) call SAOPLOT 
     a      (iartpro,ipolpro,sysdes,idfi,scaled,ftoe,ftof1,ftof,
     a       the,thf1,thf2,ote,otf1,otf,iyear,idayno,ihour,imin,
     a       fof2_pol2,hmf2_pol2,fn,virtht,realht,freq_int,em3_smoothed,	!! em3_smoothed added 23-oct-07
     a     kall_polan,numpolpro,polplot_fr,polplot_hp,polplot_hr)

      ENDIF	!! call_POLAN.ne.0
      ENDIF	!! iwantprofiles


c----- MOD 26-march-2009 WRITE move to here, after calls to SAOPLOT

      write(ipeakT,765) hourUT,hourLT,fof2_art,hmf2_art,				!! A-D
     a statid,cyear4,cdayno,chour,cmin,fof2_pol1,hmf2_pol1,      		!! E-K
     a fof2_pol2,hmf2_pol2,shf2_art,abs(shf2_pol1),abs(shf2_pol2),      !! L-P
     a h_art7,hmf2_art-h_art7,foe_art,foe_ccir,zenangle,sunrise,sunset,!! R-W
     a em3_ART,em3_ART*fof2_art,em3_smoothed,TEC_ART,hmf2_dud,      	!! X-Z, AA,AB
     a virthMH22,virthMH57,hmf2_dud-hmF2_art,start_height,      		!! AC,AF
     a hmf2_dud-hmF2_pol2,elapsed_hour,width,vdepth,polHalfWidth      	!! AG-AJ				
765   format(4f10.2,a10,a5,a4,a3,a3,30f10.2)


cc      print*, "XTRADUD hmf2_dud, foF1",hmf2_dud,scaled(2),scaled(9)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Count the F2 FOM cases
      if(iamp_flag.eq.1) iampflag1 = iampflag1 + 1
      if(iamp_flag.eq.2) iampflag2 = iampflag2 + 1
      if(iamp_flag.eq.3) iampflag3 = iampflag3 + 1
      if(iamp_flag.eq.4) iampflag4 = iampflag4 + 1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Write out the record that is used to assign a quality figure 

      call write_record_for_quality_figure
     a (khit,kasenum,kflag,kall_POLAN,iPOLANok,NGDCfile,numprob,
     a fof2_pol1,fof2_art,hmf2_pol1,hmf2_art,em3_smoothed,
     a em3_art,em3_rms_def,iaafcon,
     a statid,cyear4,cdayno,chour,cmin)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----Write out the Problems found with this ionogram (if there are any)
c      kasenum is the counter for PROBLEM ionograms
c      kflag = 0 initially for each ionogram. Set = 1 if a PROBLEM is set

      ik = kasenum
      DO i = 1,numprob
      ctemp(i) = blank
      ENDDO
      if(kasenum.ne.0) THEN
      DO i = 1,numprob
      ctemp(i) = khit(i,ik)
      if(ctemp(i).eq.blank) ctemp(i) = "-"!! to make easier to read
      ENDDO
      ENDIF
      if(kflag.eq.1.and.ik.gt.0) write(iflagfile,1778)
     a      iyear,kday(ik),khour(ik),kmin(ik),(ctemp(k),k=1,numprob)
1778  format('PROBLEMs    ',i4,i3,2i2,4x,18(2x,a1))

c-----Write out the data
      if(kflag.eq.0)  !! data is OK  - skip khit because for a previous iono
     a write(ioutput,7655) statid,iyear,idayno,chour,cmin,csec,
     a fof2_pol1,hmf2_pol1,fof2_pol2,hmf2_pol2,
     a fof2_ART,hmf2_ART,slope_end,FOM_F1fit,FOM_F2fit,iamp_flag,iaafcon
7655   format(a6,i5,i4,1x,3a2,1x,18x,1x,f6.1,f6.0,f6.1,f6.0,f6.1,4f6.0,
     a 2i4)

ccc      	if(khit(16,kasenum).ne."G") THEN

      if(kflag.eq.1)  !! data is qualified
     a write(ioutput,7654) statid,iyear,idayno,chour,cmin,csec,
     a (khit(k,kasenum),k=1,numprob),
     a fof2_pol1,hmf2_pol1,fof2_pol2,hmf2_pol2,
     a fof2_ART,hmf2_ART,slope_end,FOM_F1fit,FOM_F2fit,iamp_flag,iaafcon
7654  format(a6,i5,i4,1x,3a2,1x,18a1,1x,f6.1,f6.0,f6.1,f6.0,f6.1,
     a 4f6.0,2i4)

ccc      	ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Count the number of times each check failed (not all checks are used)
      if(icheck1.ne.0) kount_of_checks(1) = kount_of_checks(1) + 1
      if(icheck2.ne.0) kount_of_checks(2) = kount_of_checks(2) + 1
      if(icheck3.ne.0) kount_of_checks(3) = kount_of_checks(3) + 1
      if(icheck4.ne.0) kount_of_checks(4) = kount_of_checks(4) + 1
      if(icheck5.ne.0) kount_of_checks(5) = kount_of_checks(5) + 1
      if(icheck6.ne.0) kount_of_checks(6) = kount_of_checks(6) + 1
      if(icheck7.ne.0) kount_of_checks(7) = kount_of_checks(7) + 1
      if(icheck8.ne.0) kount_of_checks(8) = kount_of_checks(8) + 1
      if(icheck9.ne.0) kount_of_checks(9) = kount_of_checks(9) + 1
      if(icheck10.ne.0) kount_of_checks(10) = kount_of_checks(10) + 1
      if(icheck11.ne.0) kount_of_checks(11) = kount_of_checks(11) + 1
      if(icheck12.ne.0) kount_of_checks(12) = kount_of_checks(12) + 1
      if(icheck13.ne.0) kount_of_checks(13) = kount_of_checks(13) + 1
      if(icheck14.ne.0) kount_of_checks(14) = kount_of_checks(14) + 1
      if(icheck15.ne.0) kount_of_checks(15) = kount_of_checks(15) + 1
      if(icheck16.ne.0) kount_of_checks(16) = kount_of_checks(16) + 1
      if(icheck17.ne.0) kount_of_checks(17) = kount_of_checks(17) + 1
      if(icheck18.ne.0) kount_of_checks(18) = kount_of_checks(18) + 1
      if(icheck19.ne.0) kount_of_checks(19) = kount_of_checks(19) + 1
      if(icheck20.ne.0) kount_of_checks(20) = kount_of_checks(20) + 1
      if(icheck21.ne.0) kount_of_checks(21) = kount_of_checks(21) + 1
      if(icheck22.ne.0) kount_of_checks(22) = kount_of_checks(22) + 1
      if(icheck23.ne.0) kount_of_checks(23) = kount_of_checks(23) + 1
      if(icheck24.ne.0) kount_of_checks(24) = kount_of_checks(24) + 1
      if(icheck25.ne.0) kount_of_checks(25) = kount_of_checks(25) + 1
      if(icheck26.ne.0) kount_of_checks(26) = kount_of_checks(26) + 1
      if(icheck27.ne.0) kount_of_checks(27) = kount_of_checks(27) + 1
      if(icheck28.ne.0) kount_of_checks(28) = kount_of_checks(28) + 1
      if(icheck29.ne.0) kount_of_checks(29) = kount_of_checks(29) + 1
      if(icheck30.ne.0) kount_of_checks(30) = kount_of_checks(30) + 1
      if(icheck31.ne.0) kount_of_checks(31) = kount_of_checks(31) + 1
      if(icheck32.ne.0) kount_of_checks(32) = kount_of_checks(32) + 1
      if(icheck33.ne.0) kount_of_checks(33) = kount_of_checks(33) + 1
      if(icheck34.ne.0) kount_of_checks(34) = kount_of_checks(34) + 1
      if(icheck35.ne.0) kount_of_checks(35) = kount_of_checks(35) + 1
      if(icheck36.ne.0) kount_of_checks(36) = kount_of_checks(36) + 1
      if(icheck37.ne.0) kount_of_checks(37) = kount_of_checks(37) + 1
      if(icheck38.ne.0) kount_of_checks(38) = kount_of_checks(38) + 1
      if(icheck39.ne.0) kount_of_checks(39) = kount_of_checks(39) + 1
      if(icheck40.ne.0) kount_of_checks(40) = kount_of_checks(40) + 1

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      IF(.NOT.EOF) GO TO 15      !! Go back for a new ionogram

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Set up a GAIM EPD2 file that contains just the header information
c      if there is no ARTIST or PROFILE profile, or some other reason

c-----ICHECK = 1 No foF2 or Cheby Coeffs supplied
c-----ICHECK = 2 Trace too short to process
c-----ICHECK = 27 Virtual heights not set (=9999 or 0)
c-----ICHECK = 30 Last h' segment(s) has too high a slope
c      This check lops off the end of the F2 trace, which may get too short
c-----ICHECK = 11 Check the scaled F2 h' trace for smoothness.& validity
c      This check possibly (ipoorfitF2=6) lops off the end of the F2 trace,
c      which may get too short
c----- IpolanOK = 0 if one of the following
c      icheck11	!! F2 trace not smoothed successfully		PROBLEM 6
c      icheck32	!! F1 trace not smoothed successfully		PROBLEM 10 [A]
c      icheck33 	!! too long a gap between trace segments	PROBLEM 12 [C]
c----- POLAN 1 or 2 profile not monotonic
c      The parm monop is set to 0. Usually happens because of bad F1 trace.

7502  continue

      if(IwantGAIMfile.eq.1) THEN

      if(IhaveNoProfile.ge.90) THEN

c----- Set up the GAIM EDP2 profile name and write headers
c----- MOD 12-March-2009 Options for GAIM file name
c----- IwantSecs = 0 gives standard GAIM file name, XXXXX_yyydddhhmm.edp2 (no seconds)
c----- IwantSecs = 1 gives file name as XXXXX_yyydddhhmmss.EDP (with seconds, diff extension)
      IF(IwantSecs.eq.0) THEN	!! standard GAIM file name convention -- DEFAULT
      profile_name = "gaim_edp2/"
     a //statid//"_"//cyear4//cdayno//chour//cmin//".edp2"
      ENDIF
      IF(IwantSecs.eq.1) THEN	!! name convention as used at NGDC
      profile_name = "gaim_edp2/"
     a //statid//"_"//cyear4//cdayno//chour//cmin//csec//".EDP"
      ENDIF
c      print*," EDP@@@ name ",profile_name
c      pause
c----- MOD 12-March-2009 Options for GAIM file name

      close(igaim)
      open(unit=igaim,file=profile_name)
      IwantGAIMheadersOnly = 1

      IF(IhaveNoProfile.eq.90) THEN	!! check 1
      creason = ".Check  1 failed."
      num_IhaveNoProfile90 = num_IhaveNoProfile90 + 1   
      ENDIF

      IF(IhaveNoProfile.eq.91) THEN	!! check 2
      creason = ".Check  2 failed."
      num_IhaveNoProfile91 = num_IhaveNoProfile91 + 1    
      ENDIF

      IF(IhaveNoProfile.eq.92) THEN	!! check 27
      creason = ".Check 27 failed." 
      num_IhaveNoProfile92 = num_IhaveNoProfile92 + 1   
      ENDIF

      IF(IhaveNoProfile.eq.93) THEN	!! Trace too short (from Check 30)
      creason = ".30 Trace 2 short"
      num_IhaveNoProfile93 = num_IhaveNoProfile93 + 1    
      ENDIF

      IF(IhaveNoProfile.eq.94) THEN	!! Trace too short (from Check 11, IpoorFitF2 = 6)
      creason = ".11 Trace 2 short"
      num_IhaveNoProfile94 = num_IhaveNoProfile94 + 1     
      ENDIF

      IF(IhaveNoProfile.eq.95) THEN	!! No POLAN profile. Check 11 failed, Problem 6
      creason = ".Check 11 failed."
      num_IhaveNoProfile95 = num_IhaveNoProfile95 + 1    
      ENDIF

      IF(IhaveNoProfile.eq.96) THEN	!! No POLAN profile. Check 11 failed, Problem 10 [A]
      creason = ".Check 11 failed." 
      num_IhaveNoProfile96 = num_IhaveNoProfile96 + 1   
      ENDIF

      IF(IhaveNoProfile.eq.97) THEN	!! No POLAN profile. Check 11 failed, Problem 12 [C]
      creason = ".Check 11 failed."
      num_IhaveNoProfile97 = num_IhaveNoProfile97 + 1    
      ENDIF

      IF(IhaveNoProfile.eq.98) THEN	!! No POLAN profile. POLAN 1 or 2 profile not monotonic
      creason = ".POLprof not mono" 
      num_IhaveNoProfile98 = num_IhaveNoProfile98 + 1   
      ENDIF

      IF(IhaveNoProfile.eq.99) THEN	!! check 40
      creason = ".Check 40 failed."
      num_IhaveNoProfile99 = num_IhaveNoProfile99 + 1    
      ENDIF

      IF(IhaveNoProfile.eq.100) THEN	!! POLAN profile has negative values
      creason = ".POLAN neg vals ."
      num_IhaveNoProfile100 = num_IhaveNoProfile100 + 1    
      ENDIF

      DO i = 1,17
         chits(i) = creason(i:i)	!! reason why no good 
      ENDDO
      DO i = 18,20
         chits(i)=blank
      ENDDO 

c----- Write out the two EDP2 header lines only

      write(idb,1320) IhaveNoProfile,creason
1320  format(" Calling makeGAIMfile, headers only",i4,2x,a17)

      print*,"CHITS", chits 

      call makeGAIMfile
     a(version,igaim,IhaveNoProfile,devf_pol1,devh_pol1,chits,numprob,
     a statID,statlat,statlon,cyear4,cdayno,chour,cmin,csec,iaafcon,
     a idfi,scaled,ftoE,ftof1,ftof,the,thval,thf1,thf2,
     a fof2_pol,hmf2_pol,shf2_pol,fnpol,realpol,freq_int,slope_end,
     a fnpro_art,fnpro_pol,fnpro_gmf,fn_error_bar,polan_fn_errorbars,
     a IwantGAIMalts)

c---- Go back for next ionogram, or from whence you came

      if(IhaveNoProfile.eq.90) go to 15	!! ICHECK = 1 No foF2 or Cheby Coeffs supplied
      if(IhaveNoProfile.eq.91) go to 15	!! ICHECK = 2 Trace too short to process
      if(IhaveNoProfile.eq.92) go to 15	!! ICHECK = 27 Virtual heights not set (=9999 or 0)
      if(IhaveNoProfile.eq.93) go to 15	!! ICHECK = 30 Chopped-off trace too short
      if(IhaveNoProfile.eq.94) go to 15	!! ICHECK = 11,IpoorFitF2 = 6 Chopped-off trace too short
      if(IhaveNoProfile.eq.99) go to 15	!! ICHECK = 40 Trace is probably all ES

      if(IhaveNoProfile.eq.95) go to 7503
      if(IhaveNoProfile.eq.96) go to 7503
      if(IhaveNoProfile.eq.97) go to 7503

      IF(IhaveNoProfile.eq.98) go to 7504

      ENDIF	!! IhaveNoProfile.ge.90

      ENDIF	!! IwantGAIMfile

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      go to 15 !! back for new ionogram
cc      ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

16      continue    !! arrive here if EOF  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Calculate the RMS fractional discrepancy between ARTIST and smoothed M3

      rms_em3000 = 0.
      if(num_rms_em3.ge.100) THEN
      rms_em3000 = sqrt(rms_em3/float(num_rms_em3)) * 100.
      write(iusefuls,444) rms_em3000,num_rms_em3
444   format(//"M(3000)F2 % RMS discrepancy",f8.2,i8)
      ENDIF

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Write out the F2 amplitude FOM flags (for three thirds of trace)
      write(ioutput,7501) iampflag1,iampflag2,iampflag3,iampflag4
      write(iusefuls,7501) iampflag1,iampflag2,iampflag3,iampflag4
7501  format(//"# Amplitude flags based on non-zero amplitude counts",
     a 10i5)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Assign quality figure to each ionogram (written out to NGDCqual)

      write(idb,1326)
1326  format(" Entering NGDC_quality_figures")
      call NGDC_quality_figures
     a (NGDCfile,NGDCqual,kall_POLAN,iPOLANok,
     a statid,cyear4,cdayno,chour,cmin,ctemp,iononumber,numprob,
     a statlon,
     a kprob1,kprob2,kprob3,kprob4,kprob5,kprob6,kprob7,
     a kprob8,kprob9,kprob10,kprob11,kprob12,kprob13,
     a kprob14,kprob15,kprob16,kprob17,kprob18)

c-----END of assigning quality figure

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Write out the array of failed checks
      write(iflagfile,7029)
7029  format(/" Failed counts and percentages for each check"/)
      fkk = kount
      perc = 0.
      DO i = 1,numcheck
      if(kount.ne.0)perc = float(kount_of_checks(i))/fkk*100.
      if(perc.ne.0.) write(iflagfile,7030) i,kount_of_checks(i),perc
      ENDDO 
7030  format(2i5,f10.1)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c-----write the Problem key to processed data file
c      write(ioutput,7651)
7651  format(//20x,"Problem Descriptions",/
     a "1  The Amplitude Quality Figure is too small",/
     a "2  M(3000)F2 comes from the end of the F2 trace",/
     a "3  Real ht too close to hdash at start of F2",/,
     a "4  Too large a diff of POLAN and ARTIST hmF2",/
     a "5  Too long a horizontal section in F2 trace (ES?)",/
     a "6  Smoothed F2 trace is not good or not valid",/
     a "7  Too many sudden jumps in F2 trace",/
     a "8  Large errors in POLAN peak fit",/
     a "9  ARTIST value of hmF2 too low",/
     a "A  (10) Could not fit good or any LSF curve through F1 trace"/
     a "B  (11) Average slope decreasing in last half of trace"/
     a "C  (12) Too long a gap in trace above foE"/
     a "D  (13) There is a corner in the F2 trace"/
     a "E  (14) foF2 is very near a prohibited frequency",/
     a "F  (15) Slope of F2 trace is too low at end",/
     a "G  (16) fmin too high to get reliable profile",/
     a "H  (17) too few points with non-zero amplitudes")
c
      WRITE(iflagfile,101) KOUNT,kasenum
      WRITE(ioutput,101) KOUNT,kasenum
 101  FORMAT (//' There were ',i4,' Ionograms,', i5,
     a ' of which had Problems')
c
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      write(iflagfile,776) (k,k=1,numprob)
776   format(//' The ionograms for which PROBLEMS occurred'//,
     a      ' Problems:',5x,18i2/)
c
      DO i = 1,kasenum
      write(iflagfile,778) iyear,kday(i),khour(i),kmin(i),
     a      (khit(k,i),k=1,numprob)
      ENDDO
778   format(i4,i3,2i2,3x,18(1x,a1),2x,f5.1,2f5.0)

c
      write(iflagfile,1779) kprob1,kprob2,kprob3,kprob4,kprob5,
     a kprob6,kprob7,kprob8,kprob9,kprob10,kprob11,kprob12,kprob13,
     a kprob14,kprob15,kprob16,kprob17,kprob18

      write(ioutput,1779) kprob1,kprob2,kprob3,kprob4,kprob5,
     a kprob6,kprob7,kprob8,kprob9,kprob10,kprob11,kprob12,kprob13,
     a kprob14,kprob15,kprob16,kprob17,kprob18

1779  format(
     a /' Problem 1 ',i8,' The Amplitude Quality Figure is too small',
     a /' Problem 2 ',i8,' M(3000)F2 comes from end of the F2 trace',
     a /' Problem 3 ',i8,' Real ht too close to hdash at start of F2',
     a /' Problem 4 ',i8,' Too large a diff of POLAN and ARTIST hmF2',
     a /' Problem 5 ',i8,' Too long a horizontal section in F2 trace',
     a /' Problem 6 ',i8,' Smoothed F2 trace is not good or not valid',
     a /' Problem 7 ',i8,' Too many sudden jumps in F2 trace',
     a /' Problem 8 ',i8,' Large errors in POLAN peak fit',
     a /' Problem 9 ',i8,' ARTIST value of hmF2 too low',
     a /' Problem 10 [A]',i4,' Could not fit LSF through F1 trace',
     a /' Problem 11 [B]',i4,' Aver slope decreases last half of trace',
     a /' Problem 12 [C]',i4,' Too long a gap in trace above foE',
     a /' Problem 13 [D]',i4,' There is a corner in the F2 trace',
     a /' Problem 14 [E]',i4,' foF2 is very near prohibited frequency',
     a /' Problem 15 [F]',i4,' Slope of F2 trace is too low at end',
     a /' Problem 16 [G]',i4,' fmin too high to get reliable profile',
     a /' Problem 17 [H]',i4,' too few points with non-zero amplitudes',
     a /' Problem 18 [I]',i4,' foF2 too close to model value of foF1',
     a //' Note that some ionograms had multiple problems')

      write(ioutput,4333) iononumber,num_trace_too_short,
     a num_fmin_too_high,num_smoothed_no_good,num_ht_9999,
     a num_no_good_value_fof2,num_call_to_POLAN,num_no_call_POLAN,
     a num_POLAN_had_sqrt_errors,num_POLAN_equal_heights,num_no_O_data,
     a num_ARTIST_no_confidence,
     a num_POLAN_gave_no_points,
     a num_no_good_value_hseclast,
     a num_ionograms_QCd

4333  format(/5x,"Total # of ionograms read  ",i5,
     a /5x,      "# with trace too short     ",i5,
     a /5x,      "# with fmin too high       ",i5
     a /5x,      "# with bad smoothed F2 fit ",i5,
     a /5x,      "# with 9999 virtual ht     ",i5,
     a /5x,      "# with foF2 no good        ",i5,
     a /5x,      "# with calls to POLAN      ",i5,
     a /5x,      "# with no calls to POLAN   ",i5,
     a /5x,      "# with SQRT err in POLAN   ",i5,
     a /5x,      "# with POLAN equal heights ",i5,
     a /5x,      "# with no O data in POLAN  ",i5,
     a /5x,      "# with no ART confidence   ",i5,
     a /5x,      "# with no POLAN profile pts",i5,
     a /5x,      "# with h'F2 all too low    ",i5,
     a /5x,      "# of ionograms checked     ",i5)


c---- Write out the # ionograms with no GAIM EDP2 profiles

      write(ioutput,7505) num_IhaveNoProfile90,num_IhaveNoProfile91,
     a num_IhaveNoProfile92,num_IhaveNoProfile93,num_IhaveNoProfile94,
     a num_IhaveNoProfile95,num_IhaveNoProfile96,num_IhaveNoProfile97,
     a num_IhaveNoProfile98,num_IhaveNoProfile99,num_IhaveNoProfile100
7505  format(//5x," Counts for ionograms with no GAIM profiles",/
     a 5x,".Check  1 failed.",i5,/
     a 5x,".Check  2 failed.",i5,/
     a 5x,".Check 27 failed.",i5,/
     a 5x,".30 Trace 2 short",i5,/
     a 5x,".11 Trace 2 short",i5,/
     a 5x,".Prob  6 failed. ",i5,/
     a 5x,".Prob 10 failed. ",i5,/
     a 5x,".Prob 12 failed. ",i5,/
     a 5x,".POLprof not mono",i5,/
     a 5x,".Low F2 virt hts ",i5,/
     a 5x,".POLAN prof neg  ",i5)

      write(iusefuls,7505) num_IhaveNoProfile90,num_IhaveNoProfile91,
     a num_IhaveNoProfile92,num_IhaveNoProfile93,num_IhaveNoProfile94,
     a num_IhaveNoProfile95,num_IhaveNoProfile96,num_IhaveNoProfile97,
     a num_IhaveNoProfile98,num_IhaveNoProfile99,num_IhaveNoProfile100

c----- Write out LT variation of ARTIST confidence levels
      if(IhaveArtist5.gt.0) THEN
      write(iusefuls,7300)
7300  format(//" ARTIST 5 confidence levels vs LT")
      DO ih = 1,24
      write(iusefuls,7301) ih-1,(kartcon(j,ih),j = 1,5)
7301  format(6i6)
      ENDDO
c----- Write out LT variation of % ARTIST 5 confidence levels
      write(ioutput,7300)
      DO ih = 1,24
      summ = 0.
      DO i = 1,5
      summ = summ + kartcon(i,ih)
      ENDDO
      DO i = 1,5
      artcon(i) = 0.
      if(summ.gt.0.) artcon(i) = float(kartcon(i,ih)) / summ * 100.
      ENDDO
      write(ioutput,7302) ih-1,(artcon(j),j = 1,5)
7302  format(i5,5f6.1)
      ENDDO	!! ih
      ENDIF	!! IhaveArtist5.gt.0

c----- Write a record of the settings for this run

      write(ioutput,6001)
     a aqf_min,      	!!	If AQF is less than this %, get PROBLEM = 1
     a delay_min,     !!      min allowed diff between first ARTIST F2 real & virt hts
     a diff_dip,      !!      dip angle ICHECK = 3
     a diff_gyro,     !!      gyro freq ICHECK = 4
     a diff_foe,      	!!	foE   ICHECK = 5
     a diff_fof1,     !!      foF1  ICHECK = 7
     a diff_fof2,     !!      foF2  ICHECK = 19
     a diff_hme,      !!      hmE	  ICHECK = 6
     a diff_hmf2_DUD, !!      Max diff between Dudeney & ARTIST hmf2 ICHECK = 15
     a diff_hmf2_POL, !!      Max diff between POLAN & ARTIST hmf2 ICHECK = 20	
     a diffforbfreq,  !!  check for foF2 close to a prohibited freq PROB 14
     a diffitmax,      	!!  Max allowable error in Cheby LSF for F2
     a eps,      		!!  Accuracy figure for Cheby LSF
     a eta,      		!!  Accuracy figure for Cheby LSF
     a fr_max_flat,      !!	max MHz length of flat section PROBLEM 5
     a fmin_ratio,    !!  Require that fmin/foF2 < fmin_ratio      CHECK = 38
     a gapmax,      	!!  allowable freq gap after foE or foF1 PROBLEM 12
     a hmf2_min,      	!!	Assume hmF2 cannot be below this value. PROBLEM 9
     a hseclastmin,      !!  Second last F2 virtual height must exceed this value (Check 40)
     a float(max_same_slope),      !!  CHECK 31 - max # of points in F2 trace with same slope
     a float(nchebF1),      	!! default order of Cheby LSF for F1 (could be decreased)
     a float(nchebF2),      	!! default order of Cheby LSF for F2 (could be decreased)
     a float(nslope),      		!!  Aver F2 slope over last NSLOPE points = slope_end_min
     a percslope_min, !!  If % slope of F2 trace, CHECK 11, IsStraightLine = 1
     a prof_min_error,!! min allowed error in GAIM fn      !! new 13-january-2--8
     a rms_fac,       !!      Factor for RMS diff of scaled & fitted h' PROBLEM 6
     a rms_F1,        !!      Allowable error in LSF for F1 trace	 PROBLEM 10
     a sigf_pol,      	!!	Allowable errors in POLAN foF2	PROBLEM = 8
     a sigh_pol,      	!!	Allowable errors in POLAN hmF2	PROBLEM = 8
     a sigsh_pol,      	!!	Allowable errors in POLAN shF2	PROBLEM = 8
     a slope_end_min,      !!  min aver slope of last NSLOPE points (must > h' noise) PROBLEM 15
     a slopechange,   !!  change in slope that defines a corner PROBLEM 13
     a spline_ht_gap,      !! max allowed E-F height gap (else no spline interpolation)
     a tan_freq_min,      !!  tangent freq must exceed tan_freq_min * foF2 Check 16
     a too_high_slope,!!  max value for delta h' Following smoothed points are lopped
     a trace_len_min,!!  trace must be at least this long ICHECK = 2 & others
     a start_uncert,      !!  starting height is uncertain to +/- this percentage
     a valley_uncert,      !!  valley width is uncertain to +/- this percentage
     a virtht_max      	!!  maximum value of F2 virtual height (trace chopped)

6001      format(/" Allowable Errors and Restrictions",/10f8.1,
     a /10f8.1,/10f8.1,/10f8.1)

      write(ioutput,6002)
     a IwantUSEFULS,
     a IwantPlotFiles,
     a IwantOblique,
     a IwantProfiles,
     a IwantXtrace
6002  format(/" Control (Iwant....) parameters",10i3)

      call DATE_AND_TIME(cdate, ctime2, czone, ivalues)
      write(ioutput,6668) ctime1,ctime2,iononumber
6668  format(/" Start & Finish times (hhmmss.sss) & # of Ionograms",
     a 2a12,i5)

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c----- Fatal errors (replaces Fortran STOP)

6666  continue

      if(istop_error.ne.0) THEN

      open (unit=logfile,file="fortran_stop.dat")		  	!!  52

      if(istop_error.eq.1) THEN
      write(logfile,6667) cyear4,cdayno,chour,cmin
6667  format(1x,a4,1x,a3,1x,2a2," Could not find the URSI 5-char code")
      ENDIF	!! istop_error = 1

      if(istop_error.eq.2) THEN
      write(logfile,6672) cyear4,cdayno,chour,cmin
6672  format(1x,a4,1x,a3,1x,2a2," QualScan does not work for ARTIST 3",
     a /5x," There are probably asterisks in the SAO file")
      ENDIF	!! istop_error = 2

      if(istop_error.eq.3) THEN
      write(logfile,6669) cyear4,cdayno,chour,cmin
6669  format(1x,a4,1x,a3,1x,2a2," No flux data for year/month")
      ENDIF	!! istop_error = 3

      if(istop_error.eq.4) THEN	!! 14jan05
      write(logfile,6673) cyear4,cdayno,chour,cmin,maxkases
6673  format(" Too many ionograms - max allowed is",i5)
      ENDIF	!! istop_error = 4

      ENDIF	!! istop_error.ne.0

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      END
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

